/* edittext.c

   Demonstrates edittext fields.
   
   Part of the swftools package.

   Copyright (c) 2000, 2001 Matthias Kramm <kramm@quiss.org>
 
   This file is distributed under the GPL, see file COPYING for details 
*/

#include <stdio.h>
#include <fcntl.h>
#include <math.h>
#include "../rfxswf.h"

TAG* tag;

/* defined below: */
extern char * longtext;		       
extern SWFFONT * Font_Courier(U16 id);

/* Notice: It seems Flash Players 5 and below always use their
   built-in font for edittext, even if some other font is given */

int main (int argc,char ** argv)
{ SWF swf;
  RGBA rgb;
  SRECT r;
  MATRIX m;
  EditTextLayout layout;
  SWFFONT*font;
  S32 width=640,height = 480;
  int f;
  int t;
  
  memset(&swf,0x00,sizeof(SWF));

  swf.fileVersion    = 5;
  swf.frameRate      = 0x1900;
  
  swf.movieSize.xmax = 20*width;
  swf.movieSize.ymax = 20*height;

  swf.firstTag = swf_InsertTag(NULL,ST_SETBACKGROUNDCOLOR);
  tag = swf.firstTag;
  rgb.r = 0xff;
  rgb.g = 0xff;
  rgb.b = 0xff;
  swf_SetRGB(tag,&rgb);

  swf_GetMatrix(0, &m);

  tag = swf_InsertTag(tag,ST_DEFINEFONT2);
      //font = Font_Dingbats(76);
      font = Font_Courier(76);
      swf_FontSetDefine2(tag, font);

  /* draw 4 edittext fields */
  for(t=0;t<4;t++)
  {
      tag = swf_InsertTag(tag,ST_DEFINEEDITTEXT);
	  layout.align = 0;
	  layout.leftmargin = 0;
	  layout.rightmargin = 0;
	  layout.indent = 0;
	  layout.leading = 0;

	  swf_SetU16(tag, t+1);//id
	  r.xmin = 0;
	  r.ymin = 0;
	  r.xmax = width*20/2;
	  r.ymax = height*20/2;
	  rgb.r = rgb.g = rgb.b = 0; rgb.a = 255;

	  m.tx = (t&1)*width*20/2;
	  m.ty = (t&2)/2*height*20/2;

	  if(t==0) {
	      /* this is the standard edit field, upper left corner */
	      swf_SetEditText(tag, ET_MULTILINE|ET_BORDER, r, 
		      "everything you\ntype in the\nleft box\nalso appears\nin the right\nbox", 
		      &rgb, 0, /*font id*/76, 30*20, &layout, "/:variable1");
	  } if (t==1) {
	      /* this field (upper right corner) mirrors the first field, without being editable */
	      swf_SetEditText(tag, ET_NOSELECT|ET_MULTILINE|ET_BORDER|ET_READONLY, r, 0, &rgb, 0, 
		      /*font id*/76, 20*20, &layout, "/:variable1");
	  } if (t==2) {
	      /* another edit field, in brown (lower left corner) */
	      rgb.r = 80;
	      rgb.g = 80;
	      swf_SetEditText(tag, ET_WORDWRAP|ET_MULTILINE|ET_BORDER, r, longtext, &rgb, 0, 
		      /*font id*/76, 10*20, &layout, "/:variable2");
	  } if (t==3) {
	      m.ty += 40*20;
	      /* password edit field , lower right corner*/
	      swf_SetEditText(tag, ET_PASSWORD, r, 0, &rgb, 0, 
		      /*font id*/76, 24*20, &layout, "/:variable3");
	  }

      tag = swf_InsertTag(tag,ST_PLACEOBJECT2);
      swf_ObjectPlace(tag, t+1, t, &m, 0, 0);
  }
  

  tag = swf_InsertTag(tag,ST_DEFINETEXT);
    swf_SetU16(tag, 33); //id
    swf_SetDefineText(tag, font, &rgb, "Password:", 20);
   
  tag = swf_InsertTag(tag,ST_PLACEOBJECT2);
  m.tx = width/2*20;
  m.ty = (height/2+40)*20;
  swf_ObjectPlace(tag, 33, t, &m, 0, 0);

  tag = swf_InsertTag(tag,ST_SHOWFRAME);
  tag = swf_InsertTag(tag,ST_END);

  f = open("edittext.swf",O_WRONLY|O_CREAT|O_TRUNC, 0644);
  if FAILED(swf_WriteSWF(f,&swf)) fprintf(stderr,"WriteSWF() failed.\n");
  close(f);

  swf_FreeTags(&swf);                       // cleanup
  return 0;
}

/* from "Hitchhikers Guide" by Douglas Adams */

char*longtext=
"Another thing that got forgotten was the fact  that  against  all\n"
"probability a sperm whale had suddenly been called into existence\n"
"several miles above the surface of an alien planet.\n"
"\n"
"And since this is not a naturally tenable position for  a  whale,\n"
"this poor innocent creature had very little time to come to terms\n"
"with its identity as a whale before it then had to come to  terms\n"
"with not being a whale any more.\n"
"\n"
"This is a complete record of its  thoughts  from  the  moment  it\n"
"began its life till the moment it ended it.\n"
"\n"
"Ah ... ! What's happening? it thought.\n"
"\n"
"Er, excuse me, who am I?\n"
"\n"
"Hello?\n"
"Why am I here? What's my purpose in life?\n"
"\n"
"What do I mean by who am I?\n"
"\n"
"Calm down, get  a  grip  now  ...  oh!  this  is  an  interesting\n"
"sensation,  what  is  it?  It's  a  sort of ... yawning, tingling\n"
"sensation in my ... my  ...  well  I  suppose  I'd  better  start\n"
"finding  names  for  things if I want to make any headway in what\n"
"for the sake of what I shall call an argument I  shall  call  the\n"
"world, so let's call it my stomach.\n"
"\n"
"Good. Ooooh, it's getting quite strong.  And  hey,  what's  about\n"
"this  whistling  roaring sound going past what I'm suddenly going\n"
"to call my head? Perhaps I can call that ... wind! Is that a good\n"
"name?  It'll do ... perhaps I can find a better name for it later\n"
"when I've found out what it's for.  It  must  be  something  very\n"
"important  because there certainly seems to be a hell of a lot of\n"
"it. Hey! What's this thing? This ... let's call it a tail - yeah,\n"
"tail.  Hey! I can can really thrash it about pretty good can't I?\n"
"Wow! Wow! That feels great! Doesn't seem to achieve very much but\n"
"I'll probably find out what it's for later on. Now - have I built\n"
"up any coherent picture of things yet?\n"
"\n"
"No. Never mind, hey, this is really exciting, so  much  to  find  out\n"
"about,  so  much  to  look  forward  to,  I'm  quite  dizzy  with\n"
"anticipation ...     Or is it the wind?\n"
"\n"
"There really is a lot of that now isn't it?\n"
"\n"
"And wow! Hey! What's this thing suddenly coming towards  me  very\n"
"fast?  Very  very fast. So big and flat and round, it needs a big\n"
"wide sounding name like ... ow ... ound  ...  round  ...  ground!\n"
"That's it! That's a good name - ground!\n"
"\n"
"I wonder if it will be friends with me?\n"
"\n"
"And the rest, after a sudden wet thud, was silence.\n"
"\n"
"Curiously enough, the only thing that went through  the  mind  of\n"
"the bowl of petunias as it fell was Oh no, not again. Many people\n"
"have speculated that if we knew exactly why the bowl of  petunias\n"
"had thought that we would know a lot more about the nature of the\n"
"universe than we do now.\n";

/* the following data was created using makefonts and dumpfont. The command line calls were:
   ./makefonts all
   ./dumpfont Courier.swf >> edittext.c */

#define addGlyph fn5b6e

void fn5b6e(SWFFONT * f,int i,U16 ascii,U16 advance,U8 * data,U32 bitlen,int xmin,int ymin,int xmax, int ymax)
{ SHAPE * s;
  U32 l = (bitlen+7)/8;

  if (FAILED(swf_ShapeNew(&s))) return;
  s->data = malloc(l);
  if (!s->data) { swf_ShapeFree(s); return; }

  f->glyph2ascii[i]     = ascii;
  f->ascii2glyph[ascii] = i;
  f->glyph[i].advance   = advance;
  f->glyph[i].shape     = s;
  s->bitlen             = bitlen;
  s->bits.fill          = 1;
  if(f->layout && f->layout->bounds)
  {  f->layout->bounds[i].xmin = xmin;
     f->layout->bounds[i].ymin = ymin;
     f->layout->bounds[i].xmax = xmax;
     f->layout->bounds[i].ymax = ymax;
  }
  memcpy(s->data,data,l);
}

U8 Glyphs_Courier[] = {
	  0x0a, 0x0b, 0x0a, 0x92, 0xe6, 0xa0, 0x22, 0x90, 
	  0x2a, 0xc0, 0xe6, 0x6f, 0xab, 0x8b, 0x8f, 0xa9, 
	  0xad, 0x41, 0xbe, 0xd2, 0x24, 0xfc, 0xc0, 0xd4, 
	  0xe6, 0x09, 0x14, 0x64, 0xa0, 0x9c, 0xa6, 0xff, 
	  0x2a, 0x80, 0x40, 0xa3, 0x73, 0x04, 0x95, 0xd0, 
	  0x15, 0xa4, 0xae, 0xad, 0x34, 0xf0, 0x47, 0xc2, 
	  0xe4, 0xc1, 0x0b, 0x8c, 0x41, 0x1a, 0x5a, 0x02, 
	  0x66, 0x3f, 0x80, 0x9a, 0x49, 0xbd, 0xe9, 0x27, 
	  0x7e, 0x34, 0xcc, 0x00, 0x00, 0x0a, 0x0b, 0x04, 
	  0x92, 0xd2, 0x38, 0x88, 0x8f, 0xd4, 0xc0, 0xe9, 
	  0x46, 0xbf, 0xd3, 0x1a, 0x01, 0x04, 0x5b, 0x71, 
	  0x11, 0x20, 0x6d, 0xf0, 0x00, 0x00, 0x2c, 0x28, 
	  0xcb, 0x48, 0xe2, 0x22, 0x3f, 0x53, 0x03, 0xa5, 
	  0x1a, 0xff, 0x4c, 0x68, 0x04, 0x11, 0x6d, 0xc4, 
	  0x44, 0x81, 0xb7, 0xc0, 0x00, 0x00, 0x00, 0x0a, 
	  0x0a, 0xd8, 0x65, 0x30, 0xde, 0xb6, 0x00, 0x4a, 
	  0xd4, 0x08, 0x1b, 0x10, 0x18, 0x4a, 0x02, 0xcc, 
	  0xaf, 0xfb, 0xe9, 0xc0, 0x0e, 0x21, 0x04, 0x95, 
	  0x08, 0xa2, 0xcb, 0xfe, 0x8d, 0x9f, 0xb2, 0xda, 
	  0x01, 0xf9, 0x97, 0x1f, 0x81, 0xbc, 0xdf, 0x4a, 
	  0x00, 0x71, 0x07, 0xa4, 0xac, 0xe2, 0x94, 0x06, 
	  0x52, 0xfb, 0xbb, 0x77, 0xe4, 0xb6, 0x40, 0x7d, 
	  0x65, 0xc7, 0xe0, 0x6f, 0x37, 0xd7, 0x80, 0x12, 
	  0xca, 0x02, 0x01, 0x3c, 0xa0, 0x14, 0xb6, 0xff, 
	  0xbd, 0x38, 0x00, 0xe3, 0xf7, 0x20, 0x9b, 0xe9, 
	  0xc0, 0x09, 0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 
	  0x5b, 0x7f, 0xde, 0xae, 0x00, 0x71, 0xf8, 0x1b, 
	  0xed, 0x20, 0x21, 0x28, 0x34, 0xe9, 0x41, 0xca, 
	  0x94, 0x08, 0x59, 0x7c, 0x41, 0xe8, 0xf3, 0x7a, 
	  0xd8, 0x01, 0xc7, 0xe2, 0x6f, 0xb4, 0xfc, 0x84, 
	  0x1a, 0x32, 0x85, 0x44, 0x90, 0x34, 0xa9, 0xc0, 
	  0x83, 0x97, 0xc4, 0x20, 0x8f, 0x37, 0xa9, 0x80, 
	  0x12, 0xb5, 0x02, 0x06, 0xc4, 0x00, 0x72, 0x80, 
	  0xb3, 0x2b, 0xfe, 0xfb, 0x00, 0x03, 0x88, 0x25, 
	  0x7e, 0x02, 0xb5, 0x75, 0x4c, 0x38, 0xfd, 0xc8, 
	  0x26, 0xfa, 0x50, 0x03, 0x88, 0x25, 0x7e, 0x6f, 
	  0x5b, 0x00, 0x00, 0x0a, 0x0b, 0x08, 0xc2, 0xdf, 
	  0x28, 0xbd, 0x83, 0x2f, 0xc8, 0xec, 0x9b, 0xfd, 
	  0xe5, 0x5d, 0x0e, 0x71, 0xf0, 0xb1, 0x60, 0x20, 
	  0x9d, 0x3a, 0x1d, 0x13, 0x06, 0x63, 0x41, 0x12, 
	  0x49, 0x93, 0x8c, 0x41, 0x97, 0x68, 0xfa, 0x0c, 
	  0xeb, 0xa8, 0x10, 0x9e, 0x05, 0xee, 0xea, 0x5b, 
	  0x25, 0xf9, 0x32, 0xe0, 0x29, 0x6b, 0x80, 0x02, 
	  0xdb, 0x78, 0x01, 0x49, 0x2f, 0xf6, 0x2a, 0x7e, 
	  0x4a, 0x9c, 0x20, 0x19, 0xfa, 0xc0, 0x5a, 0x99, 
	  0x05, 0x09, 0xd0, 0x6e, 0x55, 0x02, 0x93, 0x82, 
	  0xde, 0x00, 0x76, 0xcb, 0xfd, 0xb2, 0x90, 0x12, 
	  0xa7, 0x00, 0x06, 0x56, 0xf0, 0x04, 0x72, 0x85, 
	  0x0f, 0xd0, 0x04, 0x70, 0x49, 0xff, 0x57, 0xbc, 
	  0xf6, 0xf6, 0x0b, 0xb9, 0xf8, 0x7d, 0x2a, 0x1f, 
	  0x7a, 0x7b, 0x17, 0x97, 0xb1, 0xe1, 0x9b, 0x03, 
	  0x54, 0x02, 0xb6, 0x70, 0x8d, 0x05, 0xc3, 0xeb, 
	  0x9d, 0xa0, 0x0f, 0x14, 0x1e, 0xe5, 0x08, 0xb9, 
	  0x37, 0xe9, 0x53, 0x80, 0x03, 0x2b, 0x68, 0x04, 
	  0x44, 0xa0, 0x66, 0xd7, 0x07, 0x2d, 0x9f, 0xdf, 
	  0x5b, 0x4b, 0x67, 0x15, 0xed, 0xd3, 0x64, 0x71, 
	  0xd7, 0xfc, 0xed, 0x00, 0x98, 0x97, 0xfc, 0x5b, 
	  0x3e, 0xe5, 0xae, 0x00, 0x0b, 0x6d, 0xa0, 0x0d, 
	  0xc0, 0x00, 0x0a, 0x0a, 0xd6, 0x96, 0x20, 0x9e, 
	  0x44, 0x1a, 0xf6, 0x39, 0xa7, 0x0a, 0x38, 0x5c, 
	  0x01, 0x69, 0xdb, 0x3e, 0x90, 0x9c, 0x92, 0x7f, 
	  0x84, 0x52, 0x45, 0xe8, 0xc2, 0x00, 0xad, 0x69, 
	  0x67, 0x09, 0xd2, 0xe1, 0x00, 0x3a, 0x8a, 0x7f, 
	  0xba, 0x62, 0xda, 0x0e, 0x9e, 0xcf, 0xf3, 0xfa, 
	  0xd9, 0x67, 0x06, 0x58, 0x12, 0xdf, 0x0c, 0x20, 
	  0x0b, 0x07, 0x6a, 0xcf, 0x27, 0x8e, 0x05, 0x7c, 
	  0xce, 0x19, 0xc3, 0x4e, 0x57, 0x30, 0x66, 0x76, 
	  0xef, 0x9c, 0x2f, 0x1d, 0x9f, 0xd9, 0x1b, 0x8f, 
	  0x7b, 0x70, 0x80, 0x2c, 0x1d, 0xab, 0x8c, 0x9d, 
	  0x36, 0x0b, 0x05, 0xa7, 0x67, 0xf8, 0xa6, 0xed, 
	  0x61, 0x19, 0xec, 0x3f, 0x0f, 0x7d, 0x8a, 0x70, 
	  0x95, 0x9d, 0x39, 0xf3, 0xc2, 0x00, 0xad, 0xef, 
	  0x55, 0x09, 0x52, 0xf8, 0xff, 0xa2, 0x5f, 0x97, 
	  0x31, 0x7a, 0x8f, 0x20, 0xa8, 0xa3, 0xa0, 0x74, 
	  0x1e, 0x74, 0x58, 0x79, 0x4b, 0x68, 0x58, 0x23, 
	  0xb2, 0x06, 0xeb, 0x42, 0xc2, 0x83, 0x11, 0x90, 
	  0x0e, 0xd7, 0x35, 0xf9, 0xc4, 0x00, 0x0a, 0x0a, 
	  0xd8, 0x90, 0x00, 0xda, 0xe8, 0x01, 0x2b, 0x50, 
	  0x00, 0x6c, 0xc0, 0x07, 0x28, 0x0b, 0x32, 0xbf, 
	  0xed, 0xb4, 0x00, 0xdb, 0x95, 0x59, 0x38, 0xfb, 
	  0x48, 0x2c, 0xae, 0x69, 0x60, 0x09, 0x5a, 0x81, 
	  0x03, 0x62, 0x00, 0x39, 0x40, 0x59, 0x95, 0xff, 
	  0x6d, 0x50, 0x04, 0xfe, 0x14, 0x97, 0x0c, 0xe1, 
	  0xc7, 0x22, 0xa7, 0xa7, 0xd2, 0xdc, 0x41, 0x3c, 
	  0x79, 0xc1, 0xd6, 0xf4, 0x87, 0xb6, 0x55, 0xa0, 
	  0x53, 0x99, 0x91, 0x53, 0x15, 0x4b, 0x6a, 0x07, 
	  0x04, 0xa8, 0xb6, 0x7e, 0xcd, 0x2f, 0xcb, 0x97, 
	  0xbe, 0x49, 0x98, 0x36, 0x93, 0xa6, 0xc3, 0x25, 
	  0xbb, 0xb3, 0x0f, 0x69, 0x70, 0x76, 0xbc, 0x02, 
	  0x79, 0x20, 0x5f, 0xdc, 0xd9, 0x9f, 0xd4, 0x2f, 
	  0x39, 0x2c, 0xe7, 0x97, 0x12, 0x7f, 0xcd, 0x9a, 
	  0x01, 0x74, 0x75, 0x01, 0x07, 0xe7, 0x44, 0x00, 
	  0x0b, 0x18, 0x0d, 0xa7, 0xcc, 0x00, 0xad, 0x52, 
	  0x75, 0x49, 0xae, 0x9e, 0x65, 0x00, 0xe7, 0xa5, 
	  0x7a, 0x7e, 0x12, 0xb9, 0xc0, 0x75, 0x35, 0x1f, 
	  0x4f, 0x89, 0xa4, 0xa5, 0x00, 0x0a, 0x0b, 0x06, 
	  0x7a, 0xd2, 0x38, 0xee, 0x8f, 0xa4, 0x7c, 0x58, 
	  0x17, 0x28, 0x56, 0xad, 0x42, 0xc8, 0xd0, 0x49, 
	  0xcf, 0x21, 0x1b, 0x13, 0x7f, 0x32, 0x45, 0x7b, 
	  0xb8, 0xde, 0xc0, 0x00, 0x00, 0x0a, 0x0b, 0x0d, 
	  0xb2, 0xd2, 0x22, 0x90, 0x93, 0x97, 0x70, 0x6b, 
	  0x8e, 0xe8, 0xc8, 0xd5, 0x6f, 0xe5, 0x38, 0xa0, 
	  0x03, 0x4c, 0x4c, 0xf5, 0x3e, 0x63, 0xa6, 0x01, 
	  0x6f, 0xd8, 0x51, 0x42, 0x54, 0xbf, 0x02, 0xdc, 
	  0x8c, 0x16, 0xd5, 0x28, 0xcb, 0xe9, 0xaf, 0xfe, 
	  0xcc, 0xa0, 0x01, 0xb2, 0x8d, 0x1a, 0x72, 0x33, 
	  0x50, 0x16, 0x97, 0xe5, 0xcb, 0x9f, 0x30, 0x80, 
	  0x00, 0x0a, 0x0b, 0x05, 0x42, 0xd2, 0x25, 0xb4, 
	  0x13, 0xe2, 0x48, 0xc0, 0xa3, 0x32, 0x83, 0x35, 
	  0x67, 0xfe, 0xd3, 0x3a, 0x00, 0x34, 0xdf, 0x35, 
	  0x58, 0xe3, 0xd3, 0x00, 0xa9, 0x41, 0xa4, 0x4a, 
	  0x12, 0x26, 0x07, 0xd9, 0x49, 0x7a, 0x4b, 0x16, 
	  0x83, 0x5e, 0xaa, 0x00, 0xec, 0x8a, 0x00, 0x2b, 
	  0x3b, 0x36, 0xac, 0xa6, 0xc5, 0x9e, 0xea, 0x05, 
	  0x83, 0xe3, 0x08, 0x00, 0x0a, 0x0a, 0xd1, 0x84, 
	  0x94, 0xe3, 0x7a, 0x75, 0x91, 0xcb, 0x9a, 0xfc, 
	  0x37, 0xd1, 0x2d, 0xb0, 0x9f, 0x52, 0x4a, 0x11, 
	  0x11, 0xc0, 0xd9, 0xd0, 0x2e, 0x28, 0x50, 0xa9, 
	  0xbe, 0xbc, 0xe0, 0x92, 0xd6, 0x43, 0x26, 0x50, 
	  0x69, 0xd2, 0x83, 0x8d, 0x61, 0x56, 0x63, 0x4e, 
	  0x59, 0x1d, 0xea, 0x29, 0x06, 0xf5, 0x23, 0x82, 
	  0x42, 0xd1, 0x24, 0x68, 0xd0, 0x66, 0x7e, 0x54, 
	  0x9f, 0x42, 0x5b, 0x93, 0xfc, 0x73, 0xaf, 0x7d, 
	  0x7a, 0x41, 0xc5, 0x0a, 0xeb, 0x25, 0x57, 0xcf, 
	  0xfe, 0x19, 0x7e, 0x5d, 0xbd, 0xee, 0x3c, 0x82, 
	  0x63, 0x8a, 0xc6, 0xcb, 0x8d, 0xf0, 0x2b, 0x71, 
	  0xff, 0xae, 0xa9, 0x7f, 0xcb, 0xb3, 0xfe, 0x5a, 
	  0xe0, 0x00, 0xb6, 0xe2, 0x00, 0x22, 0xc0, 0x00, 
	  0x0a, 0x0a, 0xd4, 0x05, 0xf8, 0xe2, 0xb4, 0x00, 
	  0x12, 0xb8, 0x02, 0x02, 0xbc, 0xa0, 0x2c, 0xc8, 
	  0xff, 0xc6, 0x98, 0x00, 0x38, 0x80, 0x13, 0x54, 
	  0xbf, 0xe5, 0xd9, 0xff, 0x2d, 0x70, 0x00, 0x5b, 
	  0x71, 0x00, 0x19, 0x6e, 0x34, 0xb0, 0x01, 0x2c, 
	  0xa0, 0x20, 0x13, 0xca, 0x01, 0x4b, 0x6f, 0xfc, 
	  0x56, 0xa0, 0x03, 0x88, 0x00, 0xc9, 0x4b, 0xfd, 
	  0xb2, 0x90, 0x12, 0xa7, 0x00, 0x06, 0x57, 0x10, 
	  0x02, 0x6e, 0x00, 0x0a, 0x0a, 0x99, 0xeb, 0x7b, 
	  0x8e, 0xe8, 0xfa, 0x47, 0xc5, 0x81, 0x72, 0x85, 
	  0x6a, 0xd4, 0x2c, 0x8d, 0x02, 0x9c, 0xf1, 0xa2, 
	  0xc9, 0x87, 0x32, 0x45, 0x7b, 0xb8, 0xde, 0xc0, 
	  0x00, 0x00, 0x0a, 0x0a, 0xdf, 0x55, 0xf8, 0x95, 
	  0xa8, 0x10, 0x36, 0x20, 0x30, 0x94, 0x05, 0x99, 
	  0x5f, 0xf9, 0xcd, 0xc0, 0x01, 0x2c, 0xa0, 0x20, 
	  0x13, 0xca, 0x01, 0x4b, 0x6f, 0xfc, 0xd9, 0x20, 
	  0x00, 0x00, 0x0a, 0x0a, 0xd2, 0x77, 0x18, 0x9a, 
	  0x00, 0x2b, 0xd9, 0xe2, 0x70, 0x51, 0xe5, 0x00, 
	  0x0b, 0xd2, 0xa0, 0x13, 0x3f, 0xfb, 0x85, 0xc2, 
	  0xcd, 0xeb, 0x11, 0x03, 0xed, 0xa6, 0xc0, 0x00, 
	  0x0a, 0x0b, 0x0f, 0x12, 0xc3, 0xa4, 0x2e, 0xaf, 
	  0xf6, 0x97, 0xdd, 0xeb, 0xbf, 0x24, 0xaf, 0xfd, 
	  0x12, 0x8f, 0x48, 0xda, 0xfa, 0xeb, 0x92, 0xb8, 
	  0x49, 0xaa, 0x80, 0x99, 0x28, 0x54, 0x48, 0xc2, 
	  0x48, 0xa0, 0x26, 0x5d, 0x19, 0xb0, 0x6a, 0xf5, 
	  0x28, 0xea, 0x90, 0x00, 0x0a, 0x0a, 0xde, 0xa5, 
	  0x42, 0xa3, 0xe8, 0x82, 0xa9, 0xcf, 0x9a, 0x8a, 
	  0x6c, 0x1a, 0xfa, 0x5f, 0x6d, 0xe0, 0x06, 0x45, 
	  0x00, 0xbb, 0xec, 0xb2, 0x83, 0xd4, 0x2c, 0x9f, 
	  0x10, 0x31, 0x05, 0x6f, 0x00, 0x4e, 0x01, 0x59, 
	  0x2c, 0xa9, 0x93, 0x81, 0xe6, 0x66, 0x1b, 0x4c, 
	  0xe4, 0x4c, 0xd2, 0x00, 0x01, 0x3a, 0x00, 0x00, 
	  0x44, 0x33, 0x4e, 0x61, 0x4b, 0x81, 0xd9, 0xbb, 
	  0xc0, 0x0b, 0x29, 0xff, 0x2c, 0xdc, 0xfa, 0x5e, 
	  0x6b, 0xc6, 0x98, 0x00, 0x39, 0xa0, 0x3f, 0x6f, 
	  0x25, 0xe7, 0xcf, 0xda, 0x7f, 0x33, 0x3d, 0xe0, 
	  0x0a, 0x70, 0x00, 0x0a, 0x0b, 0x0a, 0x02, 0xce, 
	  0x38, 0xd2, 0x03, 0xa4, 0xb4, 0xc6, 0x83, 0x3f, 
	  0x28, 0x44, 0x07, 0x44, 0x42, 0x83, 0x11, 0x90, 
	  0x0b, 0xec, 0x4f, 0xed, 0xdc, 0x50, 0x6e, 0xb3, 
	  0xa8, 0x01, 0x20, 0x57, 0x1b, 0xa8, 0x00, 0x96, 
	  0x38, 0x10, 0x29, 0xe5, 0x02, 0xa1, 0xb8, 0x0e, 
	  0x69, 0xf8, 0x00, 0x4a, 0xd4, 0x00, 0x1b, 0x30, 
	  0x01, 0xca, 0x02, 0xcc, 0xaf, 0xfc, 0x6e, 0x80, 
	  0x03, 0xa8, 0x00, 0x5c, 0x40, 0x00, 0x0a, 0x0a, 
	  0x5e, 0xdb, 0x0c, 0xa1, 0x13, 0xa8, 0xaf, 0x0f, 
	  0xc8, 0x35, 0x0a, 0x35, 0xa5, 0xe9, 0x71, 0x94, 
	  0x7b, 0xf6, 0x7d, 0x73, 0xef, 0xcf, 0x42, 0x00, 
	  0xe2, 0x92, 0x33, 0x61, 0xa8, 0xfe, 0x9f, 0xca, 
	  0x11, 0x02, 0x20, 0x92, 0x9f, 0x02, 0x2e, 0xbc, 
	  0xe4, 0x49, 0xfb, 0x83, 0xe7, 0x3b, 0xf8, 0x32, 
	  0x1a, 0x73, 0xce, 0x1f, 0x2f, 0xc1, 0x5d, 0x73, 
	  0xc7, 0x5c, 0x10, 0xb6, 0xe6, 0xd0, 0x07, 0x8e, 
	  0x6c, 0x60, 0x00, 0x6f, 0x00, 0x59, 0xa5, 0xff, 
	  0x2a, 0xc8, 0x09, 0x6b, 0x80, 0x02, 0xdb, 0x68, 
	  0x02, 0x57, 0x3b, 0x0c, 0x00, 0x00, 0x0a, 0x0a, 
	  0xd7, 0x65, 0x70, 0x89, 0xb5, 0x3e, 0x75, 0xfe, 
	  0xa8, 0x17, 0x4a, 0xa3, 0xe3, 0xb9, 0xeb, 0x7f, 
	  0xae, 0x7a, 0xff, 0xfb, 0x0e, 0x58, 0x9a, 0xf4, 
	  0xd7, 0xf4, 0x8e, 0x50, 0x68, 0x92, 0x84, 0x8d, 
	  0x21, 0x3f, 0x24, 0x27, 0xc4, 0x6b, 0x9c, 0xbb, 
	  0x99, 0x57, 0xff, 0xe7, 0x7f, 0x83, 0xc3, 0x2d, 
	  0x19, 0xfe, 0xa8, 0x7b, 0xb8, 0xfe, 0x3b, 0x93, 
	  0x23, 0x9b, 0x5c, 0x4a, 0x2f, 0xf6, 0x59, 0x60, 
	  0x7f, 0xa7, 0x94, 0x02, 0xa6, 0xc0, 0x28, 0x51, 
	  0x81, 0xb0, 0x91, 0x05, 0xa3, 0xdf, 0x40, 0xec, 
	  0xf0, 0x6e, 0x7a, 0x9f, 0xfa, 0xdf, 0x92, 0x8e, 
	  0x78, 0xc7, 0x62, 0xad, 0x90, 0x96, 0xf0, 0x4f, 
	  0x88, 0xa6, 0xfc, 0x25, 0x60, 0x31, 0x99, 0xb8, 
	  0xed, 0x98, 0x42, 0x55, 0x41, 0xd5, 0x7f, 0xa1, 
	  0x7e, 0xf8, 0x82, 0x6a, 0xc6, 0x7f, 0xbc, 0xaa, 
	  0x1b, 0x96, 0xc2, 0x00, 0x00, 0x0a, 0x0a, 0xd7, 
	  0xc6, 0xac, 0xe2, 0x00, 0x20, 0x9b, 0xec, 0x00, 
	  0x09, 0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 0x1b, 
	  0x00, 0xe2, 0x97, 0x00, 0x12, 0xb5, 0x00, 0x06, 
	  0xcc, 0x00, 0x72, 0x80, 0xb3, 0x2b, 0xfe, 0xb8, 
	  0x40, 0x38, 0x80, 0x17, 0xe6, 0xb7, 0xc0, 0x25, 
	  0x6a, 0x00, 0x0d, 0x98, 0x00, 0xe5, 0x01, 0x5e, 
	  0x50, 0x1d, 0x70, 0x80, 0x73, 0x00, 0x13, 0x83, 
	  0x7d, 0x48, 0x01, 0xcf, 0x1c, 0x31, 0x4d, 0xa0, 
	  0x0b, 0x9c, 0xd1, 0x30, 0x00, 0x05, 0x6b, 0xe3, 
	  0x2e, 0x71, 0x8a, 0x00, 0x0e, 0x66, 0x82, 0x98, 
	  0x6b, 0x70, 0x03, 0x98, 0x00, 0x5a, 0x00, 0x00, 
	  0x0a, 0x0b, 0x05, 0xf2, 0xe3, 0x38, 0xbc, 0x40, 
	  0x04, 0xae, 0x40, 0x81, 0xaf, 0x2f, 0xfb, 0x31, 
	  0xff, 0xf3, 0xb9, 0xc0, 0x03, 0x98, 0x00, 0x44, 
	  0xd2, 0x82, 0x54, 0x90, 0x14, 0x24, 0x21, 0x21, 
	  0x40, 0x3b, 0x84, 0xaa, 0xb5, 0xaa, 0xe7, 0x32, 
	  0xbf, 0x3a, 0x88, 0x0d, 0x08, 0x70, 0x1c, 0x09, 
	  0x23, 0x14, 0x7d, 0x8a, 0x85, 0x8c, 0x0a, 0x4f, 
	  0x51, 0xff, 0x5b, 0xef, 0x51, 0xce, 0x98, 0xec, 
	  0x55, 0xb2, 0x12, 0xdb, 0x09, 0xf5, 0x24, 0xdf, 
	  0xc4, 0x6b, 0xc7, 0xb3, 0xa5, 0x0c, 0x49, 0xe0, 
	  0x05, 0x0b, 0xff, 0xca, 0x0d, 0xcd, 0x74, 0x7c, 
	  0xf4, 0xdd, 0x6b, 0xf5, 0xcb, 0x48, 0x05, 0x60, 
	  0xf3, 0x59, 0x06, 0xd0, 0x14, 0x71, 0xff, 0xa5, 
	  0xc0, 0x00, 0x0a, 0x0a, 0x96, 0x28, 0x72, 0x2f, 
	  0xa0, 0xa9, 0x01, 0xa0, 0x2b, 0x64, 0x0e, 0xe0, 
	  0x73, 0x9f, 0xfd, 0x38, 0x29, 0x5d, 0x27, 0x49, 
	  0x4b, 0x9b, 0x9e, 0x59, 0x15, 0xf5, 0x50, 0x25, 
	  0x7b, 0xfd, 0x18, 0xd9, 0x12, 0x34, 0xa1, 0x21, 
	  0x65, 0x89, 0x51, 0x7c, 0x05, 0x6a, 0x7f, 0x8f, 
	  0x0a, 0xe3, 0xfa, 0x9e, 0x6e, 0x02, 0xad, 0xa3, 
	  0x28, 0xca, 0x0b, 0x70, 0x19, 0x55, 0xa4, 0x0a, 
	  0x23, 0x02, 0xec, 0x08, 0xa8, 0x4f, 0xbe, 0x10, 
	  0x72, 0x9d, 0xa3, 0xe1, 0xac, 0x6d, 0x1f, 0x8e, 
	  0x79, 0x6f, 0xef, 0x0e, 0xf1, 0xc2, 0x00, 0xa9, 
	  0x6e, 0xa2, 0x26, 0x33, 0xa1, 0x1c, 0xdb, 0x8d, 
	  0x54, 0x5d, 0x26, 0x47, 0xb2, 0x55, 0xea, 0x91, 
	  0xfe, 0x1f, 0x02, 0x83, 0xa4, 0x18, 0x05, 0xd0, 
	  0x4a, 0x3e, 0xb4, 0x6b, 0x0d, 0x06, 0x27, 0x98, 
	  0x7f, 0x35, 0x90, 0x08, 0xb6, 0x3a, 0xa5, 0xfb, 
	  0xdb, 0xb5, 0x6c, 0x20, 0x00, 0x0a, 0x0b, 0x0d, 
	  0xc2, 0xef, 0xba, 0xf5, 0xd2, 0x01, 0x47, 0xc7, 
	  0x81, 0x72, 0x83, 0x4a, 0x94, 0x14, 0xa6, 0xc1, 
	  0x8d, 0xa9, 0xd4, 0x52, 0xaf, 0xcb, 0x78, 0x02, 
	  0xe5, 0xce, 0x8e, 0x00, 0x0d, 0xe0, 0x05, 0x24, 
	  0xbf, 0xdc, 0xa9, 0xff, 0x2a, 0x70, 0x20, 0x63, 
	  0xed, 0x00, 0xac, 0xe6, 0x91, 0x00, 0x06, 0xb0, 
	  0x0c, 0x80, 0x0a, 0x0a, 0xd7, 0x75, 0x94, 0x9d, 
	  0xa7, 0x97, 0xff, 0xd2, 0xe8, 0xf7, 0x2d, 0x7a, 
	  0xf3, 0xe5, 0xa2, 0xbc, 0x06, 0xfd, 0xc4, 0xa6, 
	  0x70, 0x02, 0xd5, 0xa4, 0x69, 0x9e, 0x3e, 0x65, 
	  0xfd, 0xb1, 0x68, 0x08, 0xd4, 0x25, 0x64, 0x1e, 
	  0xa1, 0x58, 0xf8, 0x82, 0x4a, 0xfa, 0x7f, 0xd4, 
	  0xea, 0x41, 0x9c, 0xc2, 0x00, 0xb0, 0x96, 0x2e, 
	  0x0a, 0x77, 0xf0, 0x4c, 0x34, 0xe7, 0x9f, 0xc8, 
	  0xda, 0x82, 0x05, 0xa7, 0x81, 0x7a, 0xbc, 0xd2, 
	  0x49, 0xc3, 0x51, 0xb7, 0xf7, 0xb7, 0x08, 0x02, 
	  0xb4, 0xb1, 0x6f, 0x28, 0x44, 0x81, 0x00, 0x68, 
	  0xf4, 0xa3, 0xe2, 0x3d, 0xaf, 0x20, 0x62, 0x8b, 
	  0xc3, 0xe9, 0xf9, 0x30, 0x7a, 0x01, 0xbc, 0x41, 
	  0x11, 0xfb, 0xb0, 0x80, 0x00, 0x0a, 0x0a, 0xdd, 
	  0x55, 0x2e, 0x94, 0x13, 0xa0, 0x07, 0x27, 0xff, 
	  0x32, 0x35, 0x48, 0xc9, 0xed, 0xad, 0x59, 0x20, 
	  0x7e, 0x4a, 0xc2, 0xb0, 0x09, 0x63, 0x7f, 0xc5, 
	  0xbe, 0x4b, 0xb5, 0xd4, 0x08, 0x77, 0xa2, 0x5b, 
	  0xa1, 0x7f, 0xa5, 0x9c, 0x14, 0x3e, 0x46, 0x01, 
	  0x67, 0x64, 0xff, 0x94, 0xb7, 0x5a, 0x0d, 0xcd, 
	  0x1f, 0xfe, 0xa9, 0xe9, 0xfd, 0x17, 0x53, 0x43, 
	  0x7e, 0x0a, 0x2c, 0x50, 0x73, 0xe9, 0x58, 0x28, 
	  0x06, 0x95, 0x24, 0xb0, 0x20, 0x9d, 0xa6, 0x02, 
	  0x3c, 0xc3, 0x30, 0x80, 0x2b, 0x73, 0xd3, 0x0a, 
	  0x6c, 0xc6, 0x0e, 0x42, 0x58, 0xec, 0xcb, 0x2e, 
	  0x6b, 0x85, 0x0a, 0xb1, 0x99, 0x21, 0x26, 0x20, 
	  0x28, 0xc6, 0xfe, 0x6f, 0xb6, 0xf8, 0xa0, 0x11, 
	  0xba, 0x4e, 0xff, 0xae, 0x76, 0x78, 0x04, 0xaa, 
	  0xfd, 0x8c, 0x49, 0x11, 0xa5, 0x06, 0x28, 0x5a, 
	  0x9c, 0x20, 0x00, 0x0a, 0x0a, 0xd2, 0x77, 0x18, 
	  0x9a, 0x00, 0x2b, 0xd9, 0xe2, 0x70, 0x51, 0xe5, 
	  0x00, 0x0b, 0xd2, 0xa0, 0x13, 0x3f, 0xfb, 0x85, 
	  0xc2, 0xcd, 0xeb, 0x11, 0x03, 0xed, 0xa6, 0xc0, 
	  0x01, 0x5a, 0x4e, 0x97, 0x13, 0x40, 0x07, 0x7b, 
	  0x3e, 0x4e, 0x0a, 0x3d, 0x20, 0x01, 0x5a, 0x54, 
	  0x02, 0x67, 0xff, 0x60, 0xb8, 0x69, 0xbd, 0x61, 
	  0x20, 0x7c, 0xb4, 0xd8, 0x00, 0x00, 0x0a, 0x0a, 
	  0x9a, 0x6b, 0x7b, 0x8e, 0xe8, 0xfa, 0x47, 0xc5, 
	  0x81, 0x72, 0x85, 0x6a, 0xd4, 0x2c, 0x8d, 0x02, 
	  0x9c, 0xf1, 0xa2, 0xc9, 0x87, 0x32, 0x45, 0x7b, 
	  0xb8, 0xde, 0xc0, 0x00, 0x2b, 0x43, 0xd2, 0xe2, 
	  0x68, 0x00, 0xef, 0x67, 0xc9, 0xc1, 0x47, 0xa4, 
	  0x00, 0x2b, 0x4a, 0x80, 0x4c, 0xff, 0xec, 0x17, 
	  0x0d, 0x37, 0xac, 0x24, 0x0f, 0x96, 0x9b, 0x00, 
	  0x00, 0x0a, 0x0a, 0xc4, 0x85, 0xce, 0xe6, 0xd0, 
	  0x8e, 0x84, 0x88, 0x14, 0x50, 0x12, 0x27, 0xf9, 
	  0x76, 0xe5, 0x4a, 0x8c, 0xd6, 0x05, 0xa4, 0x02, 
	  0xe9, 0xb0, 0xe7, 0x4e, 0xb3, 0xb7, 0x35, 0x8d, 
	  0x9d, 0xa4, 0x6b, 0x30, 0x29, 0x8c, 0x17, 0xd5, 
	  0xf2, 0xf5, 0x49, 0x9d, 0xb6, 0xff, 0x1d, 0xc3, 
	  0x14, 0xf3, 0x97, 0x87, 0x40, 0x00, 0x0a, 0x0b, 
	  0x10, 0x53, 0x5b, 0x25, 0x6a, 0x04, 0x0d, 0x88, 
	  0x0c, 0x25, 0x01, 0x66, 0x57, 0xfe, 0x72, 0x20, 
	  0x00, 0x4b, 0x28, 0x08, 0x04, 0xf2, 0x80, 0x52, 
	  0xdb, 0xff, 0x36, 0xf0, 0x00, 0x01, 0x62, 0x0a, 
	  0x74, 0x24, 0xad, 0x40, 0x81, 0xb1, 0x00, 0x1c, 
	  0xa0, 0x2c, 0xca, 0xff, 0xce, 0x44, 0x00, 0x09, 
	  0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 0x5b, 0x7f, 
	  0xe6, 0xde, 0x00, 0x00, 0x00, 0x0a, 0x0b, 0x10, 
	  0x83, 0x73, 0xb9, 0xcb, 0xec, 0x61, 0x1c, 0x2f, 
	  0x6f, 0xc9, 0x60, 0x3b, 0x27, 0x97, 0x1a, 0x3d, 
	  0x24, 0x09, 0x93, 0xf5, 0x5b, 0x3f, 0x9a, 0xc6, 
	  0x31, 0x5c, 0xe9, 0xd1, 0x8a, 0x92, 0x53, 0x81, 
	  0x52, 0x30, 0x30, 0xc8, 0xca, 0x4d, 0x21, 0x07, 
	  0xa0, 0x2c, 0x48, 0x08, 0x11, 0xa4, 0x0f, 0xb7, 
	  0x36, 0x89, 0x8c, 0x00, 0x0a, 0x0a, 0xd4, 0x06, 
	  0x12, 0xa1, 0x65, 0xd9, 0x3e, 0xfc, 0xda, 0x8f, 
	  0xa2, 0xe2, 0xaa, 0xbf, 0x69, 0x64, 0x00, 0xa0, 
	  0x22, 0x6b, 0x10, 0xd8, 0xf3, 0x39, 0x31, 0x1a, 
	  0xe1, 0x63, 0x91, 0x2a, 0x3d, 0xe0, 0x04, 0x44, 
	  0xbf, 0xd9, 0xa9, 0xfb, 0x2a, 0x70, 0x60, 0x66, 
	  0xed, 0x00, 0xae, 0x99, 0x7b, 0x45, 0x2f, 0xda, 
	  0x55, 0xbe, 0x59, 0x00, 0xa1, 0x10, 0x02, 0x41, 
	  0x83, 0x3e, 0x80, 0x10, 0xa4, 0xaa, 0x08, 0xcd, 
	  0xe0, 0x04, 0x44, 0xbf, 0xdb, 0x29, 0x01, 0x2a, 
	  0x70, 0x00, 0x65, 0x6d, 0x00, 0xae, 0x05, 0x68, 
	  0xf3, 0xab, 0x4d, 0x2a, 0x0b, 0xf6, 0xbf, 0x30, 
	  0x2a, 0xf3, 0x58, 0x2e, 0xb6, 0x80, 0x26, 0x6e, 
	  0xfa, 0x08, 0xa3, 0x9b, 0xe2, 0x86, 0x4b, 0xef, 
	  0x5c, 0xc0, 0x00, 0x00, 0x0a, 0x0a, 0xda, 0x46, 
	  0xde, 0xda, 0x80, 0x01, 0x2b, 0x5f, 0xbf, 0xe9, 
	  0xca, 0x03, 0x05, 0xcf, 0x5c, 0xc0, 0x05, 0xda, 
	  0xa3, 0xe8, 0xb6, 0x2d, 0x8f, 0xb2, 0x8a, 0x60, 
	  0x20, 0xfb, 0x1e, 0x8e, 0x20, 0x02, 0x8d, 0x3f, 
	  0xed, 0xac, 0x67, 0x4e, 0x4e, 0x68, 0x4a, 0xac, 
	  0x3f, 0xb1, 0xa0, 0x08, 0xfc, 0xef, 0xaf, 0x68, 
	  0x93, 0x35, 0x2f, 0xdb, 0xd7, 0x7e, 0x45, 0x21, 
	  0x45, 0x26, 0xe1, 0x58, 0x94, 0xfb, 0x81, 0xc5, 
	  0xd8, 0x05, 0x3d, 0xb4, 0x05, 0xb3, 0xc7, 0x4f, 
	  0xa8, 0xba, 0x80, 0xa8, 0xfc, 0x40, 0x0b, 0x02, 
	  0x80, 0x3a, 0x5b, 0x48, 0x3e, 0x79, 0xdb, 0xa0, 
	  0xd0, 0x8b, 0x7f, 0x68, 0x02, 0xf4, 0x34, 0x61, 
	  0x45, 0x6e, 0x09, 0xfc, 0xc8, 0x6c, 0xe1, 0x57, 
	  0x2b, 0xfc, 0x1f, 0x29, 0xa0, 0x0e, 0x3d, 0x69, 
	  0x09, 0x00, 0x56, 0xd2, 0x34, 0x04, 0x97, 0x89, 
	  0x68, 0x31, 0x50, 0x50, 0x49, 0x78, 0x19, 0xff, 
	  0x3d, 0x13, 0xf1, 0xf2, 0xb1, 0x50, 0x0b, 0xe7, 
	  0xe8, 0x0f, 0xe7, 0xc4, 0x00, 0x5c, 0x00, 0x0a, 
	  0x0a, 0xda, 0xc6, 0x84, 0xe2, 0x38, 0x25, 0x5b, 
	  0xed, 0x00, 0x29, 0x65, 0x01, 0x00, 0x9e, 0x50, 
	  0x0a, 0x1b, 0x00, 0xe2, 0x9c, 0x00, 0x12, 0xb5, 
	  0x00, 0x06, 0xcc, 0x00, 0x72, 0x80, 0xb3, 0x2b, 
	  0xfe, 0xdb, 0x60, 0x0e, 0xbc, 0xed, 0x7e, 0x1c, 
	  0x66, 0x80, 0x02, 0x59, 0x40, 0x40, 0x27, 0x94, 
	  0x02, 0x96, 0xdf, 0xf7, 0xbc, 0x00, 0x1c, 0xf4, 
	  0xd3, 0xc0, 0xd7, 0x08, 0x04, 0xb2, 0x80, 0x80, 
	  0x4f, 0x10, 0x28, 0x24, 0xa1, 0x8f, 0xb0, 0x01, 
	  0xc5, 0x2e, 0x00, 0x25, 0x6c, 0x00, 0x05, 0x89, 
	  0x40, 0x59, 0x95, 0xff, 0x7d, 0x88, 0x01, 0xc4, 
	  0x6c, 0xb5, 0x39, 0xa1, 0x40, 0x00, 0x0a, 0xd9, 
	  0xd6, 0x34, 0xe3, 0x15, 0x00, 0x1c, 0xc6, 0xc5, 
	  0xbc, 0xd2, 0xf0, 0x1c, 0xc7, 0x02, 0x44, 0x00, 
	  0x0a, 0x0a, 0x5e, 0x1b, 0x0d, 0xb3, 0x80, 0x12, 
	  0xca, 0x02, 0x01, 0x3c, 0xa0, 0x14, 0x36, 0x01, 
	  0xcd, 0x32, 0x00, 0x0a, 0x12, 0xcf, 0x94, 0x1c, 
	  0xba, 0x67, 0x00, 0x4e, 0xe0, 0x9a, 0x99, 0xd5, 
	  0xda, 0x2f, 0xf5, 0xa2, 0x8f, 0x96, 0xf7, 0xb0, 
	  0xfe, 0xde, 0x77, 0xf0, 0x00, 0x4b, 0x28, 0x08, 
	  0x04, 0xf2, 0x80, 0x52, 0xdb, 0xfe, 0xd6, 0x40, 
	  0x0e, 0x60, 0x01, 0xe0, 0x02, 0xb2, 0x81, 0x65, 
	  0x38, 0x80, 0x12, 0xe7, 0x15, 0x48, 0x00, 0x9d, 
	  0xe0, 0x0e, 0x0b, 0x2f, 0x28, 0xfa, 0xcc, 0xab, 
	  0xb4, 0x10, 0xe3, 0x68, 0x00, 0x00, 0xa9, 0x40, 
	  0xec, 0x38, 0x80, 0x11, 0xa7, 0x14, 0xd0, 0x00, 
	  0x9d, 0x55, 0xfc, 0x2a, 0x0d, 0x26, 0x72, 0x48, 
	  0x04, 0x72, 0x9f, 0xd6, 0xce, 0x8b, 0x85, 0x38, 
	  0xca, 0xc0, 0x00, 0x00, 0x0a, 0x0a, 0xde, 0x04, 
	  0x0a, 0x9e, 0xdb, 0x7b, 0x9a, 0x80, 0x67, 0x9a, 
	  0x7f, 0xee, 0xc8, 0xf9, 0xee, 0xa9, 0xbf, 0xbb, 
	  0x1f, 0x78, 0x01, 0x4d, 0x40, 0x74, 0xe6, 0xba, 
	  0x41, 0xb4, 0xec, 0x5f, 0xf2, 0x66, 0xeb, 0x32, 
	  0x65, 0xc7, 0xf7, 0x14, 0xbf, 0xee, 0xdb, 0xfb, 
	  0x1d, 0x81, 0x92, 0x47, 0x92, 0xd9, 0x71, 0xd9, 
	  0x77, 0x54, 0xf6, 0xf5, 0x35, 0x13, 0xf7, 0x44, 
	  0xe3, 0xea, 0x7a, 0x73, 0x66, 0xf0, 0x05, 0xca, 
	  0x80, 0x9a, 0x78, 0x5d, 0x3d, 0xca, 0x12, 0xe0, 
	  0x54, 0x30, 0x32, 0xe5, 0x06, 0xb5, 0x2f, 0xd9, 
	  0x54, 0x83, 0xff, 0x37, 0x78, 0x02, 0x49, 0x2f, 
	  0xf9, 0x76, 0x40, 0xcb, 0x5f, 0xe8, 0x16, 0x7a, 
	  0xc0, 0x3a, 0x00, 0x0a, 0x0a, 0x59, 0x1b, 0x0d, 
	  0x71, 0x00, 0x4b, 0x28, 0x08, 0x04, 0xf2, 0x80, 
	  0x50, 0xd8, 0x07, 0x16, 0xe0, 0x00, 0xa1, 0xa7, 
	  0xf5, 0xc2, 0x58, 0xb7, 0x68, 0x04, 0x85, 0x1e, 
	  0xdc, 0x67, 0x2c, 0xfb, 0x3c, 0x64, 0x80, 0x02, 
	  0x59, 0x40, 0x40, 0x27, 0x94, 0x02, 0x96, 0xdf, 
	  0xf5, 0xbc, 0x01, 0xcc, 0x00, 0x3c, 0x00, 0x54, 
	  0x8c, 0x76, 0x1c, 0xc0, 0x04, 0x40, 0xe2, 0x94, 
	  0x00, 0x13, 0xa6, 0xbf, 0x86, 0x23, 0x24, 0xe7, 
	  0xe4, 0x40, 0x19, 0x59, 0xbc, 0x00, 0x92, 0xa3, 
	  0xd7, 0x5b, 0x2b, 0x70, 0xbb, 0x8d, 0x94, 0x00, 
	  0x00, 0x0a, 0x0a, 0xca, 0x05, 0xe4, 0xe2, 0x96, 
	  0x00, 0x1b, 0x40, 0x15, 0xa5, 0xfe, 0xd9, 0x48, 
	  0x09, 0x53, 0x80, 0x03, 0x2b, 0x88, 0x01, 0x7d, 
	  0x4b, 0xfe, 0x5d, 0x9f, 0xf2, 0xd7, 0x00, 0x05, 
	  0xb6, 0xd0, 0x06, 0x0e, 0x36, 0xa0, 0x01, 0xc4, 
	  0x00, 0x97, 0x39, 0xa5, 0x80, 0x01, 0xbc, 0x00, 
	  0xc0, 0x94, 0x03, 0x35, 0x1f, 0x65, 0x52, 0x0f, 
	  0xfc, 0xde, 0x20, 0x05, 0xe1, 0xce, 0x52, 0x00, 
	  0x09, 0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 0x5b, 
	  0x7f, 0xda, 0xc8, 0x01, 0xcc, 0x00, 0x3c, 0x0d, 
	  0xb3, 0x80, 0x12, 0xca, 0x02, 0x01, 0x3c, 0xa0, 
	  0x14, 0x36, 0x01, 0xcd, 0xc2, 0x00, 0x0e, 0x20, 
	  0x05, 0x81, 0x2f, 0xf9, 0x56, 0x40, 0x4b, 0x5c, 
	  0x00, 0x16, 0xdb, 0xc0, 0x0f, 0x0e, 0x76, 0x00, 
	  0x00, 0x71, 0x00, 0x23, 0x40, 0x00, 0x0a, 0x0a, 
	  0xca, 0x05, 0xe4, 0xe2, 0x96, 0x00, 0x1b, 0x40, 
	  0x15, 0xa5, 0x00, 0xd9, 0x40, 0x09, 0x54, 0x80, 
	  0xff, 0x2b, 0x88, 0x01, 0x7d, 0x4a, 0x06, 0x5d, 
	  0x7f, 0xf2, 0xd8, 0x00, 0x01, 0xb6, 0xd0, 0x06, 
	  0x0e, 0x36, 0xa0, 0x01, 0xc4, 0x00, 0x97, 0x39, 
	  0xa8, 0x00, 0x01, 0xbc, 0x00, 0xc0, 0x94, 0x03, 
	  0x35, 0x1f, 0x65, 0x52, 0x0f, 0xfc, 0xde, 0x20, 
	  0x05, 0xe1, 0xce, 0x3e, 0x00, 0x09, 0x65, 0x01, 
	  0x00, 0x9e, 0x50, 0x0a, 0x5b, 0x7f, 0xda, 0xc8, 
	  0x01, 0xcc, 0x00, 0x3c, 0x0d, 0xb3, 0x80, 0x12, 
	  0xca, 0x02, 0x01, 0x3c, 0xa0, 0x14, 0x36, 0x01, 
	  0xc5, 0xd2, 0x00, 0x25, 0x6c, 0x00, 0x05, 0x89, 
	  0x40, 0xd9, 0x93, 0xff, 0x8d, 0xc4, 0x00, 0x71, 
	  0x00, 0x23, 0x40, 0x00, 0x0a, 0x0b, 0x10, 0x43, 
	  0x97, 0x34, 0xb8, 0x04, 0xae, 0x00, 0x80, 0xaf, 
	  0x28, 0x0b, 0x32, 0x3f, 0xf1, 0x9f, 0x00, 0x09, 
	  0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 0x5b, 0x7f, 
	  0xe2, 0x8c, 0x00, 0x1c, 0x40, 0x04, 0xba, 0x6a, 
	  0x52, 0xbb, 0x90, 0xf9, 0xb1, 0x43, 0x6f, 0x7f, 
	  0xe8, 0x8f, 0x3f, 0x0f, 0xb2, 0x58, 0xde, 0x00, 
	  0xb7, 0x4e, 0x0a, 0xa0, 0xa3, 0xae, 0xf3, 0x9c, 
	  0x32, 0xaa, 0x60, 0x1d, 0x09, 0x28, 0x1c, 0x13, 
	  0x94, 0xd2, 0x02, 0xfa, 0x1e, 0x46, 0x80, 0x37, 
	  0xf1, 0xa4, 0x28, 0x04, 0xa5, 0x82, 0x81, 0xb9, 
	  0xbc, 0x01, 0x4e, 0x94, 0x0c, 0xaa, 0xe0, 0xa5, 
	  0xaf, 0xf4, 0x0b, 0x3d, 0x20, 0x39, 0x3d, 0xe3, 
	  0x2f, 0x3a, 0x01, 0xcf, 0x37, 0xff, 0xdd, 0xcf, 
	  0xb3, 0xd8, 0x53, 0xff, 0x77, 0x1e, 0xf0, 0x02, 
	  0x52, 0x90, 0x36, 0x7c, 0x10, 0x38, 0x18, 0x99, 
	  0x13, 0xfd, 0x17, 0xca, 0x67, 0xbe, 0x97, 0x2b, 
	  0xee, 0x20, 0x05, 0x48, 0x00, 0x0a, 0x0a, 0xdb, 
	  0x85, 0xe4, 0xe2, 0x00, 0x39, 0x9b, 0x63, 0x80, 
	  0x25, 0x94, 0x04, 0x02, 0x79, 0x40, 0x28, 0x6c, 
	  0x03, 0x8a, 0x34, 0x00, 0x4a, 0xd0, 0x00, 0x2b, 
	  0x12, 0x80, 0xb3, 0x2b, 0xfe, 0xda, 0x80, 0x0e, 
	  0x60, 0x02, 0x20, 0x6b, 0x5c, 0x02, 0x56, 0xa0, 
	  0x40, 0xd7, 0x94, 0x05, 0x99, 0x5f, 0xf7, 0xc4, 
	  0x00, 0x12, 0xca, 0x02, 0x01, 0x3c, 0xa0, 0x14, 
	  0xb6, 0xff, 0xb5, 0xc8, 0x03, 0x88, 0x00, 0xd2, 
	  0x73, 0xbc, 0x80, 0x03, 0x88, 0x01, 0x2e, 0x6d, 
	  0x66, 0x00, 0x95, 0xb0, 0x10, 0x15, 0xe5, 0x01, 
	  0x66, 0x57, 0xfd, 0xf1, 0x00, 0x04, 0xb2, 0x80, 
	  0x80, 0x4f, 0x28, 0x05, 0x2d, 0xbf, 0xeb, 0x74, 
	  0x03, 0x98, 0x00, 0x78, 0x1b, 0x67, 0x80, 0x25, 
	  0x8e, 0x04, 0x0a, 0x79, 0x40, 0xa8, 0x6e, 0x03, 
	  0x8a, 0x30, 0x00, 0x4a, 0xd8, 0x00, 0x0b, 0x12, 
	  0x80, 0xb3, 0x2b, 0xfe, 0xd9, 0xa0, 0x0e, 0x20, 
	  0x04, 0x69, 0xcd, 0x0e, 0x00, 0x00, 0x00, 0x0a, 
	  0x0b, 0x0a, 0x02, 0xfc, 0x38, 0xa2, 0xc0, 0x04, 
	  0xae, 0x00, 0x80, 0xaf, 0x28, 0x0b, 0x32, 0x3f, 
	  0xf3, 0xb0, 0x40, 0x02, 0x59, 0x40, 0x40, 0x27, 
	  0x94, 0x02, 0x96, 0xdf, 0xf8, 0xa3, 0x00, 0x07, 
	  0x30, 0x00, 0xf0, 0x38, 0xdd, 0x00, 0x04, 0xb2, 
	  0x80, 0x80, 0x4f, 0x28, 0x05, 0x0d, 0x80, 0x73, 
	  0x4f, 0xc0, 0x02, 0x56, 0xe0, 0x00, 0xd8, 0x94, 
	  0x05, 0x99, 0x1f, 0xf8, 0xdd, 0x40, 0x07, 0x30, 
	  0x01, 0x10, 0x00, 0x0a, 0x0b, 0x0e, 0x62, 0xfc, 
	  0x37, 0xb0, 0x00, 0x12, 0xb5, 0x02, 0x06, 0xbc, 
	  0xa0, 0x2c, 0xca, 0xff, 0xce, 0xd8, 0x00, 0x09, 
	  0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 0x5b, 0x7f, 
	  0xe2, 0xa0, 0x00, 0x1c, 0xc0, 0x02, 0xc6, 0xa3, 
	  0xe6, 0x40, 0xaf, 0x40, 0x62, 0x69, 0xb0, 0x09, 
	  0x9c, 0x39, 0x66, 0x61, 0x9d, 0x4b, 0x88, 0x01, 
	  0x7e, 0x4b, 0xfe, 0x55, 0x90, 0x12, 0xd7, 0x00, 
	  0x05, 0xb7, 0x10, 0x01, 0x2a, 0x9d, 0x18, 0x80, 
	  0x3b, 0x88, 0xa6, 0x3d, 0x12, 0x40, 0x00, 0xa1, 
	  0x56, 0xf8, 0x02, 0x2a, 0xdb, 0x98, 0x00, 0xa7, 
	  0x40, 0x00, 0x0a, 0x0a, 0x94, 0x09, 0x1b, 0x7a, 
	  0xb2, 0xdd, 0x3a, 0xac, 0x5a, 0x6d, 0x66, 0x4e, 
	  0x42, 0x3c, 0x93, 0x9b, 0x5b, 0xd5, 0xc0, 0x09, 
	  0x5a, 0x80, 0x03, 0x66, 0x00, 0x39, 0x40, 0x59, 
	  0x95, 0xff, 0x6c, 0x80, 0x04, 0xfa, 0xb9, 0x2e, 
	  0xf7, 0x19, 0x3e, 0x72, 0xa5, 0x5a, 0xe2, 0xf1, 
	  0x6f, 0x27, 0x8d, 0x68, 0x00, 0x4a, 0xe0, 0x08, 
	  0x0a, 0xf2, 0x80, 0xb3, 0x23, 0xfe, 0xf8, 0xa0, 
	  0x02, 0x58, 0xe0, 0x40, 0xa7, 0x97, 0xfa, 0x97, 
	  0x3f, 0xf6, 0xad, 0x00, 0x73, 0xb9, 0x07, 0xbb, 
	  0x8f, 0xfd, 0x09, 0x6f, 0x50, 0x00, 0x25, 0x6c, 
	  0x04, 0x05, 0x79, 0x40, 0x59, 0x95, 0xff, 0x8d, 
	  0x58, 0x00, 0x4b, 0x28, 0x08, 0x04, 0xf2, 0x80, 
	  0x52, 0xdb, 0xfe, 0xd6, 0x40, 0x0e, 0x60, 0x01, 
	  0xe0, 0x6d, 0x9c, 0x00, 0x96, 0x50, 0x10, 0x09, 
	  0xe5, 0x00, 0xa1, 0xb0, 0x0e, 0x2a, 0xa0, 0x01, 
	  0x2b, 0x60, 0x00, 0x2c, 0x4a, 0x02, 0xcc, 0xaf, 
	  0xfb, 0xec, 0x00, 0x0e, 0x20, 0x05, 0x2c, 0x00, 
	  0x0a, 0x0b, 0x07, 0x32, 0xfc, 0x37, 0xae, 0x80, 
	  0x12, 0xb5, 0x02, 0x06, 0xbc, 0xa0, 0x2c, 0xca, 
	  0xff, 0xc6, 0x2e, 0x00, 0x25, 0x94, 0x04, 0x02, 
	  0x79, 0x40, 0x29, 0x6d, 0xff, 0x7b, 0x20, 0x01, 
	  0xcc, 0x00, 0x3c, 0x0d, 0xf3, 0x80, 0x04, 0xb2, 
	  0x80, 0x80, 0x4f, 0x28, 0x05, 0x0d, 0x80, 0x73, 
	  0x70, 0x80, 0x03, 0x88, 0x01, 0x37, 0x4b, 0xfe, 
	  0x55, 0x90, 0x12, 0xd7, 0x00, 0x05, 0xb7, 0x10, 
	  0x01, 0x42, 0xe7, 0x79, 0x00, 0x07, 0x30, 0x01, 
	  0x10, 0x00, 0x0a, 0x0a, 0xd4, 0x66, 0xae, 0xe6, 
	  0x4e, 0xaa, 0x16, 0x77, 0x03, 0x98, 0x00, 0x78, 
	  0x1b, 0xed, 0xc0, 0x09, 0x65, 0x01, 0x00, 0x9e, 
	  0x50, 0x0a, 0x1b, 0x00, 0xe2, 0x95, 0x00, 0x12, 
	  0xb5, 0x00, 0x06, 0xcc, 0x00, 0x72, 0x80, 0xb3, 
	  0x2b, 0xfe, 0xdb, 0x80, 0x0e, 0x60, 0x02, 0x20, 
	  0x6b, 0x6c, 0x02, 0x56, 0xa0, 0x40, 0xd7, 0x94, 
	  0x05, 0x99, 0x5f, 0xf7, 0xce, 0x00, 0x1c, 0xf6, 
	  0x62, 0xb2, 0xe7, 0xb1, 0xaa, 0x76, 0xf9, 0xd0, 
	  0x02, 0x59, 0x40, 0x40, 0x27, 0x84, 0x30, 0xa5, 
	  0x06, 0x91, 0x9f, 0xfd, 0x6b, 0x80, 0x73, 0x00, 
	  0x0f, 0x03, 0x5c, 0x00, 0x12, 0xca, 0x02, 0x01, 
	  0x3c, 0x21, 0x03, 0x28, 0x14, 0xad, 0x40, 0x71, 
	  0x4a, 0x80, 0x09, 0x5b, 0x80, 0x03, 0x62, 0x50, 
	  0x16, 0x64, 0x7f, 0xdf, 0x66, 0x00, 0x73, 0x00, 
	  0x11, 0x03, 0x4a, 0xc0, 0x73, 0x27, 0xca, 0xfb, 
	  0x6a, 0xe0, 0x00, 0x00, 0x0a, 0x0a, 0xdf, 0x40, 
	  0x00, 0xea, 0x00, 0x17, 0xe1, 0xb5, 0x18, 0x02, 
	  0x56, 0xa0, 0x40, 0xd7, 0x94, 0x05, 0x99, 0x5f, 
	  0xf8, 0xda, 0xc0, 0x04, 0xb1, 0xc0, 0x81, 0x4f, 
	  0x2f, 0xf5, 0x2e, 0x7f, 0xef, 0x4a, 0x00, 0x39, 
	  0x80, 0x07, 0x35, 0xce, 0xcf, 0x41, 0x6d, 0xf2, 
	  0xc0, 0x04, 0xb2, 0x80, 0x80, 0x4f, 0x08, 0x61, 
	  0x4a, 0x0d, 0x23, 0x3f, 0xfb, 0x59, 0x80, 0x39, 
	  0x80, 0x07, 0x81, 0xae, 0x10, 0x09, 0x65, 0x01, 
	  0x00, 0x9e, 0x50, 0x0a, 0x1b, 0x00, 0xe2, 0x96, 
	  0x00, 0x12, 0xb4, 0x00, 0x0a, 0xc4, 0xa0, 0x2c, 
	  0xca, 0xff, 0xbe, 0xc4, 0x00, 0xe6, 0x00, 0x23, 
	  0x07, 0x34, 0xd4, 0xfc, 0x36, 0xb3, 0x00, 0x00, 
	  0x0a, 0x0b, 0x09, 0x62, 0xe1, 0xa9, 0xc6, 0xa0, 
	  0xbb, 0xeb, 0xa1, 0xca, 0x41, 0x4a, 0x20, 0x39, 
	  0x60, 0xc2, 0x93, 0x8f, 0xf3, 0x81, 0x6d, 0xea, 
	  0xa7, 0xec, 0xdd, 0x8c, 0x67, 0xf5, 0xb0, 0x80, 
	  0x2c, 0x25, 0x8b, 0xd6, 0xa1, 0x80, 0x0a, 0x02, 
	  0x47, 0x62, 0x8f, 0x5d, 0xcb, 0xa1, 0x42, 0xfa, 
	  0x28, 0x3f, 0x4b, 0xd9, 0x8b, 0xa8, 0x09, 0x63, 
	  0x15, 0xff, 0xd5, 0xc2, 0x00, 0x00, 0x0a, 0x0a, 
	  0x94, 0x08, 0xd3, 0x8a, 0x20, 0x00, 0x50, 0xbb, 
	  0xfc, 0x81, 0x0d, 0x99, 0x47, 0xc3, 0x69, 0xd4, 
	  0x7f, 0x4f, 0x18, 0x80, 0x00, 0x96, 0x50, 0x10, 
	  0x09, 0xe5, 0x00, 0xa5, 0xb7, 0xfd, 0xac, 0x80, 
	  0x1c, 0xc0, 0x03, 0xc0, 0xdb, 0x38, 0x01, 0x2c, 
	  0xa0, 0x20, 0x13, 0xca, 0x01, 0x43, 0x60, 0x1c, 
	  0x5d, 0x20, 0x02, 0x56, 0xe0, 0x00, 0xd8, 0x94, 
	  0x05, 0x99, 0x1f, 0xf8, 0xdc, 0x40, 0x07, 0x10, 
	  0x02, 0x84, 0x05, 0x65, 0x02, 0xf2, 0x71, 0x00, 
	  0x20, 0xce, 0x29, 0xa0, 0x01, 0x42, 0x10, 0x0a, 
	  0x03, 0x87, 0x05, 0x1f, 0x09, 0xd1, 0x6e, 0x83, 
	  0x1c, 0x6e, 0xa0, 0x00, 0x00, 0x0a, 0x0a, 0xd3, 
	  0x10, 0x20, 0xa4, 0xe2, 0x7c, 0x80, 0x4d, 0x7a, 
	  0x29, 0xfa, 0xd7, 0x93, 0x1b, 0x7d, 0x2a, 0x71, 
	  0xa8, 0x2e, 0xfa, 0xe8, 0x72, 0x80, 0x71, 0xd0, 
	  0x5c, 0x87, 0x4d, 0xf4, 0xc4, 0x34, 0x95, 0x1a, 
	  0x02, 0x72, 0x83, 0x4e, 0x94, 0x1c, 0x68, 0xfb, 
	  0x3b, 0x31, 0xa7, 0x8a, 0x07, 0xac, 0xcc, 0xdd, 
	  0xc7, 0xc0, 0x12, 0xa0, 0xfe, 0x70, 0x24, 0xa8, 
	  0x42, 0xab, 0x21, 0x2b, 0xa2, 0x47, 0x3f, 0x42, 
	  0xc3, 0x11, 0xa4, 0x0b, 0x04, 0xa8, 0x3f, 0xa4, 
	  0xf1, 0x33, 0xe7, 0x00, 0x96, 0x6c, 0xbf, 0x6c, 
	  0xdd, 0xfb, 0x1d, 0x3f, 0x44, 0xcd, 0x68, 0x5f, 
	  0x9f, 0xfd, 0x1d, 0xc3, 0x80, 0x47, 0x60, 0x60, 
	  0x10, 0xe1, 0x44, 0xba, 0xc1, 0x52, 0xe1, 0x2d, 
	  0x0d, 0xd5, 0xfd, 0xcb, 0x73, 0xe5, 0x90, 0x32, 
	  0x5f, 0xfe, 0x20, 0xcb, 0x60, 0x1c, 0x21, 0xbb, 
	  0x5b, 0x2b, 0x01, 0x61, 0x2c, 0x5e, 0xb5, 0x0c, 
	  0x00, 0x50, 0x12, 0x3b, 0x14, 0x7a, 0xee, 0x55, 
	  0x0a, 0x17, 0x51, 0x41, 0xfa, 0x7e, 0xcc, 0x5f, 
	  0x40, 0x4b, 0x18, 0xaf, 0xfe, 0xae, 0x10, 0x00, 
	  0x0a, 0x0a, 0x94, 0x08, 0x33, 0x8a, 0x24, 0x00, 
	  0x4c, 0xba, 0x52, 0x98, 0xa3, 0x40, 0xca, 0x35, 
	  0x12, 0x48, 0x86, 0xd7, 0x20, 0x09, 0x5a, 0x80, 
	  0x03, 0x66, 0x00, 0x39, 0x40, 0x59, 0x95, 0xff, 
	  0x5c, 0x20, 0x13, 0xdd, 0xe1, 0xdb, 0x1d, 0x4c, 
	  0xd9, 0x18, 0x37, 0x1a, 0x14, 0x23, 0x1c, 0xf8, 
	  0x05, 0x9d, 0xd1, 0xed, 0xdd, 0x35, 0xcf, 0xcb, 
	  0xc6, 0x10, 0x00, 0x25, 0x94, 0x04, 0x02, 0x79, 
	  0x40, 0x29, 0x6d, 0xff, 0x6b, 0x20, 0x07, 0x30, 
	  0x00, 0xf0, 0x36, 0xce, 0x00, 0x4b, 0x28, 0x08, 
	  0x04, 0xf2, 0x80, 0x50, 0xd8, 0x07, 0x15, 0x50, 
	  0x00, 0x95, 0xb0, 0x00, 0x16, 0x25, 0x01, 0x66, 
	  0x57, 0xfd, 0xf6, 0x00, 0x07, 0x10, 0x02, 0x5c, 
	  0x05, 0x65, 0x02, 0xde, 0x71, 0x00, 0x23, 0x4e, 
	  0x29, 0xe0, 0x01, 0x3b, 0xe8, 0x2c, 0x22, 0x65, 
	  0x51, 0xef, 0x1a, 0xd5, 0xc0, 0x2d, 0xbe, 0x24, 
	  0x00, 0x00, 0x0a, 0x0b, 0x0e, 0x12, 0xfd, 0xa7, 
	  0xc1, 0x62, 0xea, 0x00, 0x5a, 0x2a, 0xf0, 0x53, 
	  0xeb, 0x47, 0x27, 0xfe, 0xa1, 0x4c, 0x24, 0xb9, 
	  0xc9, 0x83, 0xd6, 0x20, 0x7e, 0x75, 0x90, 0x70, 
	  0x5a, 0x23, 0x89, 0x0d, 0x4a, 0x65, 0xd3, 0x90, 
	  0x96, 0xfa, 0x3e, 0x23, 0xc2, 0xcc, 0x04, 0xa8, 
	  0xb4, 0x7e, 0xdf, 0x67, 0x27, 0x97, 0xf5, 0x0b, 
	  0x40, 0x25, 0xae, 0x00, 0x0b, 0x6d, 0xe0, 0x07, 
	  0x04, 0xa0, 0x19, 0x22, 0x09, 0x0b, 0x0c, 0x44, 
	  0xe0, 0xff, 0x29, 0xae, 0xe0, 0x2a, 0x6b, 0x01, 
	  0x1a, 0x74, 0x12, 0x39, 0xac, 0x01, 0xa1, 0x84, 
	  0xfa, 0xc1, 0xcb, 0x22, 0x7f, 0xd5, 0x8b, 0x0d, 
	  0xb2, 0x86, 0x69, 0xa7, 0xe0, 0xf4, 0xe7, 0x3e, 
	  0x19, 0xeb, 0x9e, 0x8e, 0x37, 0x56, 0x0b, 0xa9, 
	  0xad, 0x32, 0x40, 0x27, 0xe8, 0x04, 0xf2, 0xc4, 
	  0x27, 0xf2, 0xa1, 0x03, 0x03, 0x42, 0x53, 0x06, 
	  0x50, 0x4c, 0x13, 0x00, 0x95, 0x38, 0x00, 0x32, 
	  0xb7, 0x80, 0x26, 0xd2, 0xff, 0x97, 0x64, 0x0c, 
	  0xb5, 0xfe, 0x81, 0x67, 0xac, 0x02, 0x60, 0x00, 
	  0x0a, 0x0a, 0xd4, 0x07, 0xb0, 0xe6, 0x00, 0x22, 
	  0x07, 0x15, 0x50, 0x00, 0xde, 0x00, 0x47, 0x4a, 
	  0x09, 0x5a, 0x6f, 0x72, 0xa9, 0x15, 0xfe, 0x86, 
	  0xf0, 0x04, 0x8b, 0x9c, 0x68, 0x00, 0x1b, 0xc0, 
	  0x0d, 0xe9, 0x40, 0x2e, 0x51, 0xe2, 0x55, 0x22, 
	  0x3f, 0xd2, 0xde, 0x00, 0xb9, 0x71, 0x55, 0x00, 
	  0x0e, 0x60, 0x01, 0xe0, 0x6f, 0x97, 0x00, 0x25, 
	  0x94, 0x04, 0x02, 0x79, 0x40, 0x28, 0x6c, 0x03, 
	  0x8b, 0xec, 0x00, 0x4a, 0xd4, 0x00, 0x1b, 0x30, 
	  0x01, 0xca, 0x02, 0xcc, 0xaf, 0xfb, 0xe5, 0x80, 
	  0x00, 0x00, 0x0a, 0x0b, 0x0f, 0xa2, 0xfc, 0x36, 
	  0xa1, 0x00, 0x4a, 0xd4, 0x08, 0x1a, 0xf2, 0x81, 
	  0xaf, 0x24, 0x0f, 0x1b, 0x58, 0x00, 0x96, 0x47, 
	  0xf0, 0x4a, 0x65, 0x00, 0xa5, 0xb7, 0xfd, 0xe9, 
	  0x80, 0x07, 0x30, 0x00, 0xa7, 0xa8, 0xf9, 0x12, 
	  0x8b, 0x70, 0x1a, 0xa2, 0xda, 0xf9, 0xbe, 0x6b, 
	  0x63, 0x98, 0x00, 0xac, 0x5b, 0xd3, 0x00, 0x09, 
	  0x5b, 0x01, 0x01, 0x5e, 0x50, 0x16, 0x65, 0x7f, 
	  0xe3, 0x6b, 0x00, 0x12, 0xca, 0xfe, 0x01, 0x4c, 
	  0xa0, 0x14, 0xb6, 0xff, 0xb5, 0x08, 0x03, 0x98, 
	  0x00, 0x53, 0xd4, 0x03, 0xcb, 0x9a, 0xe4, 0x0f, 
	  0xd0, 0xb8, 0x7c, 0x21, 0x05, 0x1b, 0xcc, 0x00, 
	  0x56, 0x20, 0x00, 0x0a, 0x0a, 0xd0, 0xb0, 0x00, 
	  0xda, 0xe4, 0x01, 0xd4, 0x68, 0xaf, 0xc3, 0x5b, 
	  0xe0, 0x12, 0xb5, 0x02, 0x06, 0xbc, 0xa0, 0x2b, 
	  0xca, 0x03, 0xc6, 0xd4, 0x00, 0x25, 0x90, 0x04, 
	  0x12, 0x79, 0x40, 0x29, 0x6d, 0xff, 0x7a, 0x70, 
	  0x01, 0xcf, 0x3f, 0x3b, 0xec, 0xb4, 0x1c, 0xf4, 
	  0x64, 0x44, 0xde, 0x9a, 0xff, 0x4a, 0xd8, 0x08, 
	  0x0a, 0xf2, 0x80, 0xaf, 0x28, 0x0f, 0x1b, 0x48, 
	  0x00, 0x96, 0x57, 0xf0, 0x0a, 0x62, 0x05, 0x04, 
	  0x94, 0x32, 0x06, 0x1f, 0xf5, 0xbe, 0x01, 0xd4, 
	  0x64, 0x10, 0x40, 0x00, 0x0a, 0x0a, 0x5e, 0x80, 
	  0x0d, 0xaf, 0xc0, 0x1c, 0xc7, 0x34, 0xe0, 0xe6, 
	  0x38, 0x19, 0x06, 0xf4, 0x00, 0x03, 0xa8, 0x3e, 
	  0x5f, 0x86, 0x97, 0x80, 0x95, 0xa8, 0x10, 0x35, 
	  0xe5, 0x01, 0x66, 0x57, 0xfe, 0x36, 0xa0, 0x01, 
	  0x2c, 0xa0, 0x20, 0x13, 0xca, 0x01, 0x4b, 0x6f, 
	  0xfb, 0xd8, 0x00, 0x0e, 0x7e, 0x39, 0xda, 0x73, 
	  0xe4, 0xd3, 0xc3, 0x6c, 0x20, 0x07, 0x3e, 0x40, 
	  0xc4, 0x39, 0xf9, 0x08, 0x9d, 0xbd, 0x75, 0xfe, 
	  0x95, 0xc0, 0x10, 0x15, 0xe5, 0x01, 0x66, 0x47, 
	  0xfe, 0x36, 0xb0, 0x01, 0x2c, 0xa0, 0x20, 0x13, 
	  0xc2, 0x18, 0x52, 0x83, 0x48, 0xcf, 0xfe, 0x97, 
	  0x80, 0xea, 0x0f, 0x08, 0x20, 0x00, 0x0a, 0x0a, 
	  0xd4, 0x55, 0xc0, 0xe2, 0xb3, 0x46, 0x1a, 0x5e, 
	  0x02, 0x56, 0xa0, 0x40, 0xd7, 0x94, 0x05, 0x79, 
	  0x40, 0x77, 0xc8, 0x80, 0x12, 0xca, 0x02, 0x01, 
	  0x3c, 0xa0, 0x14, 0xb6, 0xff, 0xb5, 0x68, 0x03, 
	  0x8d, 0x9c, 0xc7, 0x71, 0xb2, 0xa7, 0x4d, 0xaa, 
	  0xdf, 0xd2, 0xb6, 0x02, 0x02, 0xbc, 0xa0, 0x2c, 
	  0xca, 0xff, 0xbe, 0x48, 0x00, 0x96, 0x50, 0x10, 
	  0x09, 0xe5, 0x00, 0xa5, 0xb7, 0xfd, 0x2f, 0x01, 
	  0xc5, 0x66, 0x74, 0x38, 0xd1, 0x0f, 0x86, 0xbb, 
	  0xc0, 0x25, 0x94, 0x04, 0x02, 0x79, 0x40, 0x28, 
	  0x6c, 0x03, 0x8a, 0x0c, 0x00, 0x4a, 0xd8, 0x00, 
	  0x0b, 0x12, 0x80, 0xb3, 0x2b, 0xfe, 0xd8, 0x00, 
	  0x0e, 0x2a, 0x44, 0xa5, 0xc5, 0x4a, 0x6b, 0x36, 
	  0xc2, 0x01, 0x4b, 0x28, 0x08, 0x04, 0xf2, 0x80, 
	  0x50, 0xd8, 0x07, 0x14, 0x20, 0x00, 0x95, 0xa8, 
	  0x00, 0x36, 0x60, 0x03, 0x94, 0x05, 0x99, 0x5f, 
	  0xf5, 0xde, 0x01, 0xc6, 0x82, 0x84, 0x00, 0x0a, 
	  0x0a, 0xd4, 0x06, 0x04, 0xe6, 0x59, 0x2f, 0x66, 
	  0xb6, 0x00, 0x25, 0x66, 0x00, 0x1d, 0x89, 0x7f, 
	  0x5a, 0x99, 0xfb, 0x7c, 0x90, 0x01, 0x2c, 0x70, 
	  0x20, 0x53, 0xcb, 0xfd, 0x4b, 0x9f, 0xfb, 0x54, 
	  0x00, 0x38, 0xda, 0x8e, 0x17, 0x1b, 0x4a, 0x40, 
	  0xda, 0x99, 0xfd, 0x2b, 0x60, 0x20, 0x2b, 0xca, 
	  0x02, 0xcc, 0xaf, 0xfb, 0xe4, 0x40, 0x09, 0x65, 
	  0x01, 0x00, 0x9e, 0x50, 0x0a, 0x5b, 0x7f, 0xd6, 
	  0xc0, 0x07, 0x32, 0xc8, 0x85, 0x38, 0x80, 0x0d, 
	  0x66, 0xf9, 0x80, 0x02, 0x59, 0x40, 0x40, 0x27, 
	  0x94, 0x02, 0x86, 0xc0, 0x38, 0xbe, 0xc0, 0x04, 
	  0xad, 0x40, 0x01, 0xb3, 0x00, 0x1c, 0xa0, 0x2c, 
	  0xca, 0xff, 0xbe, 0x54, 0x00, 0xe2, 0x00, 0x4a, 
	  0x80, 0x00, 0x0a, 0x0a, 0xdf, 0x40, 0x00, 0xe2, 
	  0x00, 0x52, 0x92, 0x81, 0x95, 0x5c, 0x04, 0xb5, 
	  0xc0, 0x01, 0x6d, 0xc4, 0x00, 0x47, 0x39, 0xd8, 
	  0x00, 0x01, 0x9c, 0x16, 0xe6, 0xa6, 0xa3, 0x46, 
	  0xd0, 0x09, 0x2e, 0x74, 0xf8, 0x00, 0x71, 0x00, 
	  0x13, 0x89, 0x7f, 0xb9, 0x53, 0xfe, 0x54, 0xe0, 
	  0x40, 0xc7, 0xde, 0x00, 0x8c, 0x73, 0x43, 0xc0, 
	  0x03, 0x18, 0x5c, 0xeb, 0x83, 0x98, 0xda, 0x00, 
	  0xed, 0xcd, 0x8d, 0x00, 0x00, 0x00, 0x0a, 0x0b, 
	  0x0a, 0x02, 0xe3, 0x37, 0xb1, 0x00, 0x12, 0xb5, 
	  0x02, 0x06, 0xbc, 0xa0, 0x2c, 0xca, 0xff, 0xc6, 
	  0xec, 0x00, 0x3a, 0x80, 0x02, 0xda, 0x71, 0x45, 
	  0x00, 0x09, 0x5a, 0x81, 0x03, 0x5e, 0x50, 0x16, 
	  0x25, 0x00, 0xdf, 0x3c, 0x00, 0x75, 0x00, 0x0a, 
	  0xec, 0x00, 0x0a, 0x0b, 0x04, 0xda, 0xbb, 0x23, 
	  0xcc, 0xf3, 0x89, 0x35, 0xc6, 0xf0, 0x25, 0xb4, 
	  0x13, 0xe2, 0x29, 0x3f, 0x28, 0xb5, 0xba, 0x94, 
	  0x72, 0xb8, 0x46, 0x55, 0x99, 0x12, 0x18, 0x92, 
	  0xbf, 0xca, 0x8f, 0xe0, 0x5b, 0xd2, 0x03, 0xa6, 
	  0xb6, 0x75, 0xd7, 0x2a, 0x90, 0x00, 0x0a, 0x0a, 
	  0xd1, 0x80, 0xa0, 0xdf, 0x3c, 0x00, 0x4b, 0x2b, 
	  0xf8, 0x05, 0x32, 0x80, 0x4e, 0xd8, 0x0f, 0x14, 
	  0x50, 0x00, 0xea, 0x00, 0x14, 0x99, 0xc6, 0xec, 
	  0x00, 0x25, 0x95, 0xfc, 0x02, 0x99, 0x40, 0x28, 
	  0x6c, 0x03, 0x7b, 0x10, 0x01, 0xd4, 0x00, 0x14, 
	  0x50, 0x00, 0x0a, 0x0b, 0x09, 0x62, 0xcc, 0xb8, 
	  0xd3, 0x8d, 0xf4, 0x96, 0x2a, 0x11, 0xf2, 0x83, 
	  0x4a, 0x94, 0x1c, 0x6d, 0x0a, 0xef, 0x19, 0xf4, 
	  0x9a, 0x71, 0x49, 0xa8, 0xee, 0x29, 0x32, 0xe5, 
	  0x1a, 0x18, 0x73, 0x46, 0xb4, 0xbb, 0xf2, 0xa4, 
	  0xfa, 0x12, 0xdc, 0x80, 0x63, 0x75, 0x7c, 0x69, 
	  0xc9, 0x08, 0x00, 0x0a, 0x0b, 0x13, 0x20, 0x28, 
	  0x3a, 0xd9, 0x00, 0x00, 0x6d, 0x00, 0x50, 0xea, 
	  0x9c, 0x00, 0x01, 0xb4, 0x02, 0xc0, 0x00, 0x0a, 
	  0x0b, 0x0c, 0x4a, 0xd2, 0x38, 0xde, 0xc0, 0x07, 
	  0x14, 0x89, 0xde, 0x8d, 0x0f, 0x42, 0x64, 0x4d, 
	  0x66, 0xfe, 0x95, 0xaf, 0xb0, 0xb4, 0x63, 0xfd, 
	  0xbb, 0x6e, 0x3b, 0xa4, 0x7c, 0x00, 0x0a, 0x0a, 
	  0xda, 0x40, 0x00, 0xde, 0xba, 0x00, 0x4a, 0xd8, 
	  0x00, 0x0b, 0x30, 0x01, 0xca, 0x02, 0xcc, 0xaf, 
	  0xfb, 0x65, 0x80, 0x39, 0x80, 0x0b, 0xd1, 0x47, 
	  0xd5, 0x8c, 0x5a, 0x9f, 0x64, 0xfa, 0x60, 0x15, 
	  0xe4, 0x47, 0x2d, 0x21, 0x95, 0x47, 0xcb, 0x78, 
	  0x78, 0x04, 0x32, 0x84, 0x4a, 0x88, 0x1c, 0x67, 
	  0x03, 0x79, 0x3a, 0xdf, 0x88, 0x47, 0xfd, 0x46, 
	  0xff, 0x3c, 0x13, 0xba, 0x41, 0xa0, 0xf4, 0xfe, 
	  0xf0, 0x02, 0x22, 0x69, 0x1e, 0x2b, 0x4f, 0xa9, 
	  0x6b, 0xfc, 0xa4, 0x02, 0x89, 0xbc, 0x12, 0xf9, 
	  0xd1, 0x6a, 0x01, 0x23, 0xc9, 0x2a, 0x03, 0xa7, 
	  0x57, 0x00, 0x52, 0xd8, 0x99, 0x1c, 0xa9, 0xc9, 
	  0xb7, 0x81, 0x10, 0xc0, 0xad, 0xa4, 0x72, 0x09, 
	  0xaa, 0xd4, 0x6c, 0x4a, 0xa6, 0x99, 0x37, 0x89, 
	  0xfe, 0x9e, 0x47, 0xf7, 0xf9, 0xd6, 0xe8, 0x05, 
	  0xb3, 0x55, 0x53, 0xf1, 0x95, 0x20, 0x14, 0xe0, 
	  0xe6, 0x65, 0x0b, 0x52, 0x15, 0xde, 0x00, 0x5a, 
	  0x00, 0x0a, 0x0b, 0x04, 0x62, 0xcf, 0x37, 0xd2, 
	  0x80, 0x12, 0xc8, 0x03, 0xf9, 0x3c, 0xa0, 0x14, 
	  0xb6, 0xff, 0xb5, 0xa8, 0x03, 0xa8, 0x00, 0x21, 
	  0x26, 0xd9, 0xa0, 0x09, 0x64, 0x01, 0xfc, 0x9e, 
	  0x50, 0x0a, 0x1b, 0x00, 0xde, 0xba, 0x00, 0x6f, 
	  0x00, 0x54, 0x27, 0x48, 0xb4, 0x1b, 0xff, 0xfa, 
	  0x18, 0xcf, 0x6c, 0x24, 0x98, 0xa8, 0xf7, 0xe6, 
	  0x69, 0xc7, 0xda, 0x9e, 0x4a, 0x00, 0xb6, 0xb5, 
	  0x39, 0xff, 0xeb, 0x98, 0x0a, 0xd4, 0x24, 0xec, 
	  0xa1, 0x48, 0x08, 0x41, 0xc5, 0x66, 0x8f, 0x7d, 
	  0x48, 0xaf, 0x42, 0x2a, 0x2b, 0x5f, 0x83, 0xdf, 
	  0xac, 0x28, 0x08, 0x6a, 0xf5, 0x2f, 0xdd, 0xc2, 
	  0x00, 0x00, 0x0a, 0x0a, 0xdd, 0x65, 0x10, 0x9f, 
	  0x05, 0x90, 0xa3, 0x7f, 0x28, 0x93, 0x42, 0x0f, 
	  0x7d, 0xac, 0xa0, 0x20, 0x67, 0x1a, 0xa0, 0x72, 
	  0x76, 0x67, 0xf5, 0x41, 0x95, 0x99, 0x5b, 0x14, 
	  0x0b, 0x66, 0x5f, 0x97, 0xaf, 0x7c, 0x8e, 0xe0, 
	  0xc9, 0x23, 0xc1, 0x28, 0xc9, 0xec, 0x89, 0x19, 
	  0x30, 0x06, 0x8a, 0x77, 0xe9, 0xf9, 0x6a, 0xda, 
	  0x01, 0xaa, 0x79, 0x64, 0xfa, 0x28, 0x45, 0xc1, 
	  0x40, 0x9c, 0xb2, 0x94, 0x1b, 0x24, 0xbf, 0xa5, 
	  0x4e, 0x00, 0x0c, 0xad, 0xe0, 0x0a, 0x54, 0xbf, 
	  0xe2, 0xd9, 0xfb, 0x2d, 0x70, 0x60, 0x5d, 0xe9, 
	  0x01, 0xa0, 0x00, 0x0a, 0x0b, 0x0f, 0xa2, 0xcf, 
	  0x37, 0xd1, 0x80, 0x12, 0xca, 0x02, 0x01, 0x3c, 
	  0xa0, 0x14, 0xb6, 0xff, 0xb5, 0xa8, 0x03, 0x88, 
	  0x00, 0xf3, 0x4f, 0x72, 0x95, 0xc9, 0x3f, 0xf4, 
	  0x4e, 0x41, 0x57, 0xb0, 0xcd, 0x50, 0x14, 0x33, 
	  0x2c, 0x70, 0x4d, 0x23, 0x80, 0x37, 0xec, 0xeb, 
	  0x6f, 0x49, 0xe6, 0x93, 0xbc, 0x08, 0xb2, 0xde, 
	  0xba, 0x00, 0x4a, 0xd8, 0x00, 0x0b, 0x30, 0x01, 
	  0xca, 0x02, 0xcc, 0xaf, 0xfb, 0x65, 0x80, 0x3a, 
	  0x80, 0x05, 0xc6, 0x02, 0xb4, 0x69, 0x3b, 0x28, 
	  0x52, 0x42, 0x00, 0x6d, 0x58, 0xa3, 0xe2, 0x53, 
	  0x2b, 0xc0, 0x82, 0x8a, 0xcf, 0xe1, 0xf7, 0xea, 
	  0xfa, 0x02, 0x1a, 0xbd, 0x4b, 0xf7, 0x70, 0x80, 
	  0x00, 0x0a, 0x0b, 0x10, 0x43, 0x9c, 0x26, 0x04, 
	  0x8c, 0xda, 0xb2, 0xa3, 0x86, 0xbe, 0xed, 0x2f, 
	  0xce, 0x89, 0x70, 0x23, 0xf7, 0x18, 0xda, 0x02, 
	  0x76, 0xb5, 0xbd, 0x09, 0xe5, 0x6b, 0xfd, 0xcf, 
	  0x7a, 0x11, 0x1f, 0x28, 0x27, 0xe7, 0x25, 0xf9, 
	  0x72, 0xf7, 0xc8, 0x60, 0x86, 0x3b, 0x0a, 0x4b, 
	  0x9f, 0x38, 0x4b, 0xb2, 0x86, 0xe5, 0x9e, 0x22, 
	  0x90, 0x0a, 0x2a, 0x9f, 0xbf, 0xc3, 0xac, 0xf9, 
	  0xb4, 0x0f, 0xfc, 0x0a, 0x8d, 0x08, 0x82, 0x81, 
	  0x12, 0xdc, 0x4c, 0xbf, 0x0a, 0x13, 0x40, 0x44, 
	  0x42, 0x48, 0x79, 0xd1, 0x40, 0x04, 0x00, 0x0a, 
	  0x0a, 0xd0, 0xe5, 0x08, 0xe2, 0xbe, 0x00, 0x12, 
	  0xb5, 0x02, 0x06, 0xc4, 0x06, 0x12, 0x80, 0xb3, 
	  0x2b, 0xff, 0x1a, 0x10, 0x00, 0xda, 0x01, 0x19, 
	  0x38, 0x36, 0xb2, 0xd3, 0xf7, 0xca, 0xa4, 0x13, 
	  0xb1, 0x92, 0xa9, 0x10, 0x8c, 0x24, 0xce, 0x81, 
	  0xfd, 0xff, 0xb0, 0x02, 0x4a, 0x9f, 0xb8, 0x3a, 
	  0x72, 0x80, 0xc7, 0x73, 0xbc, 0xd8, 0xde, 0xd4, 
	  0xbf, 0x13, 0x5b, 0x7c, 0xe4, 0xff, 0xd1, 0x6f, 
	  0x82, 0xff, 0x69, 0xe3, 0xb4, 0x01, 0xd3, 0x7d, 
	  0x40, 0x01, 0x2c, 0xa0, 0x20, 0x13, 0xca, 0x01, 
	  0x4b, 0x6f, 0xfb, 0xd6, 0x00, 0x0e, 0x60, 0x01, 
	  0x54, 0x6f, 0x9e, 0x00, 0x25, 0x94, 0x04, 0x02, 
	  0x79, 0x40, 0x28, 0x6c, 0x03, 0x9a, 0x7a, 0x00, 
	  0x12, 0xb4, 0x00, 0x0a, 0xc4, 0xa0, 0x2c, 0xca, 
	  0xff, 0xc6, 0x9a, 0x00, 0x39, 0x80, 0x0a, 0xb0, 
	  0x00, 0x0a, 0x0a, 0xdb, 0x85, 0x64, 0x9e, 0xff, 
	  0x38, 0x95, 0x80, 0x28, 0xa1, 0x42, 0x7f, 0x65, 
	  0x83, 0xa0, 0x27, 0x60, 0x57, 0xb0, 0x96, 0x76, 
	  0x90, 0x09, 0x05, 0x3c, 0xe2, 0x01, 0x20, 0x53, 
	  0xfb, 0x1c, 0xd2, 0x00, 0xd6, 0xf8, 0xc0, 0x02, 
	  0x59, 0x40, 0x00, 0x28, 0x94, 0x02, 0x96, 0xdf, 
	  0xf7, 0xb9, 0x00, 0x13, 0xa4, 0x3f, 0xa6, 0x4c, 
	  0x7c, 0xca, 0xf4, 0xbf, 0xb1, 0x7c, 0xc0, 0x04, 
	  0xd0, 0xda, 0xdc, 0x01, 0x2b, 0x40, 0x3f, 0xab, 
	  0xca, 0x02, 0xcc, 0xaf, 0xfb, 0xe8, 0xc0, 0x0d, 
	  0xe0, 0x05, 0x60, 0x2b, 0x44, 0x13, 0xb2, 0x84, 
	  0xd8, 0x1e, 0x06, 0x94, 0x0a, 0x3e, 0x34, 0xd6, 
	  0xcd, 0x07, 0x68, 0xb2, 0x3e, 0x4f, 0x82, 0xc6, 
	  0xa0, 0x1f, 0xb1, 0x93, 0x9f, 0x83, 0x08, 0x00, 
	  0x0a, 0x0b, 0x05, 0x02, 0xcf, 0x37, 0xd3, 0x00, 
	  0x12, 0xca, 0x02, 0x01, 0x3c, 0xa0, 0x14, 0xb6, 
	  0xff, 0xb5, 0x90, 0x03, 0xa8, 0x00, 0x21, 0x26, 
	  0xda, 0xc0, 0x09, 0x65, 0x01, 0x00, 0x9e, 0x50, 
	  0x2a, 0x1a, 0x80, 0xe2, 0x84, 0x00, 0x12, 0xb7, 
	  0x00, 0x06, 0xc4, 0xa0, 0x2c, 0xc8, 0xff, 0xb6, 
	  0x70, 0x03, 0x88, 0x01, 0x00, 0x6b, 0x41, 0x9a, 
	  0x64, 0xaa, 0x53, 0x9d, 0x99, 0x8f, 0x75, 0xd5, 
	  0x00, 0x66, 0x69, 0x02, 0x39, 0x35, 0x89, 0x09, 
	  0x0e, 0x64, 0xe3, 0xd0, 0x45, 0xbe, 0x20, 0x03, 
	  0xe1, 0xb6, 0x80, 0x02, 0x59, 0x40, 0x40, 0x27, 
	  0x94, 0x02, 0x86, 0xc0, 0x38, 0xa0, 0xc0, 0x04, 
	  0xae, 0x00, 0x00, 0xb1, 0x28, 0x0b, 0x32, 0x3f, 
	  0xed, 0xaa, 0x00, 0xe2, 0x00, 0x41, 0x54, 0x7d, 
	  0x57, 0xc5, 0xa9, 0xf5, 0x4f, 0x7b, 0xff, 0xe5, 
	  0x0c, 0x32, 0xdb, 0x43, 0x69, 0x6f, 0x3f, 0xfd, 
	  0x7c, 0x80, 0x0a, 0x0a, 0xd4, 0x04, 0xb8, 0xe3, 
	  0x61, 0x00, 0x12, 0xca, 0x02, 0x01, 0x3c, 0xa0, 
	  0x14, 0xb6, 0xff, 0xbd, 0xdc, 0x00, 0xe6, 0x00, 
	  0x15, 0x47, 0x1a, 0xf8, 0x00, 0x96, 0x50, 0x10, 
	  0x09, 0xe5, 0x00, 0xa1, 0xb0, 0x0e, 0x6b, 0x48, 
	  0x00, 0x4a, 0xdc, 0x00, 0x1b, 0x12, 0x80, 0xb3, 
	  0x23, 0xff, 0x1b, 0x00, 0x00, 0xe6, 0x00, 0x28, 
	  0x40, 0x2c, 0x28, 0x0b, 0x26, 0xdb, 0x10, 0x01, 
	  0xbc, 0x00, 0xc8, 0xda, 0xf0, 0x01, 0xbc, 0x01, 
	  0x38, 0x00, 0x0a, 0x0a, 0xda, 0x45, 0x08, 0xe6, 
	  0x00, 0x19, 0x84, 0xfe, 0xd7, 0x04, 0x9c, 0x29, 
	  0xbe, 0x00, 0x00, 0x96, 0x50, 0x00, 0x0a, 0x25, 
	  0x00, 0xa5, 0xb7, 0xfe, 0x28, 0x10, 0x01, 0x42, 
	  0x4b, 0xf4, 0x82, 0xb6, 0x9f, 0x30, 0x01, 0x20, 
	  0x39, 0xdc, 0x80, 0x01, 0x2c, 0xa0, 0x20, 0x13, 
	  0xca, 0x01, 0x4b, 0x6f, 0xfc, 0x5e, 0x80, 0x00, 
	  0x16, 0x19, 0xa5, 0x93, 0x6d, 0x88, 0x00, 0xde, 
	  0x00, 0x64, 0x6d, 0x78, 0x00, 0xde, 0x00, 0x9c, 
	  0x00, 0x0a, 0x0a, 0x96, 0x8a, 0x63, 0x6b, 0x35, 
	  0x97, 0x15, 0xa1, 0x64, 0xd7, 0x20, 0x14, 0xb2, 
	  0x80, 0x80, 0x4f, 0x28, 0x05, 0x0d, 0x80, 0x71, 
	  0x41, 0x80, 0x09, 0x5a, 0x80, 0x03, 0x66, 0x00, 
	  0x39, 0x40, 0x59, 0x95, 0xff, 0x6d, 0x30, 0x07, 
	  0x19, 0x8a, 0x66, 0xe2, 0x9d, 0x5e, 0x5b, 0x57, 
	  0x80, 0x25, 0x6a, 0x04, 0x0d, 0x88, 0x0c, 0x25, 
	  0x01, 0x66, 0x57, 0xfe, 0x37, 0xe0, 0x01, 0x2c, 
	  0xa0, 0x20, 0x13, 0xca, 0x01, 0x4b, 0x6f, 0xfa, 
	  0xd6, 0x00, 0xe3, 0x50, 0x25, 0xdc, 0xff, 0xe5, 
	  0x06, 0xdf, 0x46, 0x00, 0x4b, 0x28, 0x08, 0x04, 
	  0xf2, 0x80, 0x52, 0xdb, 0xfe, 0xd6, 0xa0, 0x0e, 
	  0xa0, 0x00, 0x84, 0x9b, 0x67, 0x00, 0x25, 0x8e, 
	  0x07, 0xea, 0x79, 0x40, 0x28, 0x6c, 0x03, 0x7a, 
	  0xe8, 0x01, 0xc4, 0x00, 0xa6, 0x00, 0x0a, 0x0b, 
	  0x0a, 0x02, 0xcf, 0x38, 0xd8, 0x80, 0x04, 0xb2, 
	  0x80, 0x80, 0x4f, 0x28, 0x05, 0x2d, 0xbf, 0xef, 
	  0x76, 0x00, 0x3a, 0x80, 0x02, 0x12, 0x71, 0xaf, 
	  0x80, 0x09, 0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 
	  0x1b, 0x00, 0xe6, 0xb4, 0x80, 0x04, 0xad, 0xc0, 
	  0x01, 0xb1, 0x28, 0x0b, 0x32, 0x3f, 0xf1, 0xb0, 
	  0x00, 0x0e, 0xa0, 0x01, 0x71, 0x80, 0x00, 0x0a, 
	  0x0a, 0xc6, 0xe4, 0xb8, 0xdf, 0x6e, 0x00, 0x4b, 
	  0x28, 0x08, 0x04, 0xf1, 0x02, 0x82, 0x4a, 0x19, 
	  0x03, 0x0f, 0xfb, 0x50, 0x80, 0x39, 0x80, 0x05, 
	  0x51, 0xae, 0x00, 0x09, 0x64, 0x81, 0xfe, 0x9e, 
	  0x50, 0x0a, 0x1a, 0x00, 0xde, 0xdc, 0x00, 0x4a, 
	  0xd0, 0x00, 0x2b, 0x12, 0x80, 0xb3, 0x2b, 0xfe, 
	  0xdb, 0x80, 0x0e, 0x60, 0x02, 0xf4, 0x4e, 0x59, 
	  0xbc, 0x14, 0xbc, 0x72, 0x2b, 0xca, 0xc0, 0x4e, 
	  0x72, 0x0a, 0x03, 0x11, 0x1c, 0xc0, 0x02, 0x78, 
	  0xde, 0x98, 0x00, 0x4a, 0xd4, 0x00, 0x1b, 0x30, 
	  0x01, 0xca, 0x02, 0xcc, 0xaf, 0xfb, 0x6e, 0x00, 
	  0x39, 0x80, 0x0b, 0xd1, 0x32, 0x1c, 0xc1, 0xee, 
	  0xc4, 0xaa, 0x72, 0x2b, 0x01, 0x39, 0xd0, 0x24, 
	  0x0c, 0x42, 0x73, 0x00, 0x09, 0xfb, 0x7a, 0x60, 
	  0x01, 0x2b, 0x50, 0x00, 0x6c, 0xc0, 0x07, 0x28, 
	  0x0b, 0x32, 0xbf, 0xed, 0xb8, 0x00, 0xe6, 0x00, 
	  0x2e, 0x54, 0xff, 0x09, 0xcd, 0x0b, 0xd3, 0x35, 
	  0xb8, 0x05, 0xf1, 0xac, 0xb4, 0xd1, 0xd2, 0x79, 
	  0x3f, 0x02, 0xdd, 0x82, 0xff, 0x4d, 0x49, 0xff, 
	  0x74, 0x9b, 0x2e, 0x73, 0x79, 0xd1, 0xed, 0xfe, 
	  0x92, 0x00, 0x0a, 0x0a, 0xca, 0xa4, 0xb8, 0xdf, 
	  0x6e, 0x00, 0x4b, 0x28, 0x08, 0x04, 0xf2, 0x80, 
	  0x52, 0xdb, 0xfe, 0xd4, 0x20, 0x0e, 0x60, 0x01, 
	  0x54, 0x6d, 0x9e, 0x00, 0x96, 0x38, 0x10, 0x29, 
	  0xe5, 0xfe, 0xa1, 0xc8, 0x0e, 0x28, 0x30, 0x01, 
	  0x2b, 0x60, 0x00, 0x2c, 0x4a, 0x02, 0xcc, 0xaf, 
	  0xfb, 0x6b, 0x00, 0x38, 0x80, 0x10, 0x24, 0xc8, 
	  0x35, 0x42, 0xfd, 0x31, 0xa6, 0xeb, 0xc4, 0xca, 
	  0x17, 0x2d, 0xdf, 0xb3, 0x2b, 0x80, 0x18, 0x93, 
	  0xc6, 0xd4, 0xbd, 0x93, 0x26, 0x1f, 0x81, 0x2c, 
	  0xf1, 0x00, 0x1f, 0x0d, 0xb7, 0x40, 0x12, 0xca, 
	  0x02, 0x01, 0x3c, 0xa0, 0x14, 0x36, 0x01, 0xbd, 
	  0xb4, 0x00, 0x95, 0xa8, 0x00, 0x36, 0x60, 0x03, 
	  0x94, 0x05, 0x99, 0x5f, 0xf6, 0xde, 0x00, 0x71, 
	  0x00, 0x20, 0x2a, 0x3e, 0x8c, 0x0a, 0xde, 0xfa, 
	  0x26, 0xa1, 0xff, 0xbb, 0x2d, 0x9b, 0x10, 0xa2, 
	  0xc9, 0x63, 0x7f, 0xf2, 0xe0, 0x00, 0x0a, 0x0a, 
	  0xd2, 0xc4, 0x9c, 0xa2, 0x5b, 0x0a, 0xbd, 0x96, 
	  0x6a, 0x80, 0x9d, 0x9c, 0x69, 0x42, 0x4a, 0x1a, 
	  0x3f, 0x68, 0x29, 0x9b, 0x28, 0xf6, 0xa5, 0xd9, 
	  0x6b, 0xd9, 0xc2, 0x00, 0xad, 0x2c, 0x4e, 0xca, 
	  0x15, 0xb0, 0x80, 0x21, 0x56, 0xa8, 0xf7, 0x14, 
	  0xaa, 0xa0, 0x20, 0xa2, 0xa6, 0xf8, 0x7d, 0xea, 
	  0xbe, 0x80, 0x8a, 0xaf, 0x56, 0xbd, 0xdc, 0x20, 
	  0x00, 0x0a, 0x0a, 0xc8, 0xc4, 0xb8, 0xdf, 0x46, 
	  0x00, 0x4b, 0x28, 0x08, 0x04, 0xf0, 0x86, 0x14, 
	  0xa0, 0xd2, 0x33, 0xff, 0xb5, 0xa8, 0x03, 0xa8, 
	  0x00, 0x21, 0x26, 0xd9, 0xa0, 0x09, 0x64, 0x00, 
	  0xfc, 0xa2, 0x50, 0x0a, 0x5b, 0x7f, 0xe2, 0xc3, 
	  0x00, 0x12, 0xb6, 0x02, 0x02, 0xbc, 0xa0, 0x2c, 
	  0x4a, 0x01, 0xbe, 0x68, 0x00, 0xe2, 0x00, 0x40, 
	  0x13, 0xa2, 0x18, 0x6e, 0x6f, 0xed, 0x0c, 0x8f, 
	  0xc0, 0x10, 0xcf, 0x54, 0x7c, 0x33, 0xcc, 0xdb, 
	  0xee, 0xcf, 0x30, 0xfe, 0x5c, 0x97, 0x51, 0xe9, 
	  0x1a, 0x46, 0xff, 0xe5, 0x58, 0x15, 0xa8, 0x49, 
	  0xd9, 0x42, 0x92, 0x0f, 0x03, 0x6a, 0x05, 0x1f, 
	  0x0a, 0x6b, 0x5d, 0x83, 0xb4, 0x56, 0xbf, 0x27, 
	  0xbf, 0x63, 0x50, 0x10, 0xd8, 0xca, 0x5f, 0xc1, 
	  0x84, 0x00, 0x0a, 0x0a, 0xdc, 0xc5, 0x62, 0x9e, 
	  0xf7, 0x3a, 0x90, 0x80, 0x28, 0x9a, 0x02, 0x3f, 
	  0x71, 0x87, 0xa0, 0x24, 0x61, 0x99, 0x60, 0x82, 
	  0x77, 0x10, 0x0d, 0x05, 0x3d, 0xe6, 0x00, 0x90, 
	  0x06, 0xf9, 0xf0, 0x02, 0x59, 0x40, 0x00, 0x27, 
	  0x80, 0x06, 0x50, 0x0a, 0x5b, 0x7f, 0xe2, 0xc1, 
	  0x00, 0x12, 0xb3, 0x03, 0xf6, 0xbc, 0xa0, 0x2c, 
	  0x4a, 0x01, 0xb6, 0x58, 0x03, 0xa8, 0x00, 0x5e, 
	  0xe6, 0xd7, 0x00, 0x09, 0x59, 0x81, 0xfb, 0x5e, 
	  0x50, 0x16, 0x65, 0x7f, 0xdf, 0x46, 0x00, 0x6f, 
	  0x00, 0x2a, 0x81, 0x5a, 0x34, 0x9d, 0x94, 0x29, 
	  0x20, 0xf0, 0x36, 0xa0, 0x51, 0xf1, 0x26, 0xb5, 
	  0xd0, 0x3b, 0x45, 0x69, 0xf2, 0x7c, 0x16, 0x35, 
	  0x01, 0x05, 0x8a, 0xa6, 0x7c, 0x38, 0x40, 0x00, 
	  0x0a, 0x0a, 0xcf, 0xa4, 0xb8, 0xdf, 0x14, 0x00, 
	  0x4b, 0x2c, 0x17, 0xf4, 0xd2, 0x81, 0x50, 0xd4, 
	  0x06, 0xf4, 0xe0, 0x03, 0x98, 0x00, 0x55, 0x1b, 
	  0xe7, 0x40, 0x09, 0x65, 0x82, 0xfe, 0x9a, 0x50, 
	  0x2a, 0x1a, 0x80, 0xe6, 0x9e, 0x00, 0x04, 0xad, 
	  0x3f, 0x02, 0xb5, 0x2f, 0xeb, 0x33, 0x3f, 0xf1, 
	  0xa7, 0x80, 0x0e, 0x20, 0x04, 0x89, 0x42, 0x01, 
	  0x85, 0x0a, 0x9f, 0xd4, 0x88, 0xf8, 0x98, 0x12, 
	  0x2a, 0x0a, 0xc4, 0xca, 0xa4, 0x9b, 0x05, 0xf1, 
	  0xa5, 0x67, 0x1c, 0x66, 0x1a, 0xbf, 0x2a, 0x7f, 
	  0xa0, 0xec, 0xca, 0x0b, 0x35, 0x0a, 0xd2, 0x47, 
	  0x4c, 0xd8, 0xcb, 0x4b, 0x44, 0xb0, 0x11, 0xc4, 
	  0x11, 0x14, 0xf8, 0xa0, 0x4c, 0x61, 0xb7, 0xbf, 
	  0xfd, 0x2e, 0x00, 0x0a, 0x0a, 0xda, 0xe4, 0xfe, 
	  0x9f, 0x35, 0xa1, 0xac, 0x7f, 0x68, 0xb2, 0x01, 
	  0x3f, 0xb8, 0xd5, 0x9b, 0xf9, 0x8d, 0x48, 0xee, 
	  0x71, 0xe8, 0xb9, 0x8e, 0x12, 0x9d, 0x2e, 0x0f, 
	  0x20, 0x89, 0xe6, 0x52, 0x33, 0x02, 0x4b, 0xa3, 
	  0xec, 0x2b, 0x6e, 0x40, 0x36, 0x8b, 0x8b, 0xf1, 
	  0xf8, 0xb6, 0x7c, 0xe0, 0x94, 0xbf, 0xab, 0xda, 
	  0xfb, 0x2d, 0x70, 0x00, 0x5b, 0x6f, 0x00, 0x29, 
	  0xa5, 0xfe, 0xc9, 0x10, 0x48, 0x8c, 0x10, 0x22, 
	  0x70, 0x6f, 0x94, 0xd7, 0x70, 0x35, 0x34, 0x81, 
	  0x54, 0xe7, 0xe3, 0x6b, 0x13, 0xfd, 0x42, 0xcd, 
	  0xf7, 0x02, 0x98, 0x5c, 0xc0, 0x72, 0x34, 0xf7, 
	  0x73, 0xea, 0x78, 0x95, 0x3f, 0x74, 0xf3, 0xff, 
	  0x7f, 0xb3, 0xd7, 0x1d, 0xf7, 0x6c, 0xcb, 0x06, 
	  0xc8, 0x19, 0xb3, 0x84, 0xae, 0x2f, 0x0f, 0x8c, 
	  0xee, 0xd0, 0x58, 0x65, 0x23, 0x28, 0x55, 0xe8, 
	  0xff, 0xca, 0x9c, 0x00, 0x19, 0x5b, 0xc0, 0x17, 
	  0x69, 0x7f, 0xc5, 0xb3, 0xf6, 0x5b, 0x01, 0x80, 
	  0x38, 0xce, 0x04, 0x00, 0x0a, 0x0a, 0xcb, 0xe4, 
	  0xb8, 0xde, 0x00, 0x8c, 0x4a, 0x06, 0x65, 0x70, 
	  0x92, 0xd7, 0xfa, 0x05, 0x9e, 0xf0, 0x03, 0xa3, 
	  0x7d, 0x88, 0x01, 0x2c, 0x70, 0x20, 0x53, 0xcb, 
	  0xfd, 0x4b, 0x9f, 0xfb, 0xd3, 0xc0, 0x0e, 0x60, 
	  0x01, 0x11, 0x50, 0x04, 0x9d, 0x69, 0x18, 0x15, 
	  0x2b, 0x40, 0x0e, 0x3c, 0x4e, 0xfd, 0xea, 0x89, 
	  0x75, 0xd2, 0xfc, 0xbb, 0x7b, 0xdc, 0x56, 0x1a, 
	  0x31, 0xdc, 0x31, 0x54, 0xfa, 0x81, 0x95, 0xf4, 
	  0x2d, 0x2c, 0x51, 0x52, 0x80, 0x4f, 0x2c, 0xfc, 
	  0x7f, 0x2b, 0xdc, 0xc0, 0x05, 0xe2, 0xe2, 0xd8, 
	  0x00, 0x12, 0xb5, 0x02, 0x06, 0xc4, 0x06, 0x12, 
	  0x80, 0xb3, 0x2b, 0xff, 0x19, 0x40, 0x00, 0x00, 
	  0x0a, 0x0a, 0xdb, 0x80, 0x00, 0xde, 0x92, 0x00, 
	  0x4a, 0xd8, 0x00, 0x0b, 0x30, 0x01, 0xca, 0x02, 
	  0xcc, 0xaf, 0xfb, 0x6f, 0x80, 0x39, 0x80, 0x0a, 
	  0x11, 0xbe, 0x34, 0x00, 0x96, 0x38, 0x10, 0x29, 
	  0xe5, 0xfe, 0xa5, 0xcf, 0xfd, 0xe9, 0x60, 0x07, 
	  0x30, 0x00, 0x84, 0xa7, 0xad, 0x2d, 0x66, 0xc0, 
	  0x19, 0xea, 0x7f, 0x0f, 0x6d, 0x6b, 0x98, 0x00, 
	  0xb3, 0xdb, 0xe9, 0x80, 0x09, 0x65, 0x01, 0x00, 
	  0x9e, 0x50, 0x0a, 0x5b, 0x7f, 0xda, 0xc8, 0x01, 
	  0xcc, 0x00, 0x21, 0x2a, 0x01, 0x13, 0xe5, 0x01, 
	  0x03, 0x27, 0x62, 0xff, 0xd4, 0xb5, 0xed, 0xe0, 
	  0x44, 0x20, 0x00, 0x0a, 0x0a, 0xd5, 0x00, 0x00, 
	  0xe6, 0x53, 0x28, 0x46, 0xd5, 0x20, 0x09, 0x5a, 
	  0x81, 0x03, 0x62, 0x03, 0x09, 0x40, 0x59, 0x95, 
	  0xff, 0x8d, 0xa0, 0x00, 0x4b, 0x28, 0x08, 0x04, 
	  0xf2, 0x80, 0x52, 0xdb, 0xfe, 0xf4, 0x40, 0x03, 
	  0x9e, 0xda, 0x55, 0x1a, 0xed, 0x00, 0xe7, 0xb5, 
	  0x2a, 0xd6, 0xf4, 0x17, 0xfa, 0x57, 0x00, 0x40, 
	  0x57, 0x94, 0x05, 0x99, 0x1f, 0xf8, 0xda, 0x40, 
	  0x04, 0xb2, 0x80, 0x80, 0x4f, 0x08, 0x61, 0x4a, 
	  0x0d, 0x23, 0x3f, 0xfb, 0x54, 0x80, 0x39, 0x95, 
	  0x05, 0xf1, 0xbd, 0x18, 0x00, 0x00, 0x0a, 0x0a, 
	  0xdb, 0x90, 0x00, 0xe6, 0x29, 0xa8, 0x46, 0xb4, 
	  0xc0, 0x25, 0x6a, 0x04, 0x0d, 0x88, 0x0c, 0x25, 
	  0x01, 0x66, 0x57, 0xfd, 0xf2, 0x20, 0x04, 0xb2, 
	  0x80, 0x80, 0x4f, 0x28, 0x05, 0x2d, 0xbf, 0xed, 
	  0x64, 0x00, 0xe7, 0xdd, 0x94, 0x47, 0x1d, 0x3a, 
	  0x02, 0xdb, 0x34, 0x01, 0xc7, 0x54, 0x7f, 0xb9, 
	  0xf7, 0x0a, 0xf5, 0xb5, 0xab, 0xfa, 0x56, 0xc0, 
	  0x40, 0x57, 0x94, 0x05, 0x99, 0x5f, 0xf7, 0xc8, 
	  0x80, 0x12, 0xca, 0x02, 0x01, 0x3c, 0x21, 0x85, 
	  0x28, 0x34, 0x8c, 0xff, 0xeb, 0x4c, 0x03, 0x98, 
	  0xa8, 0x5f, 0x1b, 0x59, 0x80, 0x39, 0x8b, 0x2b, 
	  0xf5, 0xcc, 0x5b, 0x20, 0x6d, 0xac, 0x80, 0x00, 
	  0x00, 0x0a, 0x0a, 0xd4, 0x96, 0x4a, 0xe2, 0xa3, 
	  0x57, 0xd9, 0xdc, 0x09, 0x5a, 0x81, 0x03, 0x62, 
	  0x03, 0x09, 0x40, 0x59, 0x95, 0xff, 0x7c, 0x90, 
	  0x01, 0x2c, 0xa0, 0x20, 0x13, 0xca, 0x01, 0x4b, 
	  0x6f, 0xfb, 0x58, 0x00, 0x38, 0xdd, 0xc8, 0x67, 
	  0x1b, 0xd2, 0xf6, 0xda, 0xb9, 0xfd, 0x2b, 0x60, 
	  0x20, 0x2b, 0xca, 0x02, 0xbc, 0xa0, 0x3b, 0xe4, 
	  0x40, 0x09, 0x65, 0x01, 0x00, 0x9e, 0x50, 0x0a, 
	  0x5b, 0x7f, 0xce, 0xe0, 0x71, 0x51, 0x94, 0x2e, 
	  0x34, 0x82, 0xcd, 0xa6, 0xe0, 0x25, 0x94, 0x04, 
	  0x02, 0x79, 0x40, 0x28, 0x6c, 0x03, 0x8a, 0x14, 
	  0x00, 0x4a, 0xd8, 0x00, 0x0b, 0x12, 0x80, 0xb3, 
	  0x2b, 0xfe, 0xfb, 0xc0, 0x03, 0x8a, 0x75, 0x6a, 
	  0x71, 0x4d, 0x92, 0xad, 0xf7, 0xe0, 0x14, 0xb2, 
	  0x80, 0x80, 0x4f, 0x28, 0x05, 0x0d, 0x80, 0x71, 
	  0x42, 0x00, 0x09, 0x5a, 0x80, 0x03, 0x66, 0x00, 
	  0x39, 0x40, 0x59, 0x95, 0xff, 0x4d, 0xc0, 0x71, 
	  0xa4, 0x29, 0xa0, 0x00, 0x0a, 0x0a, 0xd1, 0xa0, 
	  0x00, 0xe3, 0xb9, 0x25, 0x9b, 0xe0, 0x40, 0x09, 
	  0x65, 0x00, 0x00, 0xa2, 0x50, 0x0a, 0x5b, 0x7f, 
	  0xe2, 0xe9, 0x00, 0x12, 0xb5, 0x02, 0x06, 0xbc, 
	  0xa0, 0x2c, 0x4a, 0x01, 0xbe, 0xfc, 0x00, 0xea, 
	  0x40, 0x17, 0xb9, 0xa5, 0xc0, 0x25, 0x6a, 0x04, 
	  0x0d, 0x88, 0x0c, 0x25, 0x01, 0x66, 0x57, 0xfd, 
	  0xf2, 0x40, 0x04, 0xb2, 0x80, 0x80, 0x4f, 0x28, 
	  0x05, 0x2d, 0xbf, 0xed, 0x6c, 0x00, 0xe7, 0xaf, 
	  0x94, 0xf7, 0x3d, 0x71, 0x59, 0x36, 0xb4, 0x7f, 
	  0x4a, 0xd8, 0x08, 0x0a, 0xf2, 0x80, 0xb3, 0x2b, 
	  0xfe, 0xf8, 0xd0, 0x02, 0x59, 0x40, 0x40, 0x27, 
	  0x94, 0x02, 0x96, 0xdf, 0xf5, 0xa0, 0x01, 0xcc, 
	  0xbc, 0x2f, 0x80, 0x00, 0x0a, 0x0a, 0xdd, 0xb4, 
	  0xb8, 0xe7, 0x4e, 0x80, 0x06, 0xf0, 0x03, 0x1a, 
	  0x5f, 0xed, 0x94, 0x80, 0x95, 0x38, 0x00, 0x32, 
	  0xb6, 0x80, 0x45, 0x73, 0x40, 0x00, 0x03, 0x9d, 
	  0xa6, 0x56, 0x5b, 0x40, 0x11, 0xb9, 0xae, 0xe0, 
	  0x01, 0xbc, 0x01, 0x3e, 0x97, 0xfc, 0xab, 0x20, 
	  0x25, 0xae, 0x00, 0x0b, 0x6d, 0xa0, 0x0e, 0x5c, 
	  0xee, 0x90, 0x00, 0xe6, 0x98, 0x2a, 0x76, 0xd0, 
	  0x0b, 0xa0, 0x00, 0x0a, 0x0a, 0xd4, 0x04, 0x1a, 
	  0x98, 0x26, 0x49, 0xa7, 0xba, 0x56, 0xdf, 0x7f, 
	  0x59, 0x97, 0xf5, 0xaa, 0x5f, 0xa7, 0xa5, 0x04, 
	  0x7e, 0x0c, 0x1e, 0x20, 0x02, 0xb5, 0x37, 0xdb, 
	  0xa4, 0x78, 0x74, 0xb4, 0x01, 0x80, 0x4f, 0x28, 
	  0x05, 0x2c, 0x00, 0xcc, 0xe2, 0x20, 0x0a, 0xe5, 
	  0xc4, 0x00, 0x56, 0x67, 0x08, 0x30, 0x96, 0xc1, 
	  0x19, 0x57, 0x7e, 0x05, 0x6a, 0x50, 0x56, 0x65, 
	  0x7d, 0x9a, 0x5f, 0xbb, 0xde, 0x47, 0x88, 0x01, 
	  0x53, 0xcc, 0x0f, 0x23, 0x4b, 0x87, 0x32, 0xde, 
	  0x27, 0xcc, 0x87, 0x10, 0x02, 0xa6, 0x00, 0x0a, 
	  0x0b, 0x0a, 0x02, 0xdf, 0xa5, 0xff, 0x2e, 0xcf, 
	  0xf9, 0x6c, 0x00, 0x00, 0xdb, 0xa8, 0x00, 0x2a, 
	  0x24, 0xa0, 0x1b, 0x28, 0x01, 0x2a, 0x70, 0x00, 
	  0x65, 0x75, 0x00, 0x0a, 0xbc, 0x00, 0x0a, 0x0a, 
	  0xd1, 0x80, 0x26, 0x9b, 0xdd, 0xba, 0x5c, 0x4a, 
	  0x59, 0x20, 0xc1, 0xa7, 0x94, 0x0a, 0x65, 0xe0, 
	  0xa7, 0x5a, 0xfb, 0xc2, 0x33, 0xee, 0x20, 0x05, 
	  0x4f, 0x30, 0x2c, 0x63, 0x8f, 0x94, 0xac, 0x3e, 
	  0x80, 0xb3, 0x28, 0x0b, 0x14, 0x3f, 0x4d, 0x1f, 
	  0xe3, 0xf7, 0x1b, 0xc4, 0x00, 0xa9, 0xa7, 0xf7, 
	  0xcf, 0xe9, 0x7e, 0xf9, 0x68, 0x82, 0xfe, 0x9a, 
	  0x5f, 0xa9, 0xdb, 0x83, 0x99, 0xa4, 0x48, 0x25, 
	  0xbb, 0x88, 0x00, 0xad, 0x4d, 0xf0, 0xe0, 0xb8, 
	  0x79, 0x35, 0x21, 0xe8, 0x43, 0x7f, 0x10, 0x01, 
	  0x5a, 0x00, 0x0a, 0x0a, 0xde, 0x85, 0x68, 0x8e, 
	  0xa0, 0xc1, 0x65, 0xe6, 0x23, 0x32, 0x99, 0xad, 
	  0x5b, 0x2e, 0x40, 0xa2, 0xb0, 0xc0, 0x9b, 0x88, 
	  0x02, 0x56, 0x8a, 0x69, 0x8a, 0xbd, 0x2f, 0x29, 
	  0x28, 0xe6, 0x40, 0x25, 0xa4, 0x02, 0xb9, 0x89, 
	  0x69, 0x9b, 0x98, 0xf6, 0x6c, 0x64, 0x70, 0x21, 
	  0x99, 0x42, 0x21, 0x44, 0x0e, 0x36, 0x85, 0x78, 
	  0x8c, 0xfa, 0x4d, 0x66, 0x52, 0x91, 0x25, 0xed, 
	  0x91, 0x3d, 0x98, 0x02, 0x63, 0x10, 0x34, 0x93, 
	  0xf9, 0xd1, 0x07, 0x81, 0xd0, 0x2a, 0x44, 0x85, 
	  0x53, 0xf9, 0x1a, 0x01, 0xad, 0xe6, 0x40, 0xe7, 
	  0x48, 0xa8, 0x95, 0x94, 0x30, 0x19, 0xe5, 0xf9, 
	  0x7e, 0xe7, 0xdc, 0x20, 0x00, 0x0a, 0x0a, 0xd0, 
	  0x61, 0x42, 0x87, 0xa0, 0xa4, 0xf9, 0x50, 0x47, 
	  0x98, 0x19, 0x21, 0x20, 0x1a, 0x64, 0xaf, 0xa0, 
	  0x6b, 0x89, 0x00, 0xd3, 0xeb, 0x39, 0xfd, 0xca, 
	  0xe9, 0x2f, 0xe9, 0x16, 0x80, 0x4b, 0x5f, 0xf7, 
	  0xf7, 0x5c, 0xfe, 0xe2, 0x8c, 0x05, 0x69, 0x9a, 
	  0xc3, 0x4c, 0xc5, 0xf0, 0x11, 0x49, 0x37, 0xc5, 
	  0x0c, 0xf7, 0xae, 0x99, 0x80, 0x9a, 0x74, 0x2f, 
	  0xdd, 0x7e, 0x60, 0x95, 0xc6, 0x30, 0x8d, 0x2d, 
	  0x00, 0x00, 0x0a, 0x0a, 0xd1, 0x84, 0x1c, 0x9a, 
	  0x54, 0x63, 0x28, 0x9e, 0x2a, 0x3b, 0x49, 0xeb, 
	  0xe6, 0xef, 0xcb, 0x0a, 0x80, 0x61, 0x36, 0x4f, 
	  0x03, 0xad, 0xe0, 0x07, 0x14, 0xbf, 0xda, 0xa9, 
	  0x01, 0x12, 0x02, 0x04, 0xa7, 0xfd, 0x01, 0xa3, 
	  0xbc, 0x01, 0x1a, 0x94, 0xff, 0xf4, 0x1e, 0xa7, 
	  0x66, 0xf5, 0x43, 0xda, 0xe9, 0x7e, 0xda, 0xbb, 
	  0xfa, 0x2a, 0x0b, 0x28, 0xee, 0x18, 0x36, 0x7c, 
	  0xe9, 0x32, 0xf2, 0x04, 0x8e, 0xe0, 0xb8, 0x28, 
	  0xb8, 0x3e, 0xef, 0xa2, 0xf2, 0xa0, 0x17, 0xba, 
	  0x92, 0x9f, 0xb2, 0x76, 0x58, 0x24, 0x3a, 0x89, 
	  0x94, 0x2a, 0xf4, 0x7f, 0xe5, 0x4e, 0x04, 0x0c, 
	  0x7d, 0xa0, 0x10, 0xd2, 0xfe, 0x9f, 0x63, 0xfc, 
	  0xb8, 0x40, 0xf7, 0x43, 0x35, 0xee, 0x4c, 0xe7, 
	  0x94, 0x95, 0x7b, 0x58, 0x1b, 0xc0, 0x12, 0xc9, 
	  0x7f, 0xca, 0xb2, 0x02, 0x5a, 0xe0, 0x00, 0xb6, 
	  0xde, 0x00, 0x69, 0x00, 0x0a, 0x0a, 0x97, 0x0e, 
	  0xc2, 0x73, 0x7d, 0xc4, 0x03, 0x2f, 0x97, 0xfd, 
	  0x0e, 0xf1, 0xb7, 0xac, 0xbf, 0xd2, 0xb5, 0x00, 
	  0x06, 0xcc, 0x06, 0x12, 0x80, 0xaf, 0x28, 0x0e, 
	  0xf9, 0xe0, 0x02, 0x4e, 0xa5, 0xfb, 0x79, 0xf9, 
	  0x75, 0x00, 0x3f, 0x6a, 0x70, 0x9d, 0x29, 0x6b, 
	  0xee, 0x99, 0x6b, 0xf9, 0x1d, 0x2e, 0x34, 0xa9, 
	  0x4b, 0x90, 0xd4, 0x8b, 0x12, 0x26, 0x36, 0xf8, 
	  0x90, 0x13, 0xe4, 0x73, 0x61, 0x25, 0x97, 0xee, 
	  0x28, 0xb3, 0x26, 0xa8, 0xb2, 0x94, 0x00, 0xa3, 
	  0x01, 0x05, 0xbe, 0xb4, 0x0a, 0x7f, 0xd9, 0x00, 
	  0x76, 0xb8, 0xdf, 0x3e, 0x01, 0x4b, 0x28, 0x08, 
	  0x04, 0xf2, 0x80, 0x52, 0xdb, 0xfe, 0xf6, 0xa0, 
	  0x02, 0x50, 0xeb, 0x00, 0xb8, 0xa3, 0xea, 0x4f, 
	  0x35, 0xe0, 0xba, 0x5a, 0xa0, 0xff, 0xa3, 0x94, 
	  0x02, 0x86, 0xc0, 0x39, 0xa8, 0x60, 0x01, 0x3a, 
	  0x67, 0xe0, 0x0f, 0xab, 0x4b, 0xfa, 0xbd, 0xaf, 
	  0xb2, 0xda, 0xff, 0xf1, 0x7c, 0xde, 0xac, 0x96, 
	  0x20, 0x9c, 0x60, 0xc0, 0x00, 0x00, 0x0a, 0x0b, 
	  0x10, 0xb3, 0x29, 0x25, 0x43, 0xbb, 0xee, 0xa9, 
	  0x7d, 0xdd, 0xbb, 0xee, 0x3b, 0x02, 0x27, 0x8a, 
	  0xcb, 0x0f, 0x9c, 0x82, 0x47, 0x12, 0x40, 0xa0, 
	  0x4b, 0x4a, 0x15, 0x32, 0x30, 0x91, 0x30, 0x3f, 
	  0x44, 0xda, 0xf7, 0x9d, 0x1a, 0xe6, 0xdf, 0xae, 
	  0x40, 0x00, 0x0a, 0x0a, 0xd4, 0x06, 0x20, 0xe2, 
	  0x84, 0x00, 0x12, 0xad, 0xff, 0xf6, 0xac, 0xa0, 
	  0xed, 0xd3, 0x03, 0xbe, 0x28, 0x00, 0xe2, 0xa4, 
	  0x44, 0x1a, 0xd8, 0x00, 0x95, 0xa8, 0x10, 0x35, 
	  0xe5, 0x01, 0x66, 0x57, 0xfd, 0xf2, 0x40, 0x04, 
	  0xb2, 0x80, 0x80, 0x4f, 0x28, 0x05, 0x2d, 0xbf, 
	  0xed, 0x4e, 0x00, 0xe3, 0x69, 0x38, 0x5c, 0x6d, 
	  0x29, 0x03, 0x6a, 0x77, 0xf4, 0xad, 0x80, 0x80, 
	  0xaf, 0x28, 0x0b, 0x32, 0xbf, 0xef, 0x92, 0x00, 
	  0x25, 0x94, 0x04, 0x02, 0x79, 0x40, 0x29, 0x6d, 
	  0xff, 0x5b, 0x00, 0x1c, 0x54, 0x87, 0x9b, 0x7c, 
	  0x63, 0xf5, 0x2d, 0x0f, 0xe1, 0x12, 0xcb, 0xf9, 
	  0x5a, 0xe0, 0x3c, 0x50, 0x40, 0x03, 0x68, 0x03, 
	  0xc7, 0x1b, 0xf0, 0x00, 0x96, 0x97, 0xf0, 0x49, 
	  0x65, 0xfc, 0xad, 0x70, 0x1e, 0x28, 0x20, 0x01, 
	  0xbc, 0x00, 0xc8, 0xdf, 0x54, 0x00, 0x4b, 0x28, 
	  0x08, 0x04, 0xf2, 0x80, 0x50, 0xd8, 0x07, 0x16, 
	  0xa8, 0x00, 0x95, 0xa8, 0x00, 0x36, 0x60, 0x03, 
	  0x94, 0x05, 0x99, 0x5f, 0xf7, 0xd4, 0x80, 0x1b, 
	  0xc0, 0x13, 0x8e, 0x28, 0x40, 0x01, 0x2a, 0xbf, 
	  0xff, 0xea, 0xca, 0x06, 0xdd, 0x50, 0x3c, 0x6f, 
	  0x80, 0x03, 0x68, 0x04, 0x40, 0x00, 0x0a, 0x0a, 
	  0xd4, 0x05, 0x1c, 0xde, 0x00, 0xa4, 0x4e, 0x0d, 
	  0x94, 0xb6, 0x7e, 0xb2, 0x1e, 0x02, 0xc0, 0xc8, 
	  0xc8, 0x28, 0x09, 0x23, 0x64, 0x13, 0xfc, 0x69, 
	  0xf8, 0xff, 0x08, 0xe8, 0x4a, 0x88, 0x18, 0x4c, 
	  0x32, 0x03, 0x44, 0x7b, 0x4b, 0x53, 0x6c, 0x6f, 
	  0x52, 0x53, 0xed, 0x60, 0x51, 0x74, 0x82, 0xff, 
	  0x4a, 0x37, 0xbc, 0x00, 0xb8, 0xdf, 0x40, 0x00, 
	  0x4b, 0x28, 0x08, 0x04, 0xf2, 0x80, 0x52, 0xdb, 
	  0xfe, 0xf6, 0x00, 0x03, 0x98, 0x00, 0x42, 0x93, 
	  0xfc, 0x9b, 0x13, 0xc0, 0x64, 0x99, 0x01, 0x7f, 
	  0xf2, 0x46, 0x06, 0x1d, 0xcb, 0x1b, 0x7f, 0xd0, 
	  0x30, 0x5e, 0xcb, 0x7c, 0x0f, 0xd4, 0x72, 0x00, 
	  0xbb, 0x05, 0xca, 0x9c, 0x93, 0x91, 0x32, 0x38, 
	  0x23, 0x40, 0xd0, 0x86, 0xfd, 0x40, 0xbd, 0xdd, 
	  0xcc, 0x00, 0x5e, 0x0d, 0xec, 0x20, 0x04, 0xad, 
	  0x40, 0x81, 0xb1, 0x01, 0x84, 0xa0, 0x2c, 0xca, 
	  0xff, 0xbe, 0x7c, 0x00, 0x00, 0x0a, 0x0b, 0x0f, 
	  0xa2, 0xd4, 0x38, 0xca, 0x00, 0x04, 0xf1, 0xc0, 
	  0x9f, 0xb1, 0x9f, 0x2f, 0xf6, 0x66, 0xd4, 0xcf, 
	  0x3c, 0x0b, 0xfd, 0x91, 0xf4, 0x7e, 0xe4, 0x32, 
	  0x3a, 0x50, 0x6f, 0x41, 0x12, 0x28, 0x43, 0xc9, 
	  0x7f, 0xbc, 0x5d, 0x9f, 0xec, 0x88, 0xac, 0x02, 
	  0xb8, 0xd7, 0xc0, 0x06, 0xf0, 0x05, 0xda, 0x5f, 
	  0xf4, 0xac, 0xfe, 0x96, 0xb8, 0x20, 0x2b, 0xb7, 
	  0x80, 0x1b, 0x5c, 0x59, 0x40, 0x02, 0x77, 0x97, 
	  0xc4, 0x1d, 0x2f, 0x94, 0x04, 0x9c, 0xd5, 0x66, 
	  0x58, 0xf7, 0x28, 0xe5, 0x85, 0xe7, 0xa6, 0x46, 
	  0xcf, 0x02, 0xb1, 0xa0, 0x0c, 0xdd, 0x6f, 0x2d, 
	  0xbf, 0x6c, 0x86, 0x15, 0x15, 0xe6, 0xa8, 0x11, 
	  0x75, 0x53, 0x83, 0x6f, 0x4a, 0x1f, 0xa7, 0x15, 
	  0x68, 0x00, 0xde, 0x00, 0x42, 0x4a, 0x01, 0x7a, 
	  0x80, 0x32, 0xa7, 0xfe, 0x06, 0x8e, 0xf0, 0x04, 
	  0xb0, 0x15, 0xb0, 0x0b, 0x79, 0x3b, 0x2c, 0xe6, 
	  0x09, 0x30, 0xcf, 0xfb, 0x27, 0x5d, 0x40, 0xd2, 
	  0x46, 0x17, 0xa1, 0x41, 0x33, 0x3f, 0x3f, 0x9f, 
	  0x61, 0xd3, 0xed, 0x84, 0xba, 0x9e, 0x0f, 0x73, 
	  0x00, 0xea, 0x67, 0x05, 0x6b, 0x11, 0x1f, 0xa9, 
	  0x15, 0x04, 0x5f, 0xe2, 0x4f, 0x6f, 0x9c, 0x7e, 
	  0x3d, 0x57, 0x97, 0x77, 0xa0, 0x09, 0x00, 0x00, 
	  0x0a, 0x0a, 0x98, 0xea, 0xe2, 0x65, 0xa4, 0x57, 
	  0x0f, 0xf9, 0x9b, 0x00, 0x57, 0xae, 0x76, 0xb4, 
	  0x3b, 0x46, 0x95, 0xac, 0xb1, 0xbc, 0xeb, 0xfc, 
	  0xa9, 0x3e, 0x84, 0xb7, 0x27, 0xf5, 0x5b, 0x56, 
	  0xd8, 0x69, 0x49, 0x91, 0x69, 0x80, 0x63, 0xa6, 
	  0x00, 0x95, 0xbc, 0xa1, 0xda, 0xf5, 0x21, 0x22, 
	  0xf5, 0xfb, 0x8c, 0xbf, 0x2c, 0xdc, 0xfb, 0x25, 
	  0x7f, 0x4a, 0xc6, 0xd9, 0xa6, 0x09, 0xa9, 0xf0, 
	  0x63, 0x40, 0xe6, 0x8e, 0xfc, 0xa6, 0x40, 0xdb, 
	  0x31, 0x41, 0x06, 0x04, 0x94, 0x55, 0x58, 0x12, 
	  0xdb, 0x09, 0xf5, 0x24, 0x9e, 0xa4, 0xca, 0x9b, 
	  0x5e, 0x1c, 0x26, 0xbd, 0x59, 0xff, 0x73, 0x9b, 
	  0xfd, 0xad, 0x1d, 0x7f, 0x6c, 0x33, 0x84, 0x94, 
	  0xac, 0x0a, 0x52, 0x83, 0x4a, 0x9c, 0x1c, 0x89, 
	  0x06, 0xcd, 0x10, 0x03, 0xed, 0x6a, 0x8c, 0x05, 
	  0x69, 0x62, 0x5c, 0x4e, 0xdf, 0x0c, 0x04, 0x5d, 
	  0x53, 0xfb, 0x1b, 0xd2, 0x40, 0xa4, 0xf2, 0x2f, 
	  0x6f, 0xba, 0x3b, 0x38, 0x4a, 0x36, 0xde, 0xf3, 
	  0xe1, 0x00, 0x00, 0x0a, 0x0b, 0x07, 0x62, 0xd2, 
	  0x38, 0x88, 0x8f, 0xd4, 0xc0, 0xe9, 0x46, 0xbf, 
	  0xd3, 0x1a, 0x01, 0x04, 0x5b, 0x71, 0x11, 0x20, 
	  0x6d, 0xf0, 0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0d, 
	  0x9a, 0xd2, 0x37, 0xc1, 0x80, 0x1c, 0x51, 0x27, 
	  0x7a, 0x53, 0x2b, 0x92, 0xfe, 0x95, 0xaf, 0xb0, 
	  0xb4, 0x63, 0xfd, 0xbb, 0x6e, 0x3b, 0xa4, 0x7c, 
	  0x0b, 0x06, 0xd2, 0xd2, 0x37, 0xc1, 0x80, 0x1c, 
	  0x51, 0x27, 0x7a, 0x53, 0x2b, 0x92, 0xfe, 0x95, 
	  0xaf, 0xb0, 0xb4, 0x63, 0xfd, 0xbb, 0x6e, 0x3b, 
	  0xa4, 0x7c, 0x00, 0x0a, 0x0a, 0x87, 0xe9, 0x7b, 
	  0x8b, 0x40, 0xc6, 0x48, 0xc2, 0xc9, 0x01, 0x2a, 
	  0x4f, 0xa1, 0x2d, 0xc8, 0x26, 0x53, 0x4d, 0xc6, 
	  0xe2, 0xab, 0xb8, 0xa3, 0xd5, 0x84, 0x8d, 0x47, 
	  0xe5, 0xf2, 0xfc, 0xb9, 0x73, 0xe4, 0x52, 0x12, 
	  0x71, 0xcc, 0x91, 0x7f, 0x19, 0x81, 0x90, 0x05, 
	  0x69, 0x23, 0x2f, 0x71, 0x68, 0x18, 0xd9, 0x18, 
	  0x55, 0x20, 0x25, 0x49, 0xf4, 0x25, 0xb9, 0x04, 
	  0xca, 0x69, 0xb8, 0xdc, 0x55, 0x77, 0x14, 0x7a, 
	  0xb0, 0x91, 0xa8, 0xfc, 0xbe, 0x5f, 0x97, 0x2e, 
	  0x7c, 0x8a, 0x42, 0x4e, 0x39, 0x92, 0x2f, 0xe3, 
	  0x30, 0x32, 0x00, 0x00, 0x0a, 0x0a, 0x87, 0xe9, 
	  0x7b, 0x8b, 0x40, 0xc6, 0x48, 0xc2, 0xc9, 0x01, 
	  0x2a, 0x4f, 0xa1, 0x2d, 0xc8, 0x26, 0x53, 0x4d, 
	  0xc6, 0xe2, 0xab, 0xb8, 0xa3, 0xd5, 0x84, 0x8d, 
	  0x47, 0xe5, 0xf2, 0xfc, 0xb9, 0x73, 0xe4, 0x52, 
	  0x12, 0x71, 0xcc, 0x91, 0x7f, 0x19, 0x81, 0x90, 
	  0x00, 0x0a, 0x0b, 0x10, 0xeb, 0x98, 0x38, 0xcc, 
	  0x53, 0x74, 0x94, 0x57, 0x77, 0xf2, 0xdb, 0x09, 
	  0xf5, 0x24, 0x9e, 0x22, 0xd3, 0xbc, 0x51, 0xc5, 
	  0x4b, 0x8d, 0xc8, 0xa8, 0x49, 0x33, 0x42, 0x1d, 
	  0x28, 0x34, 0xa9, 0x41, 0xc4, 0xc0, 0xfd, 0x21, 
	  0xbe, 0x21, 0x87, 0x16, 0x7a, 0x76, 0x00, 0x0a, 
	  0x0a, 0xca, 0x05, 0x08, 0xde, 0x92, 0x00, 0x4a, 
	  0xd8, 0x08, 0x0a, 0xf2, 0x80, 0xb3, 0x2b, 0xfe, 
	  0xfb, 0x70, 0x03, 0x68, 0x04, 0x84, 0xe0, 0xba, 
	  0xc9, 0xf7, 0xd7, 0x31, 0x30, 0x32, 0x70, 0xf4, 
	  0x8b, 0x8e, 0x07, 0xf0, 0x20, 0x40, 0x89, 0x2a, 
	  0x3e, 0xc0, 0xea, 0x49, 0xfc, 0xd0, 0xe9, 0x2e, 
	  0x0e, 0x95, 0x7b, 0xcb, 0x53, 0xc6, 0x1f, 0xf3, 
	  0xcf, 0x03, 0x9e, 0xe7, 0x86, 0xd0, 0x07, 0x0d, 
	  0xf6, 0x60, 0x04, 0xb2, 0x80, 0x80, 0x4f, 0x08, 
	  0x40, 0xca, 0x05, 0x33, 0x5f, 0xfb, 0xd3, 0x40, 
	  0x0e, 0x60, 0x01, 0x54, 0x6f, 0xad, 0x00, 0x25, 
	  0x94, 0x04, 0x02, 0x78, 0x81, 0x41, 0x25, 0x0c, 
	  0x7d, 0x80, 0x0e, 0x2c, 0x40, 0x01, 0x2b, 0x60, 
	  0x00, 0x2c, 0x4a, 0x02, 0xcc, 0xaf, 0xfb, 0xed, 
	  0xc0, 0x0e, 0x60, 0x02, 0xac, 0x02, 0xb7, 0x81, 
	  0x2e, 0x37, 0xd0, 0x80, 0x12, 0xca, 0x02, 0x01, 
	  0x3c, 0xa0, 0x14, 0xb6, 0xff, 0xb5, 0xb8, 0x03, 
	  0x98, 0x00, 0x55, 0x1b, 0xed, 0x40, 0x09, 0x65, 
	  0x01, 0x00, 0x9e, 0x50, 0x0a, 0x1b, 0x00, 0xe2, 
	  0xc1, 0x00, 0x12, 0xb5, 0x00, 0x06, 0xcc, 0x00, 
	  0x72, 0x80, 0xb3, 0x2b, 0xfe, 0xfb, 0x20, 0x03, 
	  0x98, 0x00, 0xa1, 0x00, 0xb0, 0xf0, 0x2c, 0x9b, 
	  0x6c, 0x40, 0x06, 0xf0, 0x03, 0x23, 0x6b, 0xc0, 
	  0x06, 0xf0, 0x04, 0xe0, 0x00, 0x0a, 0x0a, 0xca, 
	  0x05, 0x08, 0xde, 0x92, 0x00, 0x4a, 0xd8, 0x08, 
	  0x0a, 0xf2, 0x80, 0xb3, 0x2b, 0xfe, 0xfb, 0x70, 
	  0x03, 0x68, 0x04, 0x84, 0xe0, 0xba, 0xc9, 0xef, 
	  0xd7, 0x31, 0x48, 0x2a, 0xc9, 0x1c, 0x02, 0x91, 
	  0xa4, 0x44, 0xfc, 0xa8, 0xfb, 0x03, 0xa9, 0x27, 
	  0xf3, 0x43, 0xa4, 0xb8, 0x7a, 0x54, 0xef, 0x2d, 
	  0x3f, 0x18, 0xbf, 0xcf, 0x3c, 0x0e, 0x7b, 0x9e, 
	  0x1b, 0x40, 0x1c, 0x37, 0xd9, 0x80, 0x12, 0xca, 
	  0x02, 0x01, 0x3c, 0x21, 0x03, 0x28, 0x14, 0xcd, 
	  0x7f, 0xef, 0x4d, 0x00, 0x39, 0x80, 0x05, 0x51, 
	  0xbe, 0xb4, 0x00, 0x96, 0x50, 0x10, 0x09, 0xe2, 
	  0x05, 0x04, 0x94, 0x31, 0xf6, 0x00, 0x38, 0xb1, 
	  0x00, 0x04, 0xad, 0x00, 0x02, 0xb1, 0x28, 0x0b, 
	  0x32, 0xbf, 0xef, 0xb7, 0x00, 0x39, 0x80, 0x0a, 
	  0xb0, 0x0b, 0x0f, 0x02, 0xcf, 0x37, 0xd0, 0x80, 
	  0x12, 0xca, 0x02, 0x01, 0x3c, 0xa0, 0x14, 0xb6, 
	  0xff, 0xb5, 0xb8, 0x03, 0xa8, 0x00, 0x21, 0x26, 
	  0xfb, 0x50, 0x02, 0x59, 0x40, 0x40, 0x27, 0x94, 
	  0x02, 0x86, 0xc0, 0x38, 0xb0, 0xc0, 0x04, 0xad, 
	  0x40, 0x01, 0xb3, 0x00, 0x1c, 0xa0, 0x2c, 0xca, 
	  0xff, 0xbe, 0xc0, 0x00, 0xea, 0x00, 0x17, 0x18, 
	  0x00, 0x0a, 0x0a, 0xdf, 0x55, 0xf8, 0x95, 0xa8, 
	  0x10, 0x36, 0x20, 0x30, 0x94, 0x05, 0x99, 0x5f, 
	  0xf9, 0xcd, 0xc0, 0x01, 0x2c, 0xa0, 0x20, 0x13, 
	  0xca, 0x01, 0x4b, 0x6f, 0xfc, 0xd9, 0x20, 0x00, 
	  0x00, 0x0a, 0x0a, 0xd4, 0x05, 0x08, 0xe2, 0x80, 
	  0x00, 0x12, 0xb8, 0x00, 0x02, 0xc4, 0xa0, 0x2b, 
	  0xc8, 0x03, 0xbe, 0x00, 0x00, 0xe2, 0x00, 0x58, 
	  0xd2, 0xff, 0x97, 0x67, 0xfc, 0xb5, 0xc0, 0x01, 
	  0x6d, 0xc4, 0x00, 0x4f, 0xb8, 0xdf, 0xc0, 0x04, 
	  0x13, 0x91, 0x4f, 0x66, 0xc9, 0x58, 0xa0, 0x83, 
	  0x25, 0xa6, 0xfe, 0xac, 0xa0, 0x14, 0x36, 0x01, 
	  0xc5, 0x02, 0x00, 0x39, 0x80, 0x06, 0x81, 0x2f, 
	  0xf6, 0xca, 0x40, 0x4a, 0x9c, 0x00, 0x19, 0x5c, 
	  0xc0, 0x04, 0xc0, 0x00, 0x0a, 0x0a, 0xd4, 0x05, 
	  0x08, 0xe2, 0x80, 0x00, 0x12, 0xb8, 0x00, 0x02, 
	  0xc4, 0xa0, 0x2b, 0xc8, 0x03, 0xbe, 0x00, 0x00, 
	  0xe2, 0x00, 0x58, 0xd2, 0xff, 0x97, 0x67, 0xfc, 
	  0xb5, 0xc0, 0x01, 0x6d, 0xc4, 0x00, 0x4f, 0xb8, 
	  0xdf, 0xc0, 0x04, 0x13, 0x91, 0x4f, 0x66, 0xc9, 
	  0x58, 0xa0, 0x83, 0x25, 0xa6, 0xfe, 0xac, 0xa0, 
	  0x14, 0x36, 0x01, 0xc5, 0x02, 0x00, 0x38, 0x80, 
	  0x0d, 0xc7, 0x1b, 0xf8, 0x00, 0x96, 0x50, 0x10, 
	  0x09, 0xe5, 0x00, 0xa5, 0xb7, 0xfe, 0x28, 0x10, 
	  0x01, 0xc4, 0x00, 0x4d, 0x65, 0xfe, 0xdd, 0x48, 
	  0x09, 0x53, 0x80, 0x03, 0x27, 0x88, 0x01, 0x65, 
	  0xf1, 0x40, 0x00, 0x09, 0x5c, 0x01, 0x01, 0x5e, 
	  0x50, 0x16, 0x64, 0x7f, 0xdf, 0x00, 0x00, 0x71, 
	  0x00, 0x24, 0x80, 0x00, 0x0a, 0x0a, 0xd2, 0x75, 
	  0x48, 0x9a, 0x00, 0x2b, 0xd9, 0xe2, 0x70, 0x51, 
	  0xe9, 0x00, 0x0a, 0xd2, 0xa0, 0x13, 0x3f, 0xfb, 
	  0x85, 0xc2, 0xcd, 0xeb, 0x11, 0x03, 0xed, 0xa6, 
	  0xc0, 0x00, 0x0a, 0x0b, 0x0d, 0xc2, 0xe3, 0x36, 
	  0xba, 0x00, 0x4a, 0xc4, 0x00, 0x1b, 0x12, 0xff, 
	  0xb5, 0x3f, 0xf7, 0x19, 0xa0, 0x00, 0xa2, 0x67, 
	  0x05, 0xbe, 0xd4, 0x93, 0x68, 0x02, 0xf4, 0xe0, 
	  0x64, 0xea, 0xd0, 0xaf, 0x39, 0x44, 0x4e, 0x85, 
	  0x04, 0xf3, 0x00, 0x08, 0xc3, 0x7d, 0x18, 0x01, 
	  0x2c, 0xc0, 0x00, 0x14, 0x4a, 0x09, 0x3b, 0x20, 
	  0x3c, 0x50, 0x20, 0x02, 0x56, 0xc0, 0x43, 0x57, 
	  0x97, 0xcd, 0xda, 0x7e, 0xfa, 0x80, 0x05, 0xb2, 
	  0x6f, 0x50, 0x00, 0x3a, 0x80, 0x02, 0x4e, 0x4b, 
	  0x50, 0x2f, 0xc4, 0x72, 0x85, 0x4e, 0xcc, 0x0e, 
	  0xf5, 0xf0, 0x02, 0x56, 0x60, 0x40, 0xd7, 0x97, 
	  0xfd, 0x89, 0xa0, 0x36, 0xc5, 0x00, 0x75, 0x00, 
	  0x0b, 0x64, 0x05, 0x68, 0xc2, 0xcd, 0x4f, 0x0a, 
	  0xec, 0xfc, 0xaa, 0x3b, 0x40, 0x2d, 0xa7, 0x06, 
	  0xd4, 0x9e, 0xbd, 0x8e, 0x20, 0x13, 0xec, 0x00, 
	  0x0a, 0x0a, 0xd2, 0xe5, 0x5e, 0x9e, 0x90, 0x10, 
	  0xf8, 0x2c, 0xa7, 0x08, 0xad, 0x96, 0x61, 0x09, 
	  0xd6, 0x7e, 0xf0, 0x8d, 0x36, 0x7f, 0x75, 0x3e, 
	  0xa5, 0xed, 0xc2, 0x00, 0x00, 0x0a, 0x0a, 0x99, 
	  0xeb, 0x7b, 0x8e, 0xe8, 0xfa, 0x47, 0xc5, 0x81, 
	  0x72, 0x85, 0x6a, 0xd4, 0x2c, 0x8d, 0x02, 0x9c, 
	  0xf1, 0xa2, 0xc9, 0x87, 0x32, 0x45, 0x7b, 0xb8, 
	  0xde, 0xc0, 0x00, 0x00, 0x0a, 0x0a, 0x94, 0xab, 
	  0x7b, 0x8e, 0xe8, 0xe1, 0x47, 0xc5, 0x01, 0x52, 
	  0x85, 0x5e, 0xd4, 0x2c, 0xa9, 0x41, 0x19, 0xa5, 
	  0xc5, 0x12, 0x88, 0xb7, 0xc1, 0x80, 0x00, 0xad, 
	  0x7e, 0x6d, 0xee, 0x3b, 0xa3, 0x85, 0x1f, 0x14, 
	  0x05, 0x4a, 0x15, 0x7b, 0x50, 0xb2, 0xa5, 0x04, 
	  0x66, 0x97, 0x14, 0x4a, 0x22, 0xdf, 0x06, 0x00, 
	  0x00, 0x0a, 0x0b, 0x05, 0x2a, 0xd2, 0x38, 0xee, 
	  0x8e, 0x14, 0x7c, 0x50, 0x15, 0x28, 0x55, 0xed, 
	  0x42, 0xca, 0x94, 0x11, 0x9a, 0x5c, 0x51, 0x28, 
	  0x8b, 0x7c, 0x18, 0x00, 0x0b, 0x0b, 0xf2, 0xd2, 
	  0x38, 0xee, 0x8e, 0x14, 0x7c, 0x50, 0x15, 0x28, 
	  0x55, 0xed, 0x42, 0xca, 0x94, 0x11, 0x9a, 0x5c, 
	  0x51, 0x28, 0x8b, 0x7c, 0x18, 0x00, 0x00, 0x0a, 
	  0x0a, 0xd3, 0x76, 0x60, 0xe3, 0x31, 0x4d, 0xd2, 
	  0x51, 0x5d, 0xdf, 0xcb, 0x6c, 0x27, 0xd4, 0x92, 
	  0x78, 0x8b, 0x4e, 0xf1, 0x47, 0x15, 0x2e, 0x37, 
	  0x22, 0xa1, 0x24, 0xcd, 0x08, 0x74, 0xa0, 0xd2, 
	  0xa5, 0x07, 0x13, 0x03, 0xf4, 0x86, 0xf8, 0x86, 
	  0x1c, 0x59, 0xe9, 0xd8, 0x16, 0x21, 0xd7, 0x30, 
	  0x71, 0x98, 0xa6, 0xe9, 0x28, 0xae, 0xef, 0xe5, 
	  0xb6, 0x13, 0xea, 0x49, 0x3c, 0x45, 0xa7, 0x78, 
	  0xa3, 0x8a, 0x97, 0x1b, 0x91, 0x50, 0x92, 0x66, 
	  0x84, 0x3a, 0x50, 0x69, 0x52, 0x83, 0x89, 0x81, 
	  0xfa, 0x43, 0x7c, 0x43, 0x0e, 0x2c, 0xf4, 0xec, 
	  0x00, 0x0a, 0x0a, 0x58, 0xd5, 0x89, 0xa9, 0x82, 
	  0x3e, 0x17, 0x26, 0x09, 0x59, 0x5d, 0x09, 0x99, 
	  0x63, 0xdc, 0x2a, 0x9e, 0x6f, 0x7a, 0x4a, 0x3f, 
	  0x8c, 0x20, 0x0a, 0xd2, 0xb7, 0x58, 0x9a, 0x98, 
	  0x2b, 0xe1, 0x6a, 0x60, 0x85, 0x95, 0xa0, 0x99, 
	  0x96, 0xfd, 0xc2, 0xe9, 0xe6, 0xf7, 0xa4, 0xa3, 
	  0xf8, 0xc2, 0x00, 0xad, 0xf5, 0x75, 0x89, 0xa9, 
	  0x02, 0x7d, 0x96, 0x66, 0x09, 0x5b, 0x5d, 0x09, 
	  0x99, 0x63, 0xdc, 0x2a, 0x9e, 0x6f, 0x7a, 0x4a, 
	  0x7f, 0x8c, 0x20, 0x00, 0x0a, 0x0b, 0x04, 0x82, 
	  0xce, 0xa7, 0x9a, 0x04, 0x7d, 0x0c, 0x79, 0xc3, 
	  0x0c, 0xe6, 0x60, 0x52, 0x76, 0x77, 0xac, 0x35, 
	  0x37, 0x9f, 0xcf, 0x34, 0x98, 0xfc, 0x30, 0x80, 
	  0x2c, 0x12, 0x0b, 0x8a, 0x9d, 0x18, 0x03, 0x06, 
	  0x21, 0xe7, 0xf9, 0xa1, 0xee, 0xa0, 0x99, 0xee, 
	  0xff, 0x8f, 0xad, 0xda, 0x70, 0x5d, 0xf5, 0x13, 
	  0xfb, 0xc2, 0x00, 0xad, 0xf0, 0x4f, 0x89, 0x50, 
	  0x6f, 0x01, 0x76, 0x4f, 0x64, 0x97, 0xc8, 0xec, 
	  0x1a, 0x0f, 0x9d, 0x14, 0x20, 0xd2, 0xdd, 0x11, 
	  0xfc, 0xd4, 0x81, 0x2a, 0xa9, 0x31, 0x31, 0x28, 
	  0x46, 0x90, 0x37, 0x9c, 0xd7, 0x67, 0x0c, 0x05, 
	  0x4b, 0x64, 0x91, 0x3c, 0xd8, 0x35, 0xea, 0x68, 
	  0x4e, 0x16, 0x66, 0xb2, 0x82, 0x53, 0xb1, 0xbd, 
	  0xa1, 0x29, 0xc4, 0xfe, 0xf9, 0x5c, 0xe7, 0xcf, 
	  0x84, 0x01, 0x52, 0xd9, 0x4c, 0x4e, 0x84, 0x06, 
	  0x01, 0x12, 0x13, 0xfe, 0xd0, 0xd7, 0xd0, 0x44, 
	  0xf7, 0x9f, 0xcf, 0xde, 0xef, 0x38, 0x26, 0xe8, 
	  0x87, 0xf9, 0x61, 0x00, 0x56, 0xe3, 0x32, 0x44, 
	  0xf3, 0x40, 0xd7, 0xa1, 0xa1, 0x38, 0x61, 0x9a, 
	  0xcc, 0x09, 0x4e, 0xce, 0xf6, 0x86, 0xa7, 0x13, 
	  0xf9, 0xe5, 0x73, 0x1f, 0x3e, 0x10, 0x05, 0x6e, 
	  0x33, 0x4c, 0x4e, 0x8c, 0x06, 0x03, 0x12, 0x13, 
	  0xfc, 0xd0, 0xd7, 0x50, 0x44, 0xf7, 0x7f, 0xcf, 
	  0xd6, 0xef, 0x38, 0x2e, 0xe8, 0x89, 0xf9, 0x61, 
	  0x00, 0x00, 0x0a, 0x0a, 0xd1, 0x86, 0xca, 0xa2, 
	  0x9a, 0x26, 0x81, 0x23, 0x1a, 0x80, 0x61, 0x1f, 
	  0x55, 0x80, 0xb9, 0x5b, 0x80, 0x61, 0xe2, 0x64, 
	  0xff, 0x37, 0x2c, 0xd9, 0x13, 0xe1, 0x0f, 0xe3, 
	  0x5f, 0x99, 0xbd, 0xe0, 0x0b, 0xd4, 0xa0, 0x65, 
	  0x57, 0x01, 0x2d, 0x80, 0x00, 0x1b, 0x6d, 0x00, 
	  0x52, 0x9a, 0x7c, 0xbe, 0xd8, 0x22, 0x5a, 0x61, 
	  0x68, 0x00, 0xa2, 0xef, 0xfd, 0xbe, 0x9c, 0xc2, 
	  0x8f, 0xf3, 0x5e, 0x56, 0x37, 0x8d, 0xe0, 0x0b, 
	  0xc4, 0xa0, 0x65, 0x57, 0x01, 0x2d, 0x80, 0x00, 
	  0x1b, 0x6d, 0x00, 0x52, 0x05, 0x69, 0xd2, 0xc0, 
	  0x4c, 0xd7, 0xf6, 0x0b, 0x43, 0x37, 0xdd, 0x0c, 
	  0xaf, 0xde, 0xb9, 0x80, 0x26, 0x92, 0x07, 0xf8, 
	  0x5d, 0x98, 0x21, 0x79, 0xb8, 0x1b, 0x5b, 0x40, 
	  0x00, 0x00, 0x0a, 0x0b, 0x06, 0x12, 0xc5, 0x24, 
	  0xbb, 0x3d, 0x3d, 0x86, 0x68, 0x25, 0xb6, 0x13, 
	  0xea, 0x49, 0x3e, 0x51, 0xa5, 0x37, 0xb9, 0x19, 
	  0x12, 0x2a, 0x91, 0xe0, 0x4a, 0x9f, 0xe8, 0x3b, 
	  0x31, 0x8a, 0x94, 0xb6, 0x79, 0x43, 0x7c, 0x72, 
	  0x70, 0x00, 0x0a, 0x0b, 0x0d, 0x8a, 0xd4, 0xa4, 
	  0x66, 0xcf, 0xee, 0x97, 0xe5, 0x9b, 0x9f, 0x62, 
	  0xa0, 0xc2, 0x93, 0x60, 0xae, 0x3b, 0x7c, 0x71, 
	  0x91, 0x24, 0xab, 0x06, 0x84, 0xa0, 0xd3, 0xa5, 
	  0x07, 0x12, 0x8a, 0x74, 0x85, 0x7c, 0x9e, 0x3b, 
	  0xdc, 0x93, 0x80, 0x00, 0x0a, 0x0b, 0x09, 0x62, 
	  0xc0, 0xb8, 0xdf, 0x06, 0xd4, 0x92, 0x26, 0x12, 
	  0xb2, 0x83, 0x4a, 0x94, 0x1c, 0x87, 0x80, 0xae, 
	  0x1b, 0xda, 0xd5, 0x0d, 0xed, 0x65, 0x84, 0x8a, 
	  0xa0, 0x78, 0x12, 0xa4, 0xfa, 0x12, 0xdc, 0x81, 
	  0xdb, 0x1d, 0x3c, 0x6f, 0x8c, 0xa0, 0x00, 0x0a, 
	  0x0b, 0x0d, 0x9a, 0xd0, 0x23, 0xb8, 0x32, 0x48, 
	  0xf0, 0x3c, 0x26, 0x6c, 0x24, 0x3e, 0x40, 0x98, 
	  0xe8, 0x4a, 0x02, 0x2a, 0x0b, 0x09, 0xba, 0xff, 
	  0xaa, 0xb3, 0x25, 0x81, 0x6a, 0xff, 0xb8, 0xe3, 
	  0xd8, 0x02, 0x49, 0xc0, 0xa0, 0x89, 0x69, 0x8d, 
	  0x90, 0xd6, 0x5b, 0x2a, 0x00, 0x98, 0x94, 0x1a, 
	  0x34, 0xa0, 0x62, 0x40, 0x5f, 0x8d, 0xfd, 0x55, 
	  0x25, 0x67, 0x18, 0xdf, 0x49, 0x11, 0xe1, 0x50, 
	  0x22, 0x30, 0x41, 0x94, 0xe0, 0x36, 0x68, 0xa6, 
	  0x60, 0x3c, 0x31, 0x02, 0x8d, 0x00, 0x48, 0x24, 
	  0x58, 0x05, 0xb9, 0x95, 0x5f, 0x26, 0x73, 0x65, 
	  0x63, 0x4b, 0xde, 0xc9, 0x7d, 0xdd, 0xbb, 0xf7, 
	  0x08, 0x00, 0x0a, 0x0b, 0x0d, 0x12, 0xf5, 0xa5, 
	  0x6a, 0x00, 0x0d, 0x89, 0x40, 0x59, 0x95, 0xff, 
	  0x8c, 0x50, 0x00, 0x4b, 0x28, 0x08, 0x04, 0xf2, 
	  0x80, 0x50, 0xd8, 0x07, 0x17, 0x60, 0x00, 0x00, 
	  0x0a, 0x0b, 0x05, 0x82, 0xca, 0x25, 0xae, 0x0b, 
	  0xfa, 0xca, 0x01, 0x63, 0x15, 0x0c, 0x04, 0x68, 
	  0x43, 0x3e, 0xf0, 0x5b, 0x3b, 0x97, 0xe5, 0x4b, 
	  0x9f, 0xa5, 0xb4, 0x03, 0xe2, 0xc9, 0xfc, 0xc7, 
	  0xda, 0x50, 0x2e, 0x7a, 0x47, 0xd7, 0xd1, 0x83, 
	  0x97, 0xdd, 0x4b, 0xa0, 0x30, 0x80, 0x00, 0x0a, 
	  0x0b, 0x09, 0x62, 0xce, 0xa6, 0xa5, 0x0a, 0xf7, 
	  0x5a, 0x98, 0x25, 0x6d, 0x6c, 0x26, 0x65, 0xaf, 
	  0x60, 0xaa, 0x89, 0xbe, 0x28, 0xe9, 0x3d, 0xf0, 
	  0x80, 0x00, 0x0a, 0x0b, 0x05, 0xf2, 0xce, 0xa6, 
	  0xa5, 0x0a, 0xf7, 0x5a, 0x98, 0x25, 0x6d, 0x6c, 
	  0x26, 0x65, 0xaf, 0x60, 0xaa, 0x89, 0xbe, 0x28, 
	  0xe9, 0x3d, 0xf0, 0x80, 0x2c, 0x33, 0x4b, 0x3a, 
	  0x9a, 0x94, 0x2b, 0xdd, 0x6a, 0x60, 0x95, 0xb5, 
	  0xb0, 0x99, 0x96, 0xbd, 0x82, 0xaa, 0x26, 0xf8, 
	  0xa3, 0xa4, 0xf7, 0xc2, 0x00, 0x00, 0x0a, 0x0b, 
	  0x09, 0x62, 0xb6, 0x27, 0xa7, 0x84, 0x3d, 0x2a, 
	  0x29, 0xc2, 0xea, 0x65, 0x88, 0x42, 0x75, 0x87, 
	  0xbc, 0x31, 0x5f, 0x9f, 0xd5, 0x57, 0xa7, 0x7c, 
	  0xf0, 0x80, 0x2c, 0x25, 0x8b, 0x28, 0x99, 0xb4, 
	  0x08, 0x2d, 0x8a, 0x6f, 0x56, 0x19, 0x30, 0x39, 
	  0xa4, 0xbf, 0x7d, 0xa7, 0x66, 0x0a, 0xa1, 0x6e, 
	  0xfd, 0xc2, 0x00, 0x00, 0x0a, 0x0a, 0xd0, 0xe0, 
	  0x00, 0xde, 0x00, 0x50, 0x6b, 0x58, 0x02, 0x65, 
	  0xe0, 0x00, 0x23, 0x49, 0xbe, 0x4c, 0x6a, 0xff, 
	  0xe2, 0x90, 0xa0, 0x86, 0x0a, 0x25, 0xc2, 0x0a, 
	  0x8e, 0x89, 0x2d, 0xdb, 0x80, 0x20, 0xbd, 0x96, 
	  0xd8, 0x2f, 0xa9, 0x25, 0xfa, 0x5d, 0x38, 0xf9, 
	  0x4f, 0x90, 0x50, 0x2a, 0x54, 0x62, 0x4f, 0x01, 
	  0x9d, 0x35, 0xfc, 0x07, 0x62, 0x27, 0xfb, 0xe2, 
	  0xef, 0xbf, 0xbd, 0xa0, 0x14, 0x5b, 0x6c, 0x00, 
	  0x00, 0x0a, 0x0b, 0x09, 0x1a, 0xd7, 0xa4, 0x6e, 
	  0x7f, 0x73, 0x97, 0xe5, 0x9b, 0x9f, 0x63, 0xb8, 
	  0x2e, 0x58, 0xee, 0x4b, 0xa7, 0x7c, 0xf1, 0x79, 
	  0x24, 0x6c, 0x0a, 0x74, 0xa0, 0xd3, 0xa5, 0x07, 
	  0x22, 0x20, 0x2b, 0x76, 0xf6, 0x15, 0x10, 0x16, 
	  0x1b, 0x15, 0xaf, 0x48, 0xe4, 0xfe, 0x67, 0x2f, 
	  0xcb, 0x37, 0x3e, 0xc9, 0x70, 0x16, 0x25, 0xbe, 
	  0x78, 0xbc, 0xcb, 0x4d, 0x25, 0xc7, 0x80, 0x8c, 
	  0xa0, 0xd3, 0xa5, 0x07, 0x22, 0x20, 0x2b, 0x76, 
	  0xf6, 0x25, 0x10, 0x00, 0x0a, 0x0a, 0xd9, 0x40, 
	  0x00, 0xdb, 0x44, 0x01, 0x3d, 0x80, 0x8e, 0x06, 
	  0x3a, 0xce, 0x04, 0x38, 0xa5, 0x3f, 0xf0, 0xa0, 
	  0xfc, 0xe8, 0x2f, 0xc8, 0x4f, 0x95, 0x27, 0x92, 
	  0xd1, 0xec, 0x79, 0x05, 0xcd, 0x2d, 0xa2, 0xdb, 
	  0x41, 0x47, 0x41, 0x40, 0x11, 0x50, 0x48, 0x4d, 
	  0x54, 0x06, 0x05, 0x7f, 0x30, 0x0d, 0x6b, 0x8d, 
	  0xfe, 0xb6, 0xd8, 0x80, 0x0a, 0x0a, 0xd2, 0xc4, 
	  0x2c, 0xe2, 0x84, 0x65, 0x12, 0x3b, 0x57, 0xb6, 
	  0x4b, 0xee, 0xed, 0xdf, 0x72, 0x62, 0x0d, 0x67, 
	  0xef, 0x95, 0x2c, 0x37, 0xca, 0xaa, 0x12, 0x57, 
	  0x8e, 0x3f, 0xcb, 0x6c, 0x27, 0xd4, 0x92, 0x7c, 
	  0xbb, 0x88, 0xf1, 0x42, 0x0d, 0xa0, 0x00, 0x0a, 
	  0x0b, 0x11, 0xe3, 0x7e, 0x25, 0x6a, 0x04, 0x0d, 
	  0x88, 0x0c, 0x25, 0x01, 0x66, 0x57, 0xfe, 0xb7, 
	  0x80, 0x00, 0x12, 0xd0, 0x03, 0xe8, 0xfc, 0x40, 
	  0x80, 0x91, 0x81, 0x01, 0x34, 0xa2, 0x0d, 0xad, 
	  0xff, 0xd5, 0x10, 0x00, 0x00, 0x00, 0x0a, 0x0a, 
	  0xd2, 0xc6, 0x84, 0xe2, 0x00, 0x25, 0x9b, 0x64, 
	  0x80, 0x25, 0x94, 0x04, 0x02, 0x79, 0x40, 0x28, 
	  0x6c, 0x03, 0x9a, 0xb2, 0x00, 0x1c, 0x40, 0x0b, 
	  0xd2, 0x5f, 0xf4, 0x2c, 0xfc, 0x96, 0xbf, 0xe0, 
	  0x2d, 0xb7, 0x80, 0x17, 0x9c, 0x65, 0xc0, 0x03, 
	  0x88, 0x01, 0x1a, 0x6f, 0x50, 0x00, 0x35, 0x80, 
	  0x61, 0x28, 0x06, 0x8a, 0x00, 0x4a, 0x9c, 0x08, 
	  0x19, 0x7b, 0xc0, 0x14, 0x09, 0x40, 0xcb, 0xaf, 
	  0xfe, 0x5b, 0x00, 0x00, 0x36, 0xda, 0x00, 0x81, 
	  0xbe, 0xc0, 0x00, 0xe2, 0x00, 0x4b, 0x9c, 0x57, 
	  0xc0, 0x03, 0x78, 0x01, 0xb5, 0x28, 0x06, 0xca, 
	  0x00, 0x4a, 0xa4, 0x07, 0xf9, 0x5c, 0x40, 0x0b, 
	  0x5b, 0x9c, 0xac, 0x00, 0x12, 0xca, 0x02, 0x01, 
	  0x3c, 0xa0, 0x14, 0xb6, 0xff, 0xb5, 0xf8, 0x03, 
	  0x9e, 0xf6, 0x78, 0x1b, 0x6d, 0x80, 0x25, 0x94, 
	  0x04, 0x02, 0x78, 0x81, 0x41, 0x25, 0x0c, 0x7d, 
	  0x80, 0x0d, 0xed, 0x00, 0x04, 0xad, 0x80, 0x00, 
	  0xb1, 0x28, 0x0b, 0x32, 0xbf, 0xeb, 0x98, 0x03, 
	  0x88, 0xa5, 0x6a, 0x71, 0x48, 0x00, 0x00, 0x56, 
	  0x96, 0x31, 0xa7, 0x1b, 0xd8, 0x00, 0xe6, 0x28, 
	  0x2d, 0xe6, 0xd6, 0xa0, 0x0e, 0x60, 0x01, 0x22, 
	  0x00, 0x0a, 0x0a, 0xd6, 0x85, 0xd0, 0xde, 0x86, 
	  0x00, 0x4a, 0xb3, 0xf8, 0x2b, 0xb2, 0xff, 0xb1, 
	  0x4f, 0xe6, 0xb9, 0x40, 0x38, 0x80, 0x15, 0x64, 
	  0xff, 0x1b, 0x35, 0x0f, 0xf1, 0x36, 0x88, 0x0d, 
	  0xf0, 0x94, 0xb5, 0xc5, 0xdc, 0x1d, 0x2d, 0xe1, 
	  0x5f, 0x0b, 0x48, 0x1b, 0x2d, 0x97, 0x13, 0x93, 
	  0x84, 0x28, 0xbf, 0x20, 0xc0, 0xa3, 0xbc, 0xcb, 
	  0xdc, 0x27, 0x40, 0xb3, 0x3d, 0x7f, 0x83, 0x29, 
	  0xed, 0x00, 0x4e, 0x96, 0x07, 0x3a, 0x7f, 0x64, 
	  0xbf, 0xeb, 0x80, 0x9e, 0x04, 0x11, 0xf5, 0x2e, 
	  0xe7, 0x07, 0xa5, 0x58, 0x20, 0x79, 0x59, 0x81, 
	  0x5f, 0xd6, 0x63, 0x8f, 0x44, 0x2d, 0xcd, 0x7e, 
	  0x1d, 0x02, 0xb5, 0xa1, 0x51, 0x24, 0x89, 0x48, 
	  0xcc, 0x9a, 0xdc, 0x7a, 0xc3, 0xfa, 0x68, 0x80, 
	  0x0f, 0x8b, 0x89, 0xc1, 0xd8, 0x95, 0xd7, 0xde, 
	  0x46, 0x00, 0x6c, 0x49, 0x5b, 0x06, 0x46, 0x33, 
	  0x68, 0x03, 0xb0, 0x00, 0x0a, 0x0b, 0x07, 0x32, 
	  0xfc, 0x37, 0xae, 0x00, 0x12, 0xb5, 0x02, 0x06, 
	  0xbc, 0xa0, 0x2c, 0xca, 0xff, 0xc6, 0x2e, 0x00, 
	  0x25, 0x94, 0x04, 0x02, 0x79, 0x40, 0x29, 0x6d, 
	  0xff, 0x7b, 0x28, 0x01, 0xc4, 0x00, 0x71, 0xb8, 
	  0xdf, 0x44, 0xa4, 0xb7, 0x89, 0x82, 0x2b, 0x28, 
	  0x44, 0x47, 0x44, 0x42, 0x83, 0x11, 0xa4, 0x0f, 
	  0xd4, 0x4b, 0xab, 0xbb, 0xdb, 0x98, 0x4e, 0x20, 
	  0x13, 0x39, 0xbe, 0x6c, 0x00, 0x96, 0x50, 0x10, 
	  0x09, 0xe5, 0x00, 0xa1, 0xb0, 0x0e, 0x6e, 0x18, 
	  0x00, 0x71, 0x00, 0x26, 0xc9, 0x7f, 0xca, 0xb2, 
	  0x02, 0x5a, 0xe0, 0x00, 0xb6, 0xe2, 0x00, 0x28, 
	  0x9c, 0xef, 0x20, 0x00, 0xe2, 0x00, 0x48, 0x5c, 
	  0x52, 0xcd, 0x22, 0x54, 0x9b, 0xff, 0x69, 0x97, 
	  0xe5, 0xdb, 0x9e, 0xe3, 0xc0, 0x6a, 0x48, 0xee, 
	  0x3d, 0x0b, 0x8d, 0xfc, 0x50, 0x71, 0xff, 0xa5, 
	  0xc0, 0x00, 0x0a, 0x0a, 0x91, 0xae, 0x6a, 0x74, 
	  0x42, 0x15, 0x6c, 0x01, 0xa4, 0xe5, 0x7d, 0x00, 
	  0x55, 0x78, 0x27, 0xfe, 0x44, 0xef, 0x95, 0x7d, 
	  0xe8, 0xca, 0xa4, 0x88, 0xd5, 0xfe, 0x52, 0xfe, 
	  0xbf, 0x83, 0xec, 0x76, 0x06, 0x4d, 0x1e, 0x4b, 
	  0x66, 0xef, 0xbc, 0x29, 0xa7, 0xb9, 0x5f, 0xaa, 
	  0x40, 0x4a, 0x71, 0xa8, 0x2c, 0xfa, 0xe8, 0x7a, 
	  0x7f, 0xfb, 0x89, 0x0e, 0xb2, 0xdf, 0x76, 0x57, 
	  0xc9, 0x6a, 0xe1, 0x91, 0x28, 0x24, 0x28, 0x01, 
	  0xc4, 0xe0, 0xd9, 0x1a, 0x36, 0xd8, 0xef, 0x43, 
	  0x57, 0x01, 0x52, 0x41, 0x90, 0x4f, 0x95, 0xb3, 
	  0xff, 0xe9, 0x34, 0x04, 0xb1, 0x8a, 0xff, 0xea, 
	  0xce, 0x91, 0xfe, 0x9d, 0xce, 0xbc, 0xee, 0x02, 
	  0xd8, 0x05, 0x6e, 0x42, 0x3f, 0x4e, 0x69, 0x4a, 
	  0x00, 0xd7, 0xd4, 0x7b, 0x2e, 0x95, 0x06, 0x17, 
	  0x4f, 0x6c, 0xff, 0xe2, 0xb1, 0x3c, 0xd2, 0x15, 
	  0x26, 0x00, 0x0a, 0x0a, 0xd5, 0x45, 0xe4, 0xde, 
	  0xa0, 0x00, 0x6b, 0x00, 0xd2, 0x5f, 0xed, 0x94, 
	  0x80, 0x95, 0x38, 0x00, 0x32, 0xb7, 0x80, 0x28, 
	  0x12, 0xff, 0x97, 0x67, 0xfc, 0xb5, 0xc0, 0x01, 
	  0x6d, 0xac, 0x03, 0xcd, 0xf6, 0x00, 0x07, 0x10, 
	  0x02, 0x5c, 0xe2, 0xbe, 0x00, 0x1b, 0xc0, 0x0d, 
	  0xe9, 0x7f, 0xb6, 0x52, 0x02, 0x54, 0xe0, 0x00, 
	  0xca, 0xe2, 0x00, 0x5a, 0x5c, 0xec, 0x50, 0x00, 
	  0xa7, 0x18, 0x01, 0xef, 0xcc, 0x84, 0xa9, 0x03, 
	  0x28, 0x5c, 0xf0, 0x81, 0x9e, 0x6a, 0x38, 0x00, 
	  0x71, 0x00, 0x2f, 0x69, 0x7f, 0xcd, 0xb3, 0xf6, 
	  0x5a, 0xff, 0x40, 0xb9, 0xde, 0x00, 0x5d, 0x71, 
	  0x97, 0x00, 0x0e, 0x20, 0x04, 0x68, 0x0b, 0x09, 
	  0x62, 0xfc, 0x39, 0x80, 0x07, 0x81, 0xb6, 0xe8, 
	  0x02, 0x79, 0x60, 0x07, 0x25, 0x71, 0x9f, 0x2b, 
	  0x7c, 0xff, 0xcd, 0x27, 0x00, 0xcb, 0xcd, 0x77, 
	  0x79, 0xcd, 0x97, 0x46, 0xb0, 0x13, 0x6a, 0x30, 
	  0x00, 0x00, 0x0a, 0x0b, 0x09, 0x6a, 0xe1, 0x28, 
	  0xbb, 0xc1, 0x7f, 0x8d, 0x07, 0xa0, 0x1d, 0x44, 
	  0x51, 0x10, 0x76, 0x84, 0x37, 0xe2, 0x07, 0x6f, 
	  0x4a, 0x3e, 0x6b, 0xce, 0xf0, 0xfa, 0xf0, 0x80, 
	  0x2c, 0x25, 0xab, 0xd4, 0x9d, 0x94, 0x0c, 0x08, 
	  0x31, 0xa7, 0xf6, 0xb1, 0xa7, 0x21, 0x49, 0xe6, 
	  0xfe, 0xdf, 0x5c, 0xd6, 0x70, 0x9c, 0xfd, 0x97, 
	  0xf3, 0xc2, 0x00, 0x00, 0x0a, 0x0a, 0xd4, 0x07, 
	  0x86, 0x9c, 0xce, 0x96, 0x48, 0x81, 0x23, 0x70, 
	  0x1f, 0xd9, 0x93, 0x3d, 0x99, 0x6c, 0xe6, 0x41, 
	  0xcd, 0xfd, 0xe7, 0x97, 0xe5, 0xdb, 0x9e, 0xe2, 
	  0x91, 0xa2, 0x8a, 0x4e, 0x92, 0x69, 0x66, 0x5c, 
	  0x70, 0xb9, 0x2f, 0x16, 0xef, 0xe8, 0xc9, 0xfe, 
	  0xaf, 0x6e, 0xb8, 0xe6, 0x81, 0x3f, 0xf4, 0xff, 
	  0xeb, 0x5f, 0x7b, 0x37, 0x3e, 0xe6, 0x5f, 0x45, 
	  0xfb, 0xcf, 0x66, 0x04, 0xeb, 0x94, 0xb3, 0xef, 
	  0x2b, 0xb6, 0x2f, 0xac, 0xd5, 0x20, 0x12, 0x26, 
	  0x52, 0xc3, 0x38, 0x0d, 0x14, 0x82, 0x3c, 0xe9, 
	  0x50, 0xa0, 0xc4, 0x86, 0xfe, 0xbe, 0x72, 0xac, 
	  0xc6, 0xd7, 0x84, 0xa9, 0x3a, 0x23, 0xff, 0x3a, 
	  0x84, 0x26, 0x0f, 0x4f, 0xed, 0x00, 0x78, 0x9a, 
	  0xa7, 0x96, 0xb7, 0xf6, 0x5a, 0xe0, 0x6a, 0x07, 
	  0x9a, 0x20, 0x52, 0xd4, 0xd2, 0x6a, 0x64, 0x90, 
	  0x06, 0x7a, 0x01, 0x64, 0x4d, 0x16, 0x05, 0x26, 
	  0x64, 0x02, 0x58, 0xae, 0x91, 0xaa, 0x5a, 0x83, 
	  0x58, 0x06, 0x52, 0x80, 0x64, 0x88, 0x24, 0x2c, 
	  0x31, 0x13, 0x83, 0x7c, 0xa6, 0xbb, 0x81, 0xa9, 
	  0xb4, 0x02, 0xf0, 0x15, 0xa3, 0x0e, 0x49, 0x3e, 
	  0x45, 0x23, 0xab, 0x0b, 0x49, 0x60, 0xd6, 0x7f, 
	  0x3c, 0xd3, 0xe7, 0xec, 0xa5, 0xcc, 0x0f, 0x74, 
	  0x63, 0xb1, 0x31, 0xbe, 0x83, 0x6f, 0x1c, 0xaa, 
	  0xfb, 0x27, 0xff, 0x2b, 0x50, 0x6f, 0xc9, 0xc8, 
	  0xa8, 0xca, 0x8d, 0xbc, 0x00, 0xba, 0x05, 0x6a, 
	  0x03, 0x10, 0x50, 0x13, 0x5a, 0x05, 0xa7, 0xf9, 
	  0x33, 0x70, 0x39, 0xc3, 0x7c, 0xe1, 0xe1, 0xb8, 
	  0x41, 0x0b, 0xc6, 0x52, 0x00, 0x80, 0x0a, 0x0a, 
	  0xd4, 0x04, 0xb8, 0xe3, 0x61, 0x00, 0x12, 0xca, 
	  0x02, 0x01, 0x3c, 0xa0, 0x14, 0xb6, 0xff, 0xbd, 
	  0xdc, 0x00, 0xe6, 0x00, 0x15, 0x47, 0x1a, 0xf8, 
	  0x00, 0x96, 0x50, 0x10, 0x09, 0xe5, 0x00, 0xa1, 
	  0xb0, 0x0e, 0x6b, 0x48, 0x00, 0x4a, 0xdc, 0x00, 
	  0x1b, 0x12, 0x80, 0xb3, 0x23, 0xff, 0x1b, 0x00, 
	  0x00, 0xe6, 0x00, 0x28, 0x40, 0x00, 0x0a, 0x0b, 
	  0x0a, 0x02, 0xcf, 0x38, 0xd8, 0x40, 0x04, 0xb2, 
	  0x80, 0x80, 0x4f, 0x28, 0x05, 0x2d, 0xbf, 0xef, 
	  0x77, 0x00, 0x38, 0x80, 0x0f, 0x36, 0xf9, 0x31, 
	  0xea, 0x5b, 0xc4, 0x81, 0x18, 0x94, 0x22, 0x64, 
	  0x41, 0x22, 0x61, 0x4e, 0x90, 0x8f, 0xd0, 0xdb, 
	  0x7a, 0xc3, 0x39, 0xc4, 0x02, 0x78, 0x38, 0xd7, 
	  0xc0, 0x04, 0xb2, 0x80, 0x80, 0x4f, 0x28, 0x05, 
	  0x0d, 0x80, 0x73, 0x5a, 0x80, 0x02, 0x56, 0xa0, 
	  0x00, 0xd9, 0x80, 0x0e, 0x50, 0x16, 0x65, 0x7f, 
	  0xe3, 0x5f, 0x00, 0x1c, 0xc0, 0x05, 0xfe, 0xde, 
	  0xd6, 0xc2, 0x4a, 0x8b, 0x87, 0xec, 0xd2, 0xfc, 
	  0xb9, 0x7b, 0xe4, 0x99, 0x01, 0x61, 0x9b, 0xea, 
	  0x86, 0x6e, 0x7f, 0xfa, 0xf5, 0x00, 0x0a, 0x0a, 
	  0x93, 0x4e, 0xea, 0x66, 0x24, 0xc7, 0x31, 0x39, 
	  0x53, 0x07, 0x52, 0x02, 0x86, 0x93, 0xdb, 0x0a, 
	  0x26, 0x79, 0xff, 0xb5, 0x4c, 0x4d, 0xfb, 0x7a, 
	  0x02, 0xed, 0x22, 0xd7, 0xfd, 0xbc, 0xbf, 0xaf, 
	  0xe4, 0xfb, 0x14, 0x86, 0x14, 0x78, 0x24, 0x5d, 
	  0xbe, 0xf4, 0x84, 0x9f, 0x05, 0x9b, 0xaf, 0x7f, 
	  0x68, 0x96, 0xc2, 0x8f, 0x65, 0x9c, 0x9c, 0x06, 
	  0xa7, 0x39, 0xa0, 0xf7, 0xdf, 0x10, 0xf2, 0x54, 
	  0xa8, 0x46, 0x4a, 0x0d, 0x0a, 0x10, 0x71, 0x28, 
	  0x1f, 0x46, 0x6e, 0x3a, 0x5b, 0xd1, 0x57, 0x80, 
	  0x56, 0xdc, 0xab, 0x74, 0xe5, 0xe3, 0x50, 0x11, 
	  0x15, 0x47, 0xbc, 0xa7, 0xd4, 0xc0, 0xfc, 0xf7, 
	  0xaf, 0xf6, 0x73, 0x61, 0xcd, 0x02, 0x5f, 0x00, 
	  0x54, 0x9e, 0x69, 0xd3, 0xe9, 0x33, 0x5f, 0xcb, 
	  0xc5, 0x01, 0x15, 0x5e, 0xad, 0x7b, 0xb3, 0xa0, 
	  0x80, 0xa6, 0x42, 0x7f, 0x3b, 0xfc, 0x83, 0x80, 
	  0x0a, 0x0b, 0x12, 0x0b, 0x9c, 0x27, 0x00, 0xda, 
	  0xfb, 0xb9, 0xb9, 0xf6, 0xd2, 0xfa, 0x47, 0xde, 
	  0x6a, 0x20, 0x0b, 0x44, 0x89, 0x6f, 0x20, 0xd2, 
	  0xb6, 0x5d, 0xe8, 0x76, 0x34, 0x9f, 0x43, 0x22, 
	  0xa9, 0xfd, 0x28, 0xba, 0x02, 0xcf, 0x89, 0x8e, 
	  0xa0, 0x1f, 0x67, 0x91, 0x90, 0xb2, 0x75, 0x6f, 
	  0xec, 0xbb, 0x17, 0x9c, 0xc8, 0xe4, 0x5f, 0x02, 
	  0xa3, 0x70, 0x1f, 0xd9, 0x93, 0x3d, 0x99, 0x6c, 
	  0xe6, 0x41, 0xcd, 0xfd, 0xe7, 0x97, 0xdd, 0xdb, 
	  0xbe, 0xe2, 0x91, 0xa2, 0x8a, 0x4e, 0x92, 0x69, 
	  0x66, 0x5c, 0x70, 0xb9, 0x2f, 0x16, 0xef, 0xe8, 
	  0xcb, 0x7e, 0x6f, 0x56, 0xbc, 0xe6, 0x81, 0x3f, 
	  0xf0, 0x2b, 0x50, 0x18, 0x82, 0x80, 0xa2, 0xd0, 
	  0x2c, 0xbf, 0xc9, 0x9b, 0xc1, 0xce, 0x5b, 0xe7, 
	  0x0f, 0x0d, 0xc2, 0x08, 0x5e, 0x32, 0x80, 0x04, 
	  0x0a, 0xca, 0x64, 0xec, 0xa0, 0xcf, 0x09, 0xc1, 
	  0x55, 0x3e, 0x8f, 0x9d, 0x46, 0xcd, 0xc2, 0x8a, 
	  0x32, 0xff, 0x67, 0xe7, 0xad, 0x68, 0x06, 0xab, 
	  0x63, 0x3b, 0xd8, 0xc2, 0x00, 0x00, 0x0a, 0x0a, 
	  0x5e, 0x1b, 0x0d, 0xb3, 0x80, 0x12, 0xca, 0x02, 
	  0x01, 0x3c, 0xa0, 0x14, 0x36, 0x01, 0xbd, 0xb8, 
	  0x00, 0x95, 0xb0, 0x00, 0x16, 0x25, 0x01, 0x66, 
	  0x57, 0xfd, 0x76, 0x00, 0x73, 0x00, 0x12, 0x62, 
	  0x70, 0xb5, 0x65, 0x7d, 0xeb, 0x9d, 0x7e, 0x1a, 
	  0x08, 0xb1, 0x27, 0xf6, 0xa5, 0xaa, 0xa1, 0x2c, 
	  0xf6, 0x04, 0xb5, 0x01, 0x7e, 0x4d, 0x28, 0x05, 
	  0x4d, 0x80, 0x67, 0x50, 0x25, 0x56, 0x05, 0x78, 
	  0xe9, 0x94, 0x46, 0x0f, 0xcc, 0x67, 0x3d, 0x19, 
	  0x40, 0xc9, 0xb9, 0xfd, 0xef, 0xea, 0x98, 0x5a, 
	  0x7c, 0x57, 0xe7, 0xe9, 0x6f, 0x97, 0xed, 0x0b, 
	  0x20, 0x25, 0xb4, 0x0b, 0xf2, 0xc9, 0xc2, 0x0d, 
	  0x76, 0x20, 0x4a, 0x83, 0xe7, 0xe7, 0x05, 0x6b, 
	  0x8a, 0x3f, 0xeb, 0xae, 0xde, 0xe2, 0x66, 0x74, 
	  0xb2, 0xfc, 0x88, 0xa3, 0xe9, 0xbb, 0xef, 0x7f, 
	  0x86, 0x8b, 0xe4, 0x1c, 0xf8, 0xcf, 0x0e, 0x60, 
	  0x01, 0xb4, 0x00, 0x00 };

SWFFONT * Font_Courier(U16 id)
{ SWFFONT * f;
  int i;

  if (!(f=malloc(sizeof(SWFFONT)))) return NULL;
  memset(f,0x00,sizeof(SWFFONT));
  f->id       = id;
  f->version  = 2;
  f->name     = strdup("Courier");
  f->style	= 0x00;
  f->encoding = 0x00;
  f->numchars = 148;
  f->maxascii = 256;
  f->glyph    = (SWFGLYPH*)malloc(sizeof(SWFGLYPH)*148);
  f->glyph2ascii = (U16*)malloc(sizeof(U16)*148);
  f->ascii2glyph = (int*)malloc(sizeof(int)*256);
  memset(f->ascii2glyph, -1, sizeof(int)*256);

  f->layout = (SWFLAYOUT*)malloc(sizeof(SWFLAYOUT));
  f->layout->ascent = 137;
  f->layout->descent = 911;
  f->layout->leading = 274;
  f->layout->kerningcount = 0;
  f->layout->kerning = 0;
  f->layout->bounds = (SRECT*)malloc(sizeof(SRECT)*148);
  memset(f->layout->bounds, 0, sizeof(SRECT)*148);

  addGlyph(f,  0, 0x021,  36, &Glyphs_Courier[0x0000],  547, 480, -1236, 720, 30); // !
  addGlyph(f,  1, 0x022,  45, &Glyphs_Courier[0x0045],  393, 292, -1208, 908, -628); // "
  addGlyph(f,  2, 0x023,  50, &Glyphs_Courier[0x0077], 1376, 184, -1294, 1016, 125); // #
  addGlyph(f,  3, 0x024,  49, &Glyphs_Courier[0x0123], 1393, 219, -1320, 980, 180); // $
  addGlyph(f,  4, 0x025,  51, &Glyphs_Courier[0x01d2], 1184, 172, -1220, 1027, 23); // %
  addGlyph(f,  5, 0x026,  47, &Glyphs_Courier[0x0266], 1207, 220, -1040, 956, 32); // &
  addGlyph(f,  6, 0x027,  34, &Glyphs_Courier[0x02fd],  251, 270, -1208, 680, -626); // '
  addGlyph(f,  7, 0x028,  45, &Glyphs_Courier[0x031d],  475, 580, -1208, 916, 250); // (
  addGlyph(f,  8, 0x029,  31, &Glyphs_Courier[0x0359],  471, 294, -1212, 622, 248); // )
  addGlyph(f,  9, 0x02a,  48, &Glyphs_Courier[0x0394],  857, 226, -1208, 975, -499); // *
  addGlyph(f, 10, 0x02b,  52, &Glyphs_Courier[0x0400],  534, 144, -1060, 1056, -64); // +
  addGlyph(f, 11, 0x02c,  34, &Glyphs_Courier[0x0443],  243, 270, -290, 680, 291); // ,
  addGlyph(f, 12, 0x02d,  52, &Glyphs_Courier[0x0462],  254, 144, -600, 1056, -519); // -
  addGlyph(f, 13, 0x02e,  37, &Glyphs_Courier[0x0482],  240, 452, -232, 748, 30); // .
  addGlyph(f, 14, 0x02f,  48, &Glyphs_Courier[0x04a0],  350, 225, -1337, 975, 163); // /
  addGlyph(f, 15, 0x030,  49, &Glyphs_Courier[0x04cc],  691, 220, -1230, 980, 30); // 0
  addGlyph(f, 16, 0x031,  48, &Glyphs_Courier[0x0523],  531, 225, -1224, 974, 0); // 1
  addGlyph(f, 17, 0x032,  49, &Glyphs_Courier[0x0566],  704, 168, -1230, 986, 0); // 2
  addGlyph(f, 18, 0x033,  50, &Glyphs_Courier[0x05be], 1009, 188, -1232, 1000, 30); // 3
  addGlyph(f, 19, 0x034,  47, &Glyphs_Courier[0x063d],  721, 210, -1220, 956, 0); // 4
  addGlyph(f, 20, 0x035,  50, &Glyphs_Courier[0x0698],  842, 190, -1220, 1000, 30); // 5
  addGlyph(f, 21, 0x036,  51, &Glyphs_Courier[0x0702], 1045, 274, -1230, 1020, 30); // 6
  addGlyph(f, 22, 0x037,  48, &Glyphs_Courier[0x0785],  424, 219, -1220, 960, 4); // 7
  addGlyph(f, 23, 0x038,  49, &Glyphs_Courier[0x07ba],  851, 220, -1230, 980, 30); // 8
  addGlyph(f, 24, 0x039,  51, &Glyphs_Courier[0x0825], 1005, 280, -1230, 1022, 29); // 9
  addGlyph(f, 25, 0x03a,  37, &Glyphs_Courier[0x08a3],  467, 452, -840, 748, 30); // :
  addGlyph(f, 26, 0x03b,  35, &Glyphs_Courier[0x08de],  470, 278, -840, 700, 291); // ;
  addGlyph(f, 27, 0x03c,  52, &Glyphs_Courier[0x0919],  420, 144, -1036, 1044, -88); // <
  addGlyph(f, 28, 0x03d,  54, &Glyphs_Courier[0x094e],  499, 102, -740, 1098, -379); // =
  addGlyph(f, 29, 0x03e,  52, &Glyphs_Courier[0x098d],  440, 155, -1036, 1056, -88); // >
  addGlyph(f, 30, 0x03f,  49, &Glyphs_Courier[0x09c4],  889, 259, -1148, 997, 29); // ?
  addGlyph(f, 31, 0x040,  47, &Glyphs_Courier[0x0a34], 1176, 215, -1242, 957, 123); // @
  addGlyph(f, 32, 0x041,  59, &Glyphs_Courier[0x0ac7],  902, 18, -1120, 1182, 0); // A
  addGlyph(f, 33, 0x042,  54, &Glyphs_Courier[0x0b38],  923, 86, -1120, 1080, 0); // B
  addGlyph(f, 34, 0x043,  53, &Glyphs_Courier[0x0bac],  822, 120, -1147, 1070, 31); // C
  addGlyph(f, 35, 0x044,  52, &Glyphs_Courier[0x0c13],  687, 86, -1120, 1040, 0); // D
  addGlyph(f, 36, 0x045,  52, &Glyphs_Courier[0x0c69],  930, 86, -1120, 1040, 0); // E
  addGlyph(f, 37, 0x046,  52, &Glyphs_Courier[0x0cde],  874, 86, -1120, 1041, 0); // F
  addGlyph(f, 38, 0x047,  56, &Glyphs_Courier[0x0d4c], 1093, 120, -1149, 1124, 32); // G
  addGlyph(f, 39, 0x048,  55, &Glyphs_Courier[0x0dd5], 1098, 105, -1120, 1102, 0); // H
  addGlyph(f, 40, 0x049,  48, &Glyphs_Courier[0x0e5f],  544, 226, -1120, 974, 0); // I
  addGlyph(f, 41, 0x04a,  58, &Glyphs_Courier[0x0ea3],  689, 159, -1120, 1166, 32); // J
  addGlyph(f, 42, 0x04b,  57, &Glyphs_Courier[0x0efa], 1133, 86, -1120, 1144, 0); // K
  addGlyph(f, 43, 0x04c,  54, &Glyphs_Courier[0x0f88],  592, 126, -1120, 1080, 0); // L
  addGlyph(f, 44, 0x04d,  59, &Glyphs_Courier[0x0fd2], 1035, 22, -1120, 1186, 0); // M
  addGlyph(f, 45, 0x04e,  56, &Glyphs_Courier[0x1054],  799, 44, -1120, 1124, 0); // N
  addGlyph(f, 46, 0x04f,  55, &Glyphs_Courier[0x10b8],  489, 100, -1146, 1100, 32); // O
  addGlyph(f, 47, 0x050,  50, &Glyphs_Courier[0x10f6],  756, 86, -1120, 1000, 0); // P
  addGlyph(f, 48, 0x051,  55, &Glyphs_Courier[0x1155], 1238, 100, -1146, 1100, 228); // Q
  addGlyph(f, 49, 0x052,  58, &Glyphs_Courier[0x11f0], 1038, 86, -1120, 1178, 0); // R
  addGlyph(f, 50, 0x053,  51, &Glyphs_Courier[0x1272], 1194, 179, -1151, 1020, 31); // S
  addGlyph(f, 51, 0x054,  53, &Glyphs_Courier[0x1308],  650, 140, -1120, 1061, 0); // T
  addGlyph(f, 52, 0x055,  56, &Glyphs_Courier[0x135a],  770, 80, -1121, 1121, 32); // U
  addGlyph(f, 53, 0x056,  59, &Glyphs_Courier[0x13bb],  644, 18, -1121, 1182, 0); // V
  addGlyph(f, 54, 0x057,  58, &Glyphs_Courier[0x140c],  781, 40, -1120, 1160, 0); // W
  addGlyph(f, 55, 0x058,  56, &Glyphs_Courier[0x146e], 1096, 80, -1121, 1120, 0); // X
  addGlyph(f, 56, 0x059,  54, &Glyphs_Courier[0x14f7],  849, 102, -1120, 1098, 0); // Y
  addGlyph(f, 57, 0x05a,  50, &Glyphs_Courier[0x1562],  538, 206, -1120, 1001, 0); // Z
  addGlyph(f, 58, 0x05b,  44, &Glyphs_Courier[0x15a6],  350, 560, -1220, 890, 241); // [
  addGlyph(f, 59, 0x05c,  48, &Glyphs_Courier[0x15d2],  350, 225, -1336, 975, 163); //  
  addGlyph(f, 60, 0x05d,  32, &Glyphs_Courier[0x15fe],  348, 310, -1221, 640, 240); // ]
  addGlyph(f, 61, 0x05e,  48, &Glyphs_Courier[0x162a],  388, 224, -1230, 974, -707); // ^
  addGlyph(f, 62, 0x05f,  61, &Glyphs_Courier[0x165b],  156, -24, 160, 1224, 240); // _
  addGlyph(f, 63, 0x060,  46, &Glyphs_Courier[0x166f],  245, 520, -1208, 930, -684); // `
  addGlyph(f, 64, 0x061,  54, &Glyphs_Courier[0x168e], 1111, 140, -868, 1080, 33); // a
  addGlyph(f, 65, 0x062,  54, &Glyphs_Courier[0x1719],  769, 40, -1220, 1080, 32); // b
  addGlyph(f, 66, 0x063,  53, &Glyphs_Courier[0x177a],  706, 160, -868, 1070, 32); // c
  addGlyph(f, 67, 0x064,  58, &Glyphs_Courier[0x17d3],  811, 120, -1220, 1160, 31); // d
  addGlyph(f, 68, 0x065,  52, &Glyphs_Courier[0x1839],  685, 126, -868, 1044, 32); // e
  addGlyph(f, 69, 0x066,  54, &Glyphs_Courier[0x188f],  973, 210, -1220, 1082, 0); // f
  addGlyph(f, 70, 0x067,  56, &Glyphs_Courier[0x1909],  887, 120, -868, 1122, 381); // g
  addGlyph(f, 71, 0x068,  55, &Glyphs_Courier[0x1978], 1040, 86, -1220, 1102, 0); // h
  addGlyph(f, 72, 0x069,  50, &Glyphs_Courier[0x19fa],  574, 184, -1242, 1016, 0); // i
  addGlyph(f, 73, 0x06a,  46, &Glyphs_Courier[0x1a42],  567, 294, -1242, 920, 381); // j
  addGlyph(f, 74, 0x06b,  54, &Glyphs_Courier[0x1a89],  936, 120, -1220, 1082, 0); // k
  addGlyph(f, 75, 0x06c,  50, &Glyphs_Courier[0x1afe],  449, 184, -1220, 1016, 0); // l
  addGlyph(f, 76, 0x06d,  59, &Glyphs_Courier[0x1b37], 1302, 20, -869, 1186, 0); // m
  addGlyph(f, 77, 0x06e,  54, &Glyphs_Courier[0x1bda], 1053, 105, -869, 1082, 0); // n
  addGlyph(f, 78, 0x06f,  53, &Glyphs_Courier[0x1c5e],  469, 140, -868, 1060, 32); // o
  addGlyph(f, 79, 0x070,  54, &Glyphs_Courier[0x1c99],  904, 40, -872, 1080, 381); // p
  addGlyph(f, 80, 0x071,  58, &Glyphs_Courier[0x1d0a],  876, 120, -868, 1163, 381); // q
  addGlyph(f, 81, 0x072,  54, &Glyphs_Courier[0x1d78],  854, 168, -860, 1084, 0); // r
  addGlyph(f, 82, 0x073,  49, &Glyphs_Courier[0x1de3], 1159, 199, -868, 983, 33); // s
  addGlyph(f, 83, 0x074,  49, &Glyphs_Courier[0x1e74],  798, 85, -1124, 998, 31); // t
  addGlyph(f, 84, 0x075,  54, &Glyphs_Courier[0x1ed8],  723, 86, -840, 1080, 31); // u
  addGlyph(f, 85, 0x076,  57, &Glyphs_Courier[0x1f33],  662, 60, -840, 1140, 0); // v
  addGlyph(f, 86, 0x077,  57, &Glyphs_Courier[0x1f86],  785, 60, -840, 1140, 0); // w
  addGlyph(f, 87, 0x078,  54, &Glyphs_Courier[0x1fe9], 1106, 102, -841, 1098, 0); // x
  addGlyph(f, 88, 0x079,  54, &Glyphs_Courier[0x2074],  826, 102, -840, 1098, 381); // y
  addGlyph(f, 89, 0x07a,  49, &Glyphs_Courier[0x20dc],  498, 230, -840, 980, 0); // z
  addGlyph(f, 90, 0x07b,  40, &Glyphs_Courier[0x211b],  670, 394, -1208, 808, 248); // {
  addGlyph(f, 91, 0x07c,  32, &Glyphs_Courier[0x216f],  246, 560, -1208, 640, 248); // |
  addGlyph(f, 92, 0x07d,  40, &Glyphs_Courier[0x218e],  670, 391, -1208, 806, 248); // }
  addGlyph(f, 93, 0x07e,  50, &Glyphs_Courier[0x21e2],  789, 182, -700, 1016, -419); // ~
  addGlyph(f, 94, 0x0a1,  36, &Glyphs_Courier[0x2245],  549, 480, -840, 720, 432); // 
  addGlyph(f, 95, 0x0a2,  46, &Glyphs_Courier[0x228a], 1039, 220, -1260, 938, 25); // 
  addGlyph(f, 96, 0x0a3,  52, &Glyphs_Courier[0x230c], 1164, 126, -1150, 1040, 0); // 
  addGlyph(f, 97, 0x0a4,  55, &Glyphs_Courier[0x239e],  347, 98, -940, 1101, -276); // 
  addGlyph(f, 98, 0x0a5,  54, &Glyphs_Courier[0x23ca], 1371, 102, -1120, 1098, 0); // 
  addGlyph(f, 99, 0x0a6,  51, &Glyphs_Courier[0x2476], 1078, 174, -1230, 1037, 180); // 
  addGlyph(f,100, 0x0a7,  53, &Glyphs_Courier[0x24fd], 1425, 131, -1200, 1072, 120); // 
  addGlyph(f,101, 0x0a8,  49, &Glyphs_Courier[0x25b0], 1170, 203, -980, 997, -187); // 
  addGlyph(f,102, 0x0a9,  36, &Glyphs_Courier[0x2643],  203, 472, -1208, 728, -628); // 
  addGlyph(f,103, 0x0aa,  50, &Glyphs_Courier[0x265d],  429, 186, -1208, 1014, -684); // 
  addGlyph(f,104, 0x0ab,  54, &Glyphs_Courier[0x2693],  705, 126, -840, 1086, 0); // 
  addGlyph(f,105, 0x0ac,  31, &Glyphs_Courier[0x26ec],  358, 126, -840, 628, 0); // 
  addGlyph(f,106, 0x0ad,  54, &Glyphs_Courier[0x2719],  366, 582, -840, 1082, 0); // 
  addGlyph(f,107, 0x0ae,  58, &Glyphs_Courier[0x2747], 1516, 20, -1242, 1170, 0); // 
  addGlyph(f,108, 0x0af,  58, &Glyphs_Courier[0x2805], 1373, 20, -1220, 1174, 0); // 
  addGlyph(f,109, 0x0b1,  52, &Glyphs_Courier[0x28b1],  254, 144, -600, 1056, -519); // 
  addGlyph(f,110, 0x0b2,  47, &Glyphs_Courier[0x28d1],  598, 248, -1208, 952, 126); // 
  addGlyph(f,111, 0x0b3,  47, &Glyphs_Courier[0x291c],  890, 248, -1208, 952, 124); // 
  addGlyph(f,112, 0x0b4,  37, &Glyphs_Courier[0x298c],  240, 452, -696, 748, -434); // 
  addGlyph(f,113, 0x0b6,  52, &Glyphs_Courier[0x29aa], 1005, 160, -1220, 1050, 121); // 
  addGlyph(f,114, 0x0b7,  39, &Glyphs_Courier[0x2a28],  225, 404, -674, 796, -282); // 
  addGlyph(f,115, 0x0b8,  34, &Glyphs_Courier[0x2a45],  243, 270, -290, 680, 291); // 
  addGlyph(f,116, 0x0b9,  50, &Glyphs_Courier[0x2a64],  423, 186, -290, 1014, 234); // 
  addGlyph(f,117, 0x0ba,  50, &Glyphs_Courier[0x2a99],  429, 186, -1208, 1014, -684); // 
  addGlyph(f,118, 0x0bb,  54, &Glyphs_Courier[0x2acf],  717, 122, -840, 1082, 0); // 
  addGlyph(f,119, 0x0bc,  55, &Glyphs_Courier[0x2b29],  597, 100, -168, 1100, 30); // 
  addGlyph(f,120, 0x0bd,  57, &Glyphs_Courier[0x2b74], 1578, 60, -1222, 1140, 17); // 
  addGlyph(f,121, 0x0bf,  47, &Glyphs_Courier[0x2c3a],  889, 202, -840, 941, 340); // 
  addGlyph(f,122, 0x0c1,  32, &Glyphs_Courier[0x2caa],  317, 308, -1278, 642, -980); // 
  addGlyph(f,123, 0x0c2,  44, &Glyphs_Courier[0x2cd2],  330, 557, -1278, 891, -979); // 
  addGlyph(f,124, 0x0c3,  44, &Glyphs_Courier[0x2cfc],  340, 308, -1278, 893, -980); // 
  addGlyph(f,125, 0x0c4,  45, &Glyphs_Courier[0x2d27],  791, 289, -1220, 915, -1040); // 
  addGlyph(f,126, 0x0c5,  44, &Glyphs_Courier[0x2d8a],  238, 310, -1146, 890, -1066); // 
  addGlyph(f,127, 0x0c6,  44, &Glyphs_Courier[0x2da8],  371, 310, -1240, 890, -980); // 
  addGlyph(f,128, 0x0c7,  35, &Glyphs_Courier[0x2dd7],  211, 500, -1222, 700, -1022); // 
  addGlyph(f,129, 0x0c8,  46, &Glyphs_Courier[0x2df2],  409, 280, -1222, 920, -1022); // 
  addGlyph(f,130, 0x0ca,  40, &Glyphs_Courier[0x2e26],  425, 400, -1320, 800, -960); // 
  addGlyph(f,131, 0x0cb,  38, &Glyphs_Courier[0x2e5c],  552, 417, 0, 760, 340); // 
  addGlyph(f,132, 0x0cd,  44, &Glyphs_Courier[0x2ea1],  596, 305, -1266, 894, -980); // 
  addGlyph(f,133, 0x0ce,  43, &Glyphs_Courier[0x2eec],  448, 554, 0, 866, 301); // 
  addGlyph(f,134, 0x0cf,  44, &Glyphs_Courier[0x2f24],  338, 308, -1278, 893, -980); // 
  addGlyph(f,135, 0x0d0,  59, &Glyphs_Courier[0x2f4f],  308, 2, -600, 1198, -519); // 
  addGlyph(f,136, 0x0e1,  59, &Glyphs_Courier[0x2f76], 1367, 20, -1120, 1180, 0); // 
  addGlyph(f,137, 0x0e3,  45, &Glyphs_Courier[0x3021], 1043, 300, -1142, 900, -559); // 
  addGlyph(f,138, 0x0e8,  54, &Glyphs_Courier[0x30a4], 1002, 84, -1120, 1080, 0); // 
  addGlyph(f,139, 0x0e9,  56, &Glyphs_Courier[0x3122], 1022, 77, -1210, 1121, 86); // 
  addGlyph(f,140, 0x0ea,  59, &Glyphs_Courier[0x31a2], 1083, 20, -1120, 1180, 0); // 
  addGlyph(f,141, 0x0eb,  45, &Glyphs_Courier[0x322a],  457, 300, -1148, 900, -560); // 
  addGlyph(f,142, 0x0f1,  57, &Glyphs_Courier[0x3264], 1808, 20, -868, 1159, 33); // 
  addGlyph(f,143, 0x0f5,  50, &Glyphs_Courier[0x3346],  443, 184, -840, 1016, 0); // 
  addGlyph(f,144, 0x0f8,  50, &Glyphs_Courier[0x337e],  831, 184, -1220, 1016, 0); // 
  addGlyph(f,145, 0x0f9,  54, &Glyphs_Courier[0x33e6], 1040, 104, -916, 1088, 86); // 
  addGlyph(f,146, 0x0fa,  57, &Glyphs_Courier[0x3468], 1193, 20, -868, 1159, 32); // 
  addGlyph(f,147, 0x0fb,  50, &Glyphs_Courier[0x34fe], 1063, 86, -1220, 1000, 31); // 
  return f;
}

#undef addGlyph
